// components/services/storage/public/mojom/file_system_access_context.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_FILE_SYSTEM_ACCESS_CONTEXT_MOJOM_H_
#define COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_FILE_SYSTEM_ACCESS_CONTEXT_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "components/services/storage/public/mojom/file_system_access_context.mojom-shared.h"
#include "components/services/storage/public/mojom/file_system_access_context.mojom-forward.h"
#include "third_party/blink/public/mojom/file_system_access/file_system_access_transfer_token.mojom.h"
#include "url/mojom/origin.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"





// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace storage {
namespace mojom {

class FileSystemAccessContextProxy;

template <typename ImplRefTraits>
class FileSystemAccessContextStub;

class FileSystemAccessContextRequestValidator;
class FileSystemAccessContextResponseValidator;


class  FileSystemAccessContext
    : public FileSystemAccessContextInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = FileSystemAccessContextInterfaceBase;
  using Proxy_ = FileSystemAccessContextProxy;

  template <typename ImplRefTraits>
  using Stub_ = FileSystemAccessContextStub<ImplRefTraits>;

  using RequestValidator_ = FileSystemAccessContextRequestValidator;
  using ResponseValidator_ = FileSystemAccessContextResponseValidator;
  enum MethodMinVersions : uint32_t {
    kSerializeHandleMinVersion = 0,
    kDeserializeHandleMinVersion = 0,
  };
  virtual ~FileSystemAccessContext() {}


  using SerializeHandleCallback = base::OnceCallback<void(const std::vector<uint8_t>&)>;
  
  virtual void SerializeHandle(::mojo::PendingRemote<::blink::mojom::FileSystemAccessTransferToken> token, SerializeHandleCallback callback) = 0;

  
  virtual void DeserializeHandle(const ::url::Origin& origin, const std::vector<uint8_t>& bits, ::mojo::PendingReceiver<::blink::mojom::FileSystemAccessTransferToken> token) = 0;
};



class  FileSystemAccessContextProxy
    : public FileSystemAccessContext {
 public:
  using InterfaceType = FileSystemAccessContext;

  explicit FileSystemAccessContextProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void SerializeHandle(::mojo::PendingRemote<::blink::mojom::FileSystemAccessTransferToken> token, SerializeHandleCallback callback) final;
  
  void DeserializeHandle(const ::url::Origin& origin, const std::vector<uint8_t>& bits, ::mojo::PendingReceiver<::blink::mojom::FileSystemAccessTransferToken> token) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  FileSystemAccessContextStubDispatch {
 public:
  static bool Accept(FileSystemAccessContext* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      FileSystemAccessContext* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<FileSystemAccessContext>>
class FileSystemAccessContextStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  FileSystemAccessContextStub() {}
  ~FileSystemAccessContextStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FileSystemAccessContextStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FileSystemAccessContextStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  FileSystemAccessContextRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  FileSystemAccessContextResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace storage

namespace mojo {

}  // namespace mojo

#endif  // COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_FILE_SYSTEM_ACCESS_CONTEXT_MOJOM_H_