// components/services/storage/public/mojom/filesystem/directory.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "components/services/storage/public/mojom/filesystem/directory.mojom-shared.h"

#include <utility>

#include "base/stl_util.h"  // for base::size()
#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "components/services/storage/public/mojom/filesystem/directory.mojom-params-data.h"
namespace storage {
namespace mojom {

std::string GetEntriesModeToString(GetEntriesMode value) {
  switch(value) {
    case GetEntriesMode::kFilesOnly:
      return "GetEntriesMode::kFilesOnly";
    case GetEntriesMode::kFilesAndDirectories:
      return "GetEntriesMode::kFilesAndDirectories";
    default:
      return base::StringPrintf("Unknown GetEntriesMode value: %i", static_cast<int32_t>(value));
  }
}

std::ostream& operator<<(std::ostream& os, GetEntriesMode value) {
  return os << GetEntriesModeToString(value);
}

std::string FileOpenModeToString(FileOpenMode value) {
  switch(value) {
    case FileOpenMode::kOpenIfExists:
      return "FileOpenMode::kOpenIfExists";
    case FileOpenMode::kCreateAndOpenOnlyIfNotExists:
      return "FileOpenMode::kCreateAndOpenOnlyIfNotExists";
    case FileOpenMode::kAlwaysOpen:
      return "FileOpenMode::kAlwaysOpen";
    case FileOpenMode::kAlwaysCreate:
      return "FileOpenMode::kAlwaysCreate";
    case FileOpenMode::kOpenIfExistsAndTruncate:
      return "FileOpenMode::kOpenIfExistsAndTruncate";
    default:
      return base::StringPrintf("Unknown FileOpenMode value: %i", static_cast<int32_t>(value));
  }
}

std::ostream& operator<<(std::ostream& os, FileOpenMode value) {
  return os << FileOpenModeToString(value);
}

std::string FileReadAccessToString(FileReadAccess value) {
  switch(value) {
    case FileReadAccess::kReadNotAllowed:
      return "FileReadAccess::kReadNotAllowed";
    case FileReadAccess::kReadAllowed:
      return "FileReadAccess::kReadAllowed";
    default:
      return base::StringPrintf("Unknown FileReadAccess value: %i", static_cast<int32_t>(value));
  }
}

std::ostream& operator<<(std::ostream& os, FileReadAccess value) {
  return os << FileReadAccessToString(value);
}

std::string FileWriteAccessToString(FileWriteAccess value) {
  switch(value) {
    case FileWriteAccess::kWriteNotAllowed:
      return "FileWriteAccess::kWriteNotAllowed";
    case FileWriteAccess::kWriteAllowed:
      return "FileWriteAccess::kWriteAllowed";
    case FileWriteAccess::kAppendOnly:
      return "FileWriteAccess::kAppendOnly";
    default:
      return base::StringPrintf("Unknown FileWriteAccess value: %i", static_cast<int32_t>(value));
  }
}

std::ostream& operator<<(std::ostream& os, FileWriteAccess value) {
  return os << FileWriteAccessToString(value);
}

namespace internal {


// static
bool StrictRelativePath_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const StrictRelativePath_Data* object = static_cast<const StrictRelativePath_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->path, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->path, validation_context))
    return false;

  return true;
}

StrictRelativePath_Data::StrictRelativePath_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PathAccessInfo_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PathAccessInfo_Data* object = static_cast<const PathAccessInfo_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

PathAccessInfo_Data::PathAccessInfo_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FileLock_Release_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const FileLock_Release_Params_Data* object = static_cast<const FileLock_Release_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

FileLock_Release_Params_Data::FileLock_Release_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FileLock_Release_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const FileLock_Release_ResponseParams_Data* object = static_cast<const FileLock_Release_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::mojo_base::mojom::internal::FileError_Data
        ::Validate(object->error, validation_context))
    return false;

  return true;
}

FileLock_Release_ResponseParams_Data::FileLock_Release_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_Clone_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_Clone_Params_Data* object = static_cast<const Directory_Clone_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->receiver, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->receiver,
                                                 validation_context)) {
    return false;
  }

  return true;
}

Directory_Clone_Params_Data::Directory_Clone_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_PathExists_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_PathExists_Params_Data* object = static_cast<const Directory_PathExists_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->path, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->path, validation_context))
    return false;

  return true;
}

Directory_PathExists_Params_Data::Directory_PathExists_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_PathExists_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_PathExists_ResponseParams_Data* object = static_cast<const Directory_PathExists_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

Directory_PathExists_ResponseParams_Data::Directory_PathExists_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_GetEntries_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_GetEntries_Params_Data* object = static_cast<const Directory_GetEntries_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->path, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->path, validation_context))
    return false;


  if (!::storage::mojom::internal::GetEntriesMode_Data
        ::Validate(object->mode, validation_context))
    return false;

  return true;
}

Directory_GetEntries_Params_Data::Directory_GetEntries_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_GetEntries_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_GetEntries_ResponseParams_Data* object = static_cast<const Directory_GetEntries_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::mojo_base::mojom::internal::FileError_Data
        ::Validate(object->error, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->entries, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams entries_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->entries, validation_context,
                                         &entries_validate_params)) {
    return false;
  }

  return true;
}

Directory_GetEntries_ResponseParams_Data::Directory_GetEntries_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_OpenFile_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_OpenFile_Params_Data* object = static_cast<const Directory_OpenFile_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->path, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->path, validation_context))
    return false;


  if (!::storage::mojom::internal::FileOpenMode_Data
        ::Validate(object->mode, validation_context))
    return false;


  if (!::storage::mojom::internal::FileReadAccess_Data
        ::Validate(object->read_access, validation_context))
    return false;


  if (!::storage::mojom::internal::FileWriteAccess_Data
        ::Validate(object->write_access, validation_context))
    return false;

  return true;
}

Directory_OpenFile_Params_Data::Directory_OpenFile_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_OpenFile_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_OpenFile_ResponseParams_Data* object = static_cast<const Directory_OpenFile_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::mojo_base::mojom::internal::FileError_Data
        ::Validate(object->error, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->file, validation_context))
    return false;

  return true;
}

Directory_OpenFile_ResponseParams_Data::Directory_OpenFile_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_WriteFileAtomically_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_WriteFileAtomically_Params_Data* object = static_cast<const Directory_WriteFileAtomically_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->path, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->path, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->contents, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->contents, validation_context))
    return false;

  return true;
}

Directory_WriteFileAtomically_Params_Data::Directory_WriteFileAtomically_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_WriteFileAtomically_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_WriteFileAtomically_ResponseParams_Data* object = static_cast<const Directory_WriteFileAtomically_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

Directory_WriteFileAtomically_ResponseParams_Data::Directory_WriteFileAtomically_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_CreateDirectory_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_CreateDirectory_Params_Data* object = static_cast<const Directory_CreateDirectory_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->path, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->path, validation_context))
    return false;

  return true;
}

Directory_CreateDirectory_Params_Data::Directory_CreateDirectory_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_CreateDirectory_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_CreateDirectory_ResponseParams_Data* object = static_cast<const Directory_CreateDirectory_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::mojo_base::mojom::internal::FileError_Data
        ::Validate(object->error, validation_context))
    return false;

  return true;
}

Directory_CreateDirectory_ResponseParams_Data::Directory_CreateDirectory_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_DeleteFile_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_DeleteFile_Params_Data* object = static_cast<const Directory_DeleteFile_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->path, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->path, validation_context))
    return false;

  return true;
}

Directory_DeleteFile_Params_Data::Directory_DeleteFile_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_DeleteFile_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_DeleteFile_ResponseParams_Data* object = static_cast<const Directory_DeleteFile_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

Directory_DeleteFile_ResponseParams_Data::Directory_DeleteFile_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_DeletePathRecursively_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_DeletePathRecursively_Params_Data* object = static_cast<const Directory_DeletePathRecursively_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->path, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->path, validation_context))
    return false;

  return true;
}

Directory_DeletePathRecursively_Params_Data::Directory_DeletePathRecursively_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_DeletePathRecursively_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_DeletePathRecursively_ResponseParams_Data* object = static_cast<const Directory_DeletePathRecursively_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

Directory_DeletePathRecursively_ResponseParams_Data::Directory_DeletePathRecursively_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_GetFileInfo_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_GetFileInfo_Params_Data* object = static_cast<const Directory_GetFileInfo_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->path, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->path, validation_context))
    return false;

  return true;
}

Directory_GetFileInfo_Params_Data::Directory_GetFileInfo_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_GetFileInfo_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_GetFileInfo_ResponseParams_Data* object = static_cast<const Directory_GetFileInfo_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidateStruct(object->info, validation_context))
    return false;

  return true;
}

Directory_GetFileInfo_ResponseParams_Data::Directory_GetFileInfo_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_GetPathAccess_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_GetPathAccess_Params_Data* object = static_cast<const Directory_GetPathAccess_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->path, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->path, validation_context))
    return false;

  return true;
}

Directory_GetPathAccess_Params_Data::Directory_GetPathAccess_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_GetPathAccess_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_GetPathAccess_ResponseParams_Data* object = static_cast<const Directory_GetPathAccess_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidateStruct(object->info, validation_context))
    return false;

  return true;
}

Directory_GetPathAccess_ResponseParams_Data::Directory_GetPathAccess_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_GetMaximumPathComponentLength_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_GetMaximumPathComponentLength_Params_Data* object = static_cast<const Directory_GetMaximumPathComponentLength_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->path, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->path, validation_context))
    return false;

  return true;
}

Directory_GetMaximumPathComponentLength_Params_Data::Directory_GetMaximumPathComponentLength_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_GetMaximumPathComponentLength_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_GetMaximumPathComponentLength_ResponseParams_Data* object = static_cast<const Directory_GetMaximumPathComponentLength_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

Directory_GetMaximumPathComponentLength_ResponseParams_Data::Directory_GetMaximumPathComponentLength_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_RenameFile_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_RenameFile_Params_Data* object = static_cast<const Directory_RenameFile_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->old_path, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->old_path, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->new_path, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->new_path, validation_context))
    return false;

  return true;
}

Directory_RenameFile_Params_Data::Directory_RenameFile_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_RenameFile_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_RenameFile_ResponseParams_Data* object = static_cast<const Directory_RenameFile_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::mojo_base::mojom::internal::FileError_Data
        ::Validate(object->error, validation_context))
    return false;

  return true;
}

Directory_RenameFile_ResponseParams_Data::Directory_RenameFile_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_LockFile_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_LockFile_Params_Data* object = static_cast<const Directory_LockFile_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->path, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->path, validation_context))
    return false;

  return true;
}

Directory_LockFile_Params_Data::Directory_LockFile_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_LockFile_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_LockFile_ResponseParams_Data* object = static_cast<const Directory_LockFile_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::mojo_base::mojom::internal::FileError_Data
        ::Validate(object->error, validation_context))
    return false;

  if (!mojo::internal::ValidateHandleOrInterface(object->lock,
                                                 validation_context)) {
    return false;
  }

  return true;
}

Directory_LockFile_ResponseParams_Data::Directory_LockFile_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_SetOpenedFileLength_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_SetOpenedFileLength_Params_Data* object = static_cast<const Directory_SetOpenedFileLength_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->file, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->file, validation_context))
    return false;

  return true;
}

Directory_SetOpenedFileLength_Params_Data::Directory_SetOpenedFileLength_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Directory_SetOpenedFileLength_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Directory_SetOpenedFileLength_ResponseParams_Data* object = static_cast<const Directory_SetOpenedFileLength_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->file, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->file, validation_context))
    return false;

  return true;
}

Directory_SetOpenedFileLength_ResponseParams_Data::Directory_SetOpenedFileLength_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace storage

namespace perfetto {

// static
void TraceFormatTraits<::storage::mojom::GetEntriesMode>::WriteIntoTracedValue(
   perfetto::TracedValue context, ::storage::mojom::GetEntriesMode value) {
  return std::move(context).WriteString(::storage::mojom::GetEntriesModeToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::storage::mojom::FileOpenMode>::WriteIntoTracedValue(
   perfetto::TracedValue context, ::storage::mojom::FileOpenMode value) {
  return std::move(context).WriteString(::storage::mojom::FileOpenModeToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::storage::mojom::FileReadAccess>::WriteIntoTracedValue(
   perfetto::TracedValue context, ::storage::mojom::FileReadAccess value) {
  return std::move(context).WriteString(::storage::mojom::FileReadAccessToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::storage::mojom::FileWriteAccess>::WriteIntoTracedValue(
   perfetto::TracedValue context, ::storage::mojom::FileWriteAccess value) {
  return std::move(context).WriteString(::storage::mojom::FileWriteAccessToString(value));
}

} // namespace perfetto
