// components/services/storage/public/mojom/indexed_db_control.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_INDEXED_DB_CONTROL_MOJOM_H_
#define COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_INDEXED_DB_CONTROL_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "components/services/storage/public/mojom/indexed_db_control.mojom-shared.h"
#include "components/services/storage/public/mojom/indexed_db_control.mojom-forward.h"
#include "components/services/storage/public/mojom/indexed_db_control_test.mojom.h"
#include "components/services/storage/public/mojom/storage_policy_update.mojom.h"
#include "components/services/storage/public/mojom/storage_usage_info.mojom.h"
#include "mojo/public/mojom/base/file_path.mojom.h"
#include "mojo/public/mojom/base/string16.mojom.h"
#include "mojo/public/mojom/base/values.mojom.h"
#include "mojo/public/mojom/base/time.mojom-forward.h"
#include "third_party/blink/public/mojom/indexeddb/indexeddb.mojom.h"
#include "url/mojom/origin.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"





// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace storage {
namespace mojom {

class IndexedDBObserverProxy;

template <typename ImplRefTraits>
class IndexedDBObserverStub;

class IndexedDBObserverRequestValidator;


class  IndexedDBObserver
    : public IndexedDBObserverInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = IndexedDBObserverInterfaceBase;
  using Proxy_ = IndexedDBObserverProxy;

  template <typename ImplRefTraits>
  using Stub_ = IndexedDBObserverStub<ImplRefTraits>;

  using RequestValidator_ = IndexedDBObserverRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnIndexedDBListChangedMinVersion = 0,
    kOnIndexedDBContentChangedMinVersion = 0,
  };
  virtual ~IndexedDBObserver() {}

  
  virtual void OnIndexedDBListChanged(const ::url::Origin& origin) = 0;

  
  virtual void OnIndexedDBContentChanged(const ::url::Origin& origin, const ::base::string16& database_name, const ::base::string16& object_store_name) = 0;
};

class IndexedDBControlProxy;

template <typename ImplRefTraits>
class IndexedDBControlStub;

class IndexedDBControlRequestValidator;
class IndexedDBControlResponseValidator;


class  IndexedDBControl
    : public IndexedDBControlInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = IndexedDBControlInterfaceBase;
  using Proxy_ = IndexedDBControlProxy;

  template <typename ImplRefTraits>
  using Stub_ = IndexedDBControlStub<ImplRefTraits>;

  using RequestValidator_ = IndexedDBControlRequestValidator;
  using ResponseValidator_ = IndexedDBControlResponseValidator;
  enum MethodMinVersions : uint32_t {
    kBindIndexedDBMinVersion = 0,
    kGetUsageMinVersion = 0,
    kDeleteForOriginMinVersion = 0,
    kForceCloseMinVersion = 0,
    kGetConnectionCountMinVersion = 0,
    kDownloadOriginDataMinVersion = 0,
    kGetAllOriginsDetailsMinVersion = 0,
    kSetForceKeepSessionStateMinVersion = 0,
    kAddObserverMinVersion = 0,
    kApplyPolicyUpdatesMinVersion = 0,
    kBindTestInterfaceMinVersion = 0,
  };
  virtual ~IndexedDBControl() {}

  
  virtual void BindIndexedDB(const ::url::Origin& origin, ::mojo::PendingReceiver<::blink::mojom::IDBFactory> receiver) = 0;


  using GetUsageCallback = base::OnceCallback<void(std::vector<::storage::mojom::StorageUsageInfoPtr>)>;
  
  virtual void GetUsage(GetUsageCallback callback) = 0;


  using DeleteForOriginCallback = base::OnceCallback<void(bool)>;
  
  virtual void DeleteForOrigin(const ::url::Origin& origin, DeleteForOriginCallback callback) = 0;


  using ForceCloseCallback = base::OnceCallback<void()>;
  
  virtual void ForceClose(const ::url::Origin& origin, ForceCloseReason reason, ForceCloseCallback callback) = 0;


  using GetConnectionCountCallback = base::OnceCallback<void(uint64_t)>;
  
  virtual void GetConnectionCount(const ::url::Origin& origin, GetConnectionCountCallback callback) = 0;


  using DownloadOriginDataCallback = base::OnceCallback<void(bool, const ::base::FilePath&, const ::base::FilePath&)>;
  
  virtual void DownloadOriginData(const ::url::Origin& origin, DownloadOriginDataCallback callback) = 0;


  using GetAllOriginsDetailsCallback = base::OnceCallback<void(bool, ::base::Value)>;
  
  virtual void GetAllOriginsDetails(GetAllOriginsDetailsCallback callback) = 0;

  
  virtual void SetForceKeepSessionState() = 0;

  
  virtual void AddObserver(::mojo::PendingRemote<IndexedDBObserver> observer) = 0;

  
  virtual void ApplyPolicyUpdates(std::vector<::storage::mojom::StoragePolicyUpdatePtr> policy_updates) = 0;

  
  virtual void BindTestInterface(::mojo::PendingReceiver<::storage::mojom::IndexedDBControlTest> receiver) = 0;
};



class  IndexedDBObserverProxy
    : public IndexedDBObserver {
 public:
  using InterfaceType = IndexedDBObserver;

  explicit IndexedDBObserverProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnIndexedDBListChanged(const ::url::Origin& origin) final;
  
  void OnIndexedDBContentChanged(const ::url::Origin& origin, const ::base::string16& database_name, const ::base::string16& object_store_name) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  IndexedDBControlProxy
    : public IndexedDBControl {
 public:
  using InterfaceType = IndexedDBControl;

  explicit IndexedDBControlProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void BindIndexedDB(const ::url::Origin& origin, ::mojo::PendingReceiver<::blink::mojom::IDBFactory> receiver) final;
  
  void GetUsage(GetUsageCallback callback) final;
  
  void DeleteForOrigin(const ::url::Origin& origin, DeleteForOriginCallback callback) final;
  
  void ForceClose(const ::url::Origin& origin, ForceCloseReason reason, ForceCloseCallback callback) final;
  
  void GetConnectionCount(const ::url::Origin& origin, GetConnectionCountCallback callback) final;
  
  void DownloadOriginData(const ::url::Origin& origin, DownloadOriginDataCallback callback) final;
  
  void GetAllOriginsDetails(GetAllOriginsDetailsCallback callback) final;
  
  void SetForceKeepSessionState() final;
  
  void AddObserver(::mojo::PendingRemote<IndexedDBObserver> observer) final;
  
  void ApplyPolicyUpdates(std::vector<::storage::mojom::StoragePolicyUpdatePtr> policy_updates) final;
  
  void BindTestInterface(::mojo::PendingReceiver<::storage::mojom::IndexedDBControlTest> receiver) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  IndexedDBObserverStubDispatch {
 public:
  static bool Accept(IndexedDBObserver* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      IndexedDBObserver* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<IndexedDBObserver>>
class IndexedDBObserverStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  IndexedDBObserverStub() {}
  ~IndexedDBObserverStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return IndexedDBObserverStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return IndexedDBObserverStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  IndexedDBControlStubDispatch {
 public:
  static bool Accept(IndexedDBControl* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      IndexedDBControl* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<IndexedDBControl>>
class IndexedDBControlStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  IndexedDBControlStub() {}
  ~IndexedDBControlStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return IndexedDBControlStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return IndexedDBControlStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  IndexedDBObserverRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  IndexedDBControlRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  IndexedDBControlResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace storage

namespace mojo {

}  // namespace mojo

#endif  // COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_INDEXED_DB_CONTROL_MOJOM_H_