// components/services/storage/public/mojom/quota_client.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_QUOTA_CLIENT_MOJOM_H_
#define COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_QUOTA_CLIENT_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "components/services/storage/public/mojom/quota_client.mojom-shared.h"
#include "components/services/storage/public/mojom/quota_client.mojom-forward.h"
#include "third_party/blink/public/mojom/quota/quota_types.mojom-forward.h"
#include "url/mojom/origin.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"





// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace storage {
namespace mojom {

class QuotaClientProxy;

template <typename ImplRefTraits>
class QuotaClientStub;

class QuotaClientRequestValidator;
class QuotaClientResponseValidator;


class  QuotaClient
    : public QuotaClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = QuotaClientInterfaceBase;
  using Proxy_ = QuotaClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = QuotaClientStub<ImplRefTraits>;

  using RequestValidator_ = QuotaClientRequestValidator;
  using ResponseValidator_ = QuotaClientResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetOriginUsageMinVersion = 0,
    kGetOriginsForTypeMinVersion = 0,
    kGetOriginsForHostMinVersion = 0,
    kDeleteOriginDataMinVersion = 0,
    kPerformStorageCleanupMinVersion = 0,
  };
  virtual ~QuotaClient() {}


  using GetOriginUsageCallback = base::OnceCallback<void(int64_t)>;
  
  virtual void GetOriginUsage(const ::url::Origin& origin, ::blink::mojom::StorageType type, GetOriginUsageCallback callback) = 0;


  using GetOriginsForTypeCallback = base::OnceCallback<void(const std::vector<::url::Origin>&)>;
  
  virtual void GetOriginsForType(::blink::mojom::StorageType type, GetOriginsForTypeCallback callback) = 0;


  using GetOriginsForHostCallback = base::OnceCallback<void(const std::vector<::url::Origin>&)>;
  
  virtual void GetOriginsForHost(::blink::mojom::StorageType type, const std::string& host, GetOriginsForHostCallback callback) = 0;


  using DeleteOriginDataCallback = base::OnceCallback<void(::blink::mojom::QuotaStatusCode)>;
  
  virtual void DeleteOriginData(const ::url::Origin& origin, ::blink::mojom::StorageType type, DeleteOriginDataCallback callback) = 0;


  using PerformStorageCleanupCallback = base::OnceCallback<void()>;
  
  virtual void PerformStorageCleanup(::blink::mojom::StorageType type, PerformStorageCleanupCallback callback) = 0;
};



class  QuotaClientProxy
    : public QuotaClient {
 public:
  using InterfaceType = QuotaClient;

  explicit QuotaClientProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetOriginUsage(const ::url::Origin& origin, ::blink::mojom::StorageType type, GetOriginUsageCallback callback) final;
  
  void GetOriginsForType(::blink::mojom::StorageType type, GetOriginsForTypeCallback callback) final;
  
  void GetOriginsForHost(::blink::mojom::StorageType type, const std::string& host, GetOriginsForHostCallback callback) final;
  
  void DeleteOriginData(const ::url::Origin& origin, ::blink::mojom::StorageType type, DeleteOriginDataCallback callback) final;
  
  void PerformStorageCleanup(::blink::mojom::StorageType type, PerformStorageCleanupCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  QuotaClientStubDispatch {
 public:
  static bool Accept(QuotaClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      QuotaClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<QuotaClient>>
class QuotaClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  QuotaClientStub() {}
  ~QuotaClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return QuotaClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return QuotaClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  QuotaClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  QuotaClientResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace storage

namespace mojo {

}  // namespace mojo

#endif  // COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_QUOTA_CLIENT_MOJOM_H_