// content/browser/conversions/conversion_internals.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_BROWSER_CONVERSIONS_CONVERSION_INTERNALS_MOJOM_SHARED_H_
#define CONTENT_BROWSER_CONVERSIONS_CONVERSION_INTERNALS_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"
#include "content/browser/conversions/conversion_internals.mojom-shared-internal.h"
#include "url/mojom/origin.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"






namespace mojom {
class WebUIConversionReportDataView;

class WebUIImpressionDataView;



}  // namespace mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::mojom::WebUIConversionReportDataView> {
  using Data = ::mojom::internal::WebUIConversionReport_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::mojom::WebUIImpressionDataView> {
  using Data = ::mojom::internal::WebUIImpression_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace mojom {
// Interface base classes. They are used for type safety check.
class ConversionInternalsHandlerInterfaceBase {};

using ConversionInternalsHandlerPtrDataView =
    mojo::InterfacePtrDataView<ConversionInternalsHandlerInterfaceBase>;
using ConversionInternalsHandlerRequestDataView =
    mojo::InterfaceRequestDataView<ConversionInternalsHandlerInterfaceBase>;
using ConversionInternalsHandlerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ConversionInternalsHandlerInterfaceBase>;
using ConversionInternalsHandlerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ConversionInternalsHandlerInterfaceBase>;


class WebUIConversionReportDataView {
 public:
  WebUIConversionReportDataView() {}

  WebUIConversionReportDataView(
      internal::WebUIConversionReport_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetImpressionDataDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadImpressionData(UserType* output) {
    
    auto* pointer = data_->impression_data.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetConversionDataDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadConversionData(UserType* output) {
    
    auto* pointer = data_->conversion_data.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetConversionOriginDataView(
      ::url::mojom::OriginDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadConversionOrigin(UserType* output) {
    
    auto* pointer = data_->conversion_origin.Get();
    return mojo::internal::Deserialize<::url::mojom::OriginDataView>(
        pointer, output, message_);
  }
  inline void GetReportingOriginDataView(
      ::url::mojom::OriginDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadReportingOrigin(UserType* output) {
    
    auto* pointer = data_->reporting_origin.Get();
    return mojo::internal::Deserialize<::url::mojom::OriginDataView>(
        pointer, output, message_);
  }
  double report_time() const {
    return data_->report_time;
  }
  int32_t attribution_credit() const {
    return data_->attribution_credit;
  }
 private:
  internal::WebUIConversionReport_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



class WebUIImpressionDataView {
 public:
  WebUIImpressionDataView() {}

  WebUIImpressionDataView(
      internal::WebUIImpression_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetImpressionDataDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadImpressionData(UserType* output) {
    
    auto* pointer = data_->impression_data.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetImpressionOriginDataView(
      ::url::mojom::OriginDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadImpressionOrigin(UserType* output) {
    
    auto* pointer = data_->impression_origin.Get();
    return mojo::internal::Deserialize<::url::mojom::OriginDataView>(
        pointer, output, message_);
  }
  inline void GetConversionDestinationDataView(
      ::url::mojom::OriginDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadConversionDestination(UserType* output) {
    
    auto* pointer = data_->conversion_destination.Get();
    return mojo::internal::Deserialize<::url::mojom::OriginDataView>(
        pointer, output, message_);
  }
  inline void GetReportingOriginDataView(
      ::url::mojom::OriginDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadReportingOrigin(UserType* output) {
    
    auto* pointer = data_->reporting_origin.Get();
    return mojo::internal::Deserialize<::url::mojom::OriginDataView>(
        pointer, output, message_);
  }
  double impression_time() const {
    return data_->impression_time;
  }
  double expiry_time() const {
    return data_->expiry_time;
  }
 private:
  internal::WebUIImpression_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::mojom::WebUIConversionReportDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::mojom::WebUIConversionReportDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::mojom::internal::WebUIConversionReport_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::impression_data(input)) in_impression_data = Traits::impression_data(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->impression_data)::BaseType> impression_data_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_impression_data, impression_data_fragment);
    fragment->impression_data.Set(
        impression_data_fragment.is_null() ? nullptr : impression_data_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->impression_data.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null impression_data in WebUIConversionReport struct");
    decltype(Traits::conversion_data(input)) in_conversion_data = Traits::conversion_data(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->conversion_data)::BaseType> conversion_data_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_conversion_data, conversion_data_fragment);
    fragment->conversion_data.Set(
        conversion_data_fragment.is_null() ? nullptr : conversion_data_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->conversion_data.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null conversion_data in WebUIConversionReport struct");
    decltype(Traits::conversion_origin(input)) in_conversion_origin = Traits::conversion_origin(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->conversion_origin)::BaseType> conversion_origin_fragment(
            fragment.message());
    mojo::internal::Serialize<::url::mojom::OriginDataView>(
        in_conversion_origin, conversion_origin_fragment);
    fragment->conversion_origin.Set(
        conversion_origin_fragment.is_null() ? nullptr : conversion_origin_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->conversion_origin.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null conversion_origin in WebUIConversionReport struct");
    decltype(Traits::reporting_origin(input)) in_reporting_origin = Traits::reporting_origin(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->reporting_origin)::BaseType> reporting_origin_fragment(
            fragment.message());
    mojo::internal::Serialize<::url::mojom::OriginDataView>(
        in_reporting_origin, reporting_origin_fragment);
    fragment->reporting_origin.Set(
        reporting_origin_fragment.is_null() ? nullptr : reporting_origin_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->reporting_origin.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null reporting_origin in WebUIConversionReport struct");
    fragment->report_time = Traits::report_time(input);
    fragment->attribution_credit = Traits::attribution_credit(input);
  }

  static bool Deserialize(::mojom::internal::WebUIConversionReport_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::mojom::WebUIConversionReportDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::mojom::WebUIImpressionDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::mojom::WebUIImpressionDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::mojom::internal::WebUIImpression_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::impression_data(input)) in_impression_data = Traits::impression_data(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->impression_data)::BaseType> impression_data_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_impression_data, impression_data_fragment);
    fragment->impression_data.Set(
        impression_data_fragment.is_null() ? nullptr : impression_data_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->impression_data.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null impression_data in WebUIImpression struct");
    decltype(Traits::impression_origin(input)) in_impression_origin = Traits::impression_origin(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->impression_origin)::BaseType> impression_origin_fragment(
            fragment.message());
    mojo::internal::Serialize<::url::mojom::OriginDataView>(
        in_impression_origin, impression_origin_fragment);
    fragment->impression_origin.Set(
        impression_origin_fragment.is_null() ? nullptr : impression_origin_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->impression_origin.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null impression_origin in WebUIImpression struct");
    decltype(Traits::conversion_destination(input)) in_conversion_destination = Traits::conversion_destination(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->conversion_destination)::BaseType> conversion_destination_fragment(
            fragment.message());
    mojo::internal::Serialize<::url::mojom::OriginDataView>(
        in_conversion_destination, conversion_destination_fragment);
    fragment->conversion_destination.Set(
        conversion_destination_fragment.is_null() ? nullptr : conversion_destination_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->conversion_destination.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null conversion_destination in WebUIImpression struct");
    decltype(Traits::reporting_origin(input)) in_reporting_origin = Traits::reporting_origin(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->reporting_origin)::BaseType> reporting_origin_fragment(
            fragment.message());
    mojo::internal::Serialize<::url::mojom::OriginDataView>(
        in_reporting_origin, reporting_origin_fragment);
    fragment->reporting_origin.Set(
        reporting_origin_fragment.is_null() ? nullptr : reporting_origin_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->reporting_origin.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null reporting_origin in WebUIImpression struct");
    fragment->impression_time = Traits::impression_time(input);
    fragment->expiry_time = Traits::expiry_time(input);
  }

  static bool Deserialize(::mojom::internal::WebUIImpression_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::mojom::WebUIImpressionDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace mojom {

inline void WebUIConversionReportDataView::GetImpressionDataDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->impression_data.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void WebUIConversionReportDataView::GetConversionDataDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->conversion_data.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void WebUIConversionReportDataView::GetConversionOriginDataView(
    ::url::mojom::OriginDataView* output) {
  auto pointer = data_->conversion_origin.Get();
  *output = ::url::mojom::OriginDataView(pointer, message_);
}
inline void WebUIConversionReportDataView::GetReportingOriginDataView(
    ::url::mojom::OriginDataView* output) {
  auto pointer = data_->reporting_origin.Get();
  *output = ::url::mojom::OriginDataView(pointer, message_);
}


inline void WebUIImpressionDataView::GetImpressionDataDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->impression_data.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void WebUIImpressionDataView::GetImpressionOriginDataView(
    ::url::mojom::OriginDataView* output) {
  auto pointer = data_->impression_origin.Get();
  *output = ::url::mojom::OriginDataView(pointer, message_);
}
inline void WebUIImpressionDataView::GetConversionDestinationDataView(
    ::url::mojom::OriginDataView* output) {
  auto pointer = data_->conversion_destination.Get();
  *output = ::url::mojom::OriginDataView(pointer, message_);
}
inline void WebUIImpressionDataView::GetReportingOriginDataView(
    ::url::mojom::OriginDataView* output) {
  auto pointer = data_->reporting_origin.Get();
  *output = ::url::mojom::OriginDataView(pointer, message_);
}



}  // namespace mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // CONTENT_BROWSER_CONVERSIONS_CONVERSION_INTERNALS_MOJOM_SHARED_H_