// content/common/frame_replication_state.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_FRAME_REPLICATION_STATE_MOJOM_SHARED_H_
#define CONTENT_COMMON_FRAME_REPLICATION_STATE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"
#include "content/common/frame_replication_state.mojom-shared-internal.h"
#include "services/network/public/mojom/content_security_policy.mojom-shared.h"
#include "services/network/public/mojom/web_sandbox_flags.mojom-shared.h"
#include "third_party/blink/public/mojom/ad_tagging/ad_frame.mojom-shared.h"
#include "third_party/blink/public/mojom/feature_policy/feature_policy.mojom-shared.h"
#include "third_party/blink/public/mojom/frame/frame_owner_element_type.mojom-shared.h"
#include "third_party/blink/public/mojom/frame/frame_policy.mojom-shared.h"
#include "third_party/blink/public/mojom/frame/tree_scope_type.mojom-shared.h"
#include "third_party/blink/public/mojom/security_context/insecure_request_policy.mojom-shared.h"
#include "url/mojom/origin.mojom-shared.h"



#include "base/component_export.h"




namespace content {
namespace mojom {
class FrameReplicationStateDataView;



}  // namespace mojom
}  // namespace content

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::content::mojom::FrameReplicationStateDataView> {
  using Data = ::content::mojom::internal::FrameReplicationState_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace content {
namespace mojom {


class FrameReplicationStateDataView {
 public:
  FrameReplicationStateDataView() {}

  FrameReplicationStateDataView(
      internal::FrameReplicationState_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetOriginDataView(
      ::url::mojom::OriginDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadOrigin(UserType* output) {
    
    auto* pointer = data_->origin.Get();
    return mojo::internal::Deserialize<::url::mojom::OriginDataView>(
        pointer, output, message_);
  }
  inline void GetNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadName(UserType* output) {
    
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetUniqueNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUniqueName(UserType* output) {
    
    auto* pointer = data_->unique_name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetFeaturePolicyHeaderDataView(
      mojo::ArrayDataView<::blink::mojom::ParsedFeaturePolicyDeclarationDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFeaturePolicyHeader(UserType* output) {
    
    auto* pointer = data_->feature_policy_header.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::ParsedFeaturePolicyDeclarationDataView>>(
        pointer, output, message_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadActiveSandboxFlags(UserType* output) const {
    auto data_value = data_->active_sandbox_flags;
    return mojo::internal::Deserialize<::network::mojom::WebSandboxFlags>(
        data_value, output);
  }
  ::network::mojom::WebSandboxFlags active_sandbox_flags() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::network::mojom::WebSandboxFlags>(data_->active_sandbox_flags));
  }
  inline void GetFramePolicyDataView(
      ::blink::mojom::FramePolicyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFramePolicy(UserType* output) {
    
    auto* pointer = data_->frame_policy.Get();
    return mojo::internal::Deserialize<::blink::mojom::FramePolicyDataView>(
        pointer, output, message_);
  }
  inline void GetAccumulatedCspsDataView(
      mojo::ArrayDataView<::network::mojom::ContentSecurityPolicyDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAccumulatedCsps(UserType* output) {
    
    auto* pointer = data_->accumulated_csps.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::network::mojom::ContentSecurityPolicyDataView>>(
        pointer, output, message_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadScope(UserType* output) const {
    auto data_value = data_->scope;
    return mojo::internal::Deserialize<::blink::mojom::TreeScopeType>(
        data_value, output);
  }
  ::blink::mojom::TreeScopeType scope() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::TreeScopeType>(data_->scope));
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadInsecureRequestPolicy(UserType* output) const {
    auto data_value = data_->insecure_request_policy;
    return mojo::internal::Deserialize<::blink::mojom::InsecureRequestPolicy>(
        data_value, output);
  }
  ::blink::mojom::InsecureRequestPolicy insecure_request_policy() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::InsecureRequestPolicy>(data_->insecure_request_policy));
  }
  inline void GetInsecureNavigationsSetDataView(
      mojo::ArrayDataView<uint32_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadInsecureNavigationsSet(UserType* output) {
    
    auto* pointer = data_->insecure_navigations_set.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint32_t>>(
        pointer, output, message_);
  }
  bool has_potentially_trustworthy_unique_origin() const {
    return data_->has_potentially_trustworthy_unique_origin;
  }
  bool has_active_user_gesture() const {
    return data_->has_active_user_gesture;
  }
  bool has_received_user_gesture_before_nav() const {
    return data_->has_received_user_gesture_before_nav;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFrameOwnerElementType(UserType* output) const {
    auto data_value = data_->frame_owner_element_type;
    return mojo::internal::Deserialize<::blink::mojom::FrameOwnerElementType>(
        data_value, output);
  }
  ::blink::mojom::FrameOwnerElementType frame_owner_element_type() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::FrameOwnerElementType>(data_->frame_owner_element_type));
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAdFrameType(UserType* output) const {
    auto data_value = data_->ad_frame_type;
    return mojo::internal::Deserialize<::blink::mojom::AdFrameType>(
        data_value, output);
  }
  ::blink::mojom::AdFrameType ad_frame_type() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::AdFrameType>(data_->ad_frame_type));
  }
 private:
  internal::FrameReplicationState_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom
}  // namespace content

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::content::mojom::FrameReplicationStateDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::content::mojom::FrameReplicationStateDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::content::mojom::internal::FrameReplicationState_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::origin(input)) in_origin = Traits::origin(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->origin)::BaseType> origin_fragment(
            fragment.message());
    mojo::internal::Serialize<::url::mojom::OriginDataView>(
        in_origin, origin_fragment);
    fragment->origin.Set(
        origin_fragment.is_null() ? nullptr : origin_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->origin.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null origin in FrameReplicationState struct");
    decltype(Traits::name(input)) in_name = Traits::name(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->name)::BaseType> name_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_name, name_fragment);
    fragment->name.Set(
        name_fragment.is_null() ? nullptr : name_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null name in FrameReplicationState struct");
    decltype(Traits::unique_name(input)) in_unique_name = Traits::unique_name(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->unique_name)::BaseType> unique_name_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_unique_name, unique_name_fragment);
    fragment->unique_name.Set(
        unique_name_fragment.is_null() ? nullptr : unique_name_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->unique_name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null unique_name in FrameReplicationState struct");
    decltype(Traits::feature_policy_header(input)) in_feature_policy_header = Traits::feature_policy_header(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->feature_policy_header)::BaseType>
        feature_policy_header_fragment(fragment.message());
    const mojo::internal::ContainerValidateParams feature_policy_header_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::blink::mojom::ParsedFeaturePolicyDeclarationDataView>>(
        in_feature_policy_header, feature_policy_header_fragment, &feature_policy_header_validate_params);
    fragment->feature_policy_header.Set(
        feature_policy_header_fragment.is_null() ? nullptr : feature_policy_header_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->feature_policy_header.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null feature_policy_header in FrameReplicationState struct");
    mojo::internal::Serialize<::network::mojom::WebSandboxFlags>(
        Traits::active_sandbox_flags(input), &fragment->active_sandbox_flags);
    decltype(Traits::frame_policy(input)) in_frame_policy = Traits::frame_policy(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->frame_policy)::BaseType> frame_policy_fragment(
            fragment.message());
    mojo::internal::Serialize<::blink::mojom::FramePolicyDataView>(
        in_frame_policy, frame_policy_fragment);
    fragment->frame_policy.Set(
        frame_policy_fragment.is_null() ? nullptr : frame_policy_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->frame_policy.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null frame_policy in FrameReplicationState struct");
    decltype(Traits::accumulated_csps(input)) in_accumulated_csps = Traits::accumulated_csps(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->accumulated_csps)::BaseType>
        accumulated_csps_fragment(fragment.message());
    const mojo::internal::ContainerValidateParams accumulated_csps_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::network::mojom::ContentSecurityPolicyDataView>>(
        in_accumulated_csps, accumulated_csps_fragment, &accumulated_csps_validate_params);
    fragment->accumulated_csps.Set(
        accumulated_csps_fragment.is_null() ? nullptr : accumulated_csps_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->accumulated_csps.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null accumulated_csps in FrameReplicationState struct");
    mojo::internal::Serialize<::blink::mojom::TreeScopeType>(
        Traits::scope(input), &fragment->scope);
    mojo::internal::Serialize<::blink::mojom::InsecureRequestPolicy>(
        Traits::insecure_request_policy(input), &fragment->insecure_request_policy);
    decltype(Traits::insecure_navigations_set(input)) in_insecure_navigations_set = Traits::insecure_navigations_set(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->insecure_navigations_set)::BaseType>
        insecure_navigations_set_fragment(fragment.message());
    const mojo::internal::ContainerValidateParams insecure_navigations_set_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<uint32_t>>(
        in_insecure_navigations_set, insecure_navigations_set_fragment, &insecure_navigations_set_validate_params);
    fragment->insecure_navigations_set.Set(
        insecure_navigations_set_fragment.is_null() ? nullptr : insecure_navigations_set_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->insecure_navigations_set.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null insecure_navigations_set in FrameReplicationState struct");
    fragment->has_potentially_trustworthy_unique_origin = Traits::has_potentially_trustworthy_unique_origin(input);
    fragment->has_active_user_gesture = Traits::has_active_user_gesture(input);
    fragment->has_received_user_gesture_before_nav = Traits::has_received_user_gesture_before_nav(input);
    mojo::internal::Serialize<::blink::mojom::FrameOwnerElementType>(
        Traits::frame_owner_element_type(input), &fragment->frame_owner_element_type);
    mojo::internal::Serialize<::blink::mojom::AdFrameType>(
        Traits::ad_frame_type(input), &fragment->ad_frame_type);
  }

  static bool Deserialize(::content::mojom::internal::FrameReplicationState_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::content::mojom::FrameReplicationStateDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace content {
namespace mojom {

inline void FrameReplicationStateDataView::GetOriginDataView(
    ::url::mojom::OriginDataView* output) {
  auto pointer = data_->origin.Get();
  *output = ::url::mojom::OriginDataView(pointer, message_);
}
inline void FrameReplicationStateDataView::GetNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->name.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void FrameReplicationStateDataView::GetUniqueNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->unique_name.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void FrameReplicationStateDataView::GetFeaturePolicyHeaderDataView(
    mojo::ArrayDataView<::blink::mojom::ParsedFeaturePolicyDeclarationDataView>* output) {
  auto pointer = data_->feature_policy_header.Get();
  *output = mojo::ArrayDataView<::blink::mojom::ParsedFeaturePolicyDeclarationDataView>(pointer, message_);
}
inline void FrameReplicationStateDataView::GetFramePolicyDataView(
    ::blink::mojom::FramePolicyDataView* output) {
  auto pointer = data_->frame_policy.Get();
  *output = ::blink::mojom::FramePolicyDataView(pointer, message_);
}
inline void FrameReplicationStateDataView::GetAccumulatedCspsDataView(
    mojo::ArrayDataView<::network::mojom::ContentSecurityPolicyDataView>* output) {
  auto pointer = data_->accumulated_csps.Get();
  *output = mojo::ArrayDataView<::network::mojom::ContentSecurityPolicyDataView>(pointer, message_);
}
inline void FrameReplicationStateDataView::GetInsecureNavigationsSetDataView(
    mojo::ArrayDataView<uint32_t>* output) {
  auto pointer = data_->insecure_navigations_set.Get();
  *output = mojo::ArrayDataView<uint32_t>(pointer, message_);
}



}  // namespace mojom
}  // namespace content

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // CONTENT_COMMON_FRAME_REPLICATION_STATE_MOJOM_SHARED_H_