// content/common/frame_replication_state.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_FRAME_REPLICATION_STATE_MOJOM_H_
#define CONTENT_COMMON_FRAME_REPLICATION_STATE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "content/common/frame_replication_state.mojom-shared.h"
#include "content/common/frame_replication_state.mojom-forward.h"
#include "services/network/public/mojom/content_security_policy.mojom.h"
#include "services/network/public/mojom/web_sandbox_flags.mojom-forward.h"
#include "third_party/blink/public/mojom/ad_tagging/ad_frame.mojom-forward.h"
#include "third_party/blink/public/mojom/feature_policy/feature_policy.mojom.h"
#include "third_party/blink/public/mojom/frame/frame_owner_element_type.mojom-forward.h"
#include "third_party/blink/public/mojom/frame/frame_policy.mojom.h"
#include "third_party/blink/public/mojom/frame/tree_scope_type.mojom-forward.h"
#include "third_party/blink/public/mojom/security_context/insecure_request_policy.mojom-forward.h"
#include "url/mojom/origin.mojom.h"
#include <string>
#include <vector>




#include "content/common/content_export.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace content {
namespace mojom {








class CONTENT_EXPORT FrameReplicationState {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FrameReplicationState, T>::value>;
  using DataView = FrameReplicationStateDataView;
  using Data_ = internal::FrameReplicationState_Data;

  template <typename... Args>
  static FrameReplicationStatePtr New(Args&&... args) {
    return FrameReplicationStatePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FrameReplicationStatePtr From(const U& u) {
    return mojo::TypeConverter<FrameReplicationStatePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FrameReplicationState>::Convert(*this);
  }


  FrameReplicationState();

  FrameReplicationState(
      const ::url::Origin& origin,
      const std::string& name,
      const std::string& unique_name,
      std::vector<::blink::ParsedFeaturePolicyDeclaration> feature_policy_header,
      ::network::mojom::WebSandboxFlags active_sandbox_flags,
      const ::blink::FramePolicy& frame_policy,
      std::vector<::network::mojom::ContentSecurityPolicyPtr> accumulated_csps,
      ::blink::mojom::TreeScopeType scope,
      ::blink::mojom::InsecureRequestPolicy insecure_request_policy,
      std::vector<uint32_t> insecure_navigations_set,
      bool has_potentially_trustworthy_unique_origin,
      bool has_active_user_gesture,
      bool has_received_user_gesture_before_nav,
      ::blink::mojom::FrameOwnerElementType frame_owner_element_type,
      ::blink::mojom::AdFrameType ad_frame_type);

  ~FrameReplicationState();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FrameReplicationStatePtr>
  FrameReplicationStatePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FrameReplicationState::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, FrameReplicationState::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FrameReplicationState::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FrameReplicationState::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FrameReplicationState_UnserializedMessageContext<
            UserType, FrameReplicationState::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<FrameReplicationState::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return FrameReplicationState::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FrameReplicationState_UnserializedMessageContext<
            UserType, FrameReplicationState::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FrameReplicationState::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::url::Origin origin;
  
  std::string name;
  
  std::string unique_name;
  
  std::vector<::blink::ParsedFeaturePolicyDeclaration> feature_policy_header;
  
  ::network::mojom::WebSandboxFlags active_sandbox_flags;
  
  ::blink::FramePolicy frame_policy;
  
  std::vector<::network::mojom::ContentSecurityPolicyPtr> accumulated_csps;
  
  ::blink::mojom::TreeScopeType scope;
  
  ::blink::mojom::InsecureRequestPolicy insecure_request_policy;
  
  std::vector<uint32_t> insecure_navigations_set;
  
  bool has_potentially_trustworthy_unique_origin;
  
  bool has_active_user_gesture;
  
  bool has_received_user_gesture_before_nav;
  
  ::blink::mojom::FrameOwnerElementType frame_owner_element_type;
  
  ::blink::mojom::AdFrameType ad_frame_type;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(FrameReplicationState);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FrameReplicationState::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FrameReplicationState::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FrameReplicationState::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FrameReplicationState::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
FrameReplicationStatePtr FrameReplicationState::Clone() const {
  return New(
      mojo::Clone(origin),
      mojo::Clone(name),
      mojo::Clone(unique_name),
      mojo::Clone(feature_policy_header),
      mojo::Clone(active_sandbox_flags),
      mojo::Clone(frame_policy),
      mojo::Clone(accumulated_csps),
      mojo::Clone(scope),
      mojo::Clone(insecure_request_policy),
      mojo::Clone(insecure_navigations_set),
      mojo::Clone(has_potentially_trustworthy_unique_origin),
      mojo::Clone(has_active_user_gesture),
      mojo::Clone(has_received_user_gesture_before_nav),
      mojo::Clone(frame_owner_element_type),
      mojo::Clone(ad_frame_type)
  );
}

template <typename T, FrameReplicationState::EnableIfSame<T>*>
bool FrameReplicationState::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->origin, other_struct.origin))
    return false;
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->unique_name, other_struct.unique_name))
    return false;
  if (!mojo::Equals(this->feature_policy_header, other_struct.feature_policy_header))
    return false;
  if (!mojo::Equals(this->active_sandbox_flags, other_struct.active_sandbox_flags))
    return false;
  if (!mojo::Equals(this->frame_policy, other_struct.frame_policy))
    return false;
  if (!mojo::Equals(this->accumulated_csps, other_struct.accumulated_csps))
    return false;
  if (!mojo::Equals(this->scope, other_struct.scope))
    return false;
  if (!mojo::Equals(this->insecure_request_policy, other_struct.insecure_request_policy))
    return false;
  if (!mojo::Equals(this->insecure_navigations_set, other_struct.insecure_navigations_set))
    return false;
  if (!mojo::Equals(this->has_potentially_trustworthy_unique_origin, other_struct.has_potentially_trustworthy_unique_origin))
    return false;
  if (!mojo::Equals(this->has_active_user_gesture, other_struct.has_active_user_gesture))
    return false;
  if (!mojo::Equals(this->has_received_user_gesture_before_nav, other_struct.has_received_user_gesture_before_nav))
    return false;
  if (!mojo::Equals(this->frame_owner_element_type, other_struct.frame_owner_element_type))
    return false;
  if (!mojo::Equals(this->ad_frame_type, other_struct.ad_frame_type))
    return false;
  return true;
}

template <typename T, FrameReplicationState::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.origin < rhs.origin)
    return true;
  if (rhs.origin < lhs.origin)
    return false;
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.unique_name < rhs.unique_name)
    return true;
  if (rhs.unique_name < lhs.unique_name)
    return false;
  if (lhs.feature_policy_header < rhs.feature_policy_header)
    return true;
  if (rhs.feature_policy_header < lhs.feature_policy_header)
    return false;
  if (lhs.active_sandbox_flags < rhs.active_sandbox_flags)
    return true;
  if (rhs.active_sandbox_flags < lhs.active_sandbox_flags)
    return false;
  if (lhs.frame_policy < rhs.frame_policy)
    return true;
  if (rhs.frame_policy < lhs.frame_policy)
    return false;
  if (lhs.accumulated_csps < rhs.accumulated_csps)
    return true;
  if (rhs.accumulated_csps < lhs.accumulated_csps)
    return false;
  if (lhs.scope < rhs.scope)
    return true;
  if (rhs.scope < lhs.scope)
    return false;
  if (lhs.insecure_request_policy < rhs.insecure_request_policy)
    return true;
  if (rhs.insecure_request_policy < lhs.insecure_request_policy)
    return false;
  if (lhs.insecure_navigations_set < rhs.insecure_navigations_set)
    return true;
  if (rhs.insecure_navigations_set < lhs.insecure_navigations_set)
    return false;
  if (lhs.has_potentially_trustworthy_unique_origin < rhs.has_potentially_trustworthy_unique_origin)
    return true;
  if (rhs.has_potentially_trustworthy_unique_origin < lhs.has_potentially_trustworthy_unique_origin)
    return false;
  if (lhs.has_active_user_gesture < rhs.has_active_user_gesture)
    return true;
  if (rhs.has_active_user_gesture < lhs.has_active_user_gesture)
    return false;
  if (lhs.has_received_user_gesture_before_nav < rhs.has_received_user_gesture_before_nav)
    return true;
  if (rhs.has_received_user_gesture_before_nav < lhs.has_received_user_gesture_before_nav)
    return false;
  if (lhs.frame_owner_element_type < rhs.frame_owner_element_type)
    return true;
  if (rhs.frame_owner_element_type < lhs.frame_owner_element_type)
    return false;
  if (lhs.ad_frame_type < rhs.ad_frame_type)
    return true;
  if (rhs.ad_frame_type < lhs.ad_frame_type)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace content

namespace mojo {


template <>
struct CONTENT_EXPORT StructTraits<::content::mojom::FrameReplicationState::DataView,
                                         ::content::mojom::FrameReplicationStatePtr> {
  static bool IsNull(const ::content::mojom::FrameReplicationStatePtr& input) { return !input; }
  static void SetToNull(::content::mojom::FrameReplicationStatePtr* output) { output->reset(); }

  static const decltype(::content::mojom::FrameReplicationState::origin)& origin(
      const ::content::mojom::FrameReplicationStatePtr& input) {
    return input->origin;
  }

  static const decltype(::content::mojom::FrameReplicationState::name)& name(
      const ::content::mojom::FrameReplicationStatePtr& input) {
    return input->name;
  }

  static const decltype(::content::mojom::FrameReplicationState::unique_name)& unique_name(
      const ::content::mojom::FrameReplicationStatePtr& input) {
    return input->unique_name;
  }

  static const decltype(::content::mojom::FrameReplicationState::feature_policy_header)& feature_policy_header(
      const ::content::mojom::FrameReplicationStatePtr& input) {
    return input->feature_policy_header;
  }

  static decltype(::content::mojom::FrameReplicationState::active_sandbox_flags) active_sandbox_flags(
      const ::content::mojom::FrameReplicationStatePtr& input) {
    return input->active_sandbox_flags;
  }

  static const decltype(::content::mojom::FrameReplicationState::frame_policy)& frame_policy(
      const ::content::mojom::FrameReplicationStatePtr& input) {
    return input->frame_policy;
  }

  static const decltype(::content::mojom::FrameReplicationState::accumulated_csps)& accumulated_csps(
      const ::content::mojom::FrameReplicationStatePtr& input) {
    return input->accumulated_csps;
  }

  static decltype(::content::mojom::FrameReplicationState::scope) scope(
      const ::content::mojom::FrameReplicationStatePtr& input) {
    return input->scope;
  }

  static decltype(::content::mojom::FrameReplicationState::insecure_request_policy) insecure_request_policy(
      const ::content::mojom::FrameReplicationStatePtr& input) {
    return input->insecure_request_policy;
  }

  static const decltype(::content::mojom::FrameReplicationState::insecure_navigations_set)& insecure_navigations_set(
      const ::content::mojom::FrameReplicationStatePtr& input) {
    return input->insecure_navigations_set;
  }

  static decltype(::content::mojom::FrameReplicationState::has_potentially_trustworthy_unique_origin) has_potentially_trustworthy_unique_origin(
      const ::content::mojom::FrameReplicationStatePtr& input) {
    return input->has_potentially_trustworthy_unique_origin;
  }

  static decltype(::content::mojom::FrameReplicationState::has_active_user_gesture) has_active_user_gesture(
      const ::content::mojom::FrameReplicationStatePtr& input) {
    return input->has_active_user_gesture;
  }

  static decltype(::content::mojom::FrameReplicationState::has_received_user_gesture_before_nav) has_received_user_gesture_before_nav(
      const ::content::mojom::FrameReplicationStatePtr& input) {
    return input->has_received_user_gesture_before_nav;
  }

  static decltype(::content::mojom::FrameReplicationState::frame_owner_element_type) frame_owner_element_type(
      const ::content::mojom::FrameReplicationStatePtr& input) {
    return input->frame_owner_element_type;
  }

  static decltype(::content::mojom::FrameReplicationState::ad_frame_type) ad_frame_type(
      const ::content::mojom::FrameReplicationStatePtr& input) {
    return input->ad_frame_type;
  }

  static bool Read(::content::mojom::FrameReplicationState::DataView input, ::content::mojom::FrameReplicationStatePtr* output);
};

}  // namespace mojo

#endif  // CONTENT_COMMON_FRAME_REPLICATION_STATE_MOJOM_H_