// content/common/renderer.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "content/common/renderer.mojom-shared.h"

#include <utility>

#include "base/stl_util.h"  // for base::size()
#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "content/common/renderer.mojom-params-data.h"
namespace content {
namespace mojom {

std::string RenderProcessBackgroundStateToString(RenderProcessBackgroundState value) {
  switch(value) {
    case RenderProcessBackgroundState::kForegrounded:
      return "RenderProcessBackgroundState::kForegrounded";
    case RenderProcessBackgroundState::kBackgrounded:
      return "RenderProcessBackgroundState::kBackgrounded";
    default:
      return base::StringPrintf("Unknown RenderProcessBackgroundState value: %i", static_cast<int32_t>(value));
  }
}

std::ostream& operator<<(std::ostream& os, RenderProcessBackgroundState value) {
  return os << RenderProcessBackgroundStateToString(value);
}

std::string RenderProcessVisibleStateToString(RenderProcessVisibleState value) {
  switch(value) {
    case RenderProcessVisibleState::kVisible:
      return "RenderProcessVisibleState::kVisible";
    case RenderProcessVisibleState::kHidden:
      return "RenderProcessVisibleState::kHidden";
    default:
      return base::StringPrintf("Unknown RenderProcessVisibleState value: %i", static_cast<int32_t>(value));
  }
}

std::ostream& operator<<(std::ostream& os, RenderProcessVisibleState value) {
  return os << RenderProcessVisibleStateToString(value);
}

namespace internal {


// static
bool UpdateScrollbarThemeParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const UpdateScrollbarThemeParams_Data* object = static_cast<const UpdateScrollbarThemeParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::content::mojom::internal::ScrollerStyle_Data
        ::Validate(object->preferred_scroller_style, validation_context))
    return false;

  return true;
}

UpdateScrollbarThemeParams_Data::UpdateScrollbarThemeParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool UpdateSystemColorInfoParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const UpdateSystemColorInfoParams_Data* object = static_cast<const UpdateSystemColorInfoParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->colors, 3, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams colors_validate_params(
      new mojo::internal::ContainerValidateParams(0, ::content::mojom::internal::SystemThemeColor_Data::Validate), new mojo::internal::ContainerValidateParams(0, false, nullptr));
  if (!mojo::internal::ValidateContainer(object->colors, validation_context,
                                         &colors_validate_params)) {
    return false;
  }

  return true;
}

UpdateSystemColorInfoParams_Data::UpdateSystemColorInfoParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_CreateAgentSchedulingGroup_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_CreateAgentSchedulingGroup_Params_Data* object = static_cast<const Renderer_CreateAgentSchedulingGroup_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->bootstrap, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->bootstrap,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->broker_remote, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->broker_remote,
                                                 validation_context)) {
    return false;
  }

  return true;
}

Renderer_CreateAgentSchedulingGroup_Params_Data::Renderer_CreateAgentSchedulingGroup_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_CreateAssociatedAgentSchedulingGroup_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_CreateAssociatedAgentSchedulingGroup_Params_Data* object = static_cast<const Renderer_CreateAssociatedAgentSchedulingGroup_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->agent_scheduling_group, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->agent_scheduling_group,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->broker_remote, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->broker_remote,
                                                 validation_context)) {
    return false;
  }

  return true;
}

Renderer_CreateAssociatedAgentSchedulingGroup_Params_Data::Renderer_CreateAssociatedAgentSchedulingGroup_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_OnNetworkConnectionChanged_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_OnNetworkConnectionChanged_Params_Data* object = static_cast<const Renderer_OnNetworkConnectionChanged_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::content::mojom::internal::NetworkConnectionType_Data
        ::Validate(object->connection_type, validation_context))
    return false;

  return true;
}

Renderer_OnNetworkConnectionChanged_Params_Data::Renderer_OnNetworkConnectionChanged_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_OnNetworkQualityChanged_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 40, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_OnNetworkQualityChanged_Params_Data* object = static_cast<const Renderer_OnNetworkQualityChanged_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::network::mojom::internal::EffectiveConnectionType_Data
        ::Validate(object->effective_connection_type, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->http_rtt, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->http_rtt, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->transport_rtt, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->transport_rtt, validation_context))
    return false;

  return true;
}

Renderer_OnNetworkQualityChanged_Params_Data::Renderer_OnNetworkQualityChanged_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_SetWebKitSharedTimersSuspended_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_SetWebKitSharedTimersSuspended_Params_Data* object = static_cast<const Renderer_SetWebKitSharedTimersSuspended_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

Renderer_SetWebKitSharedTimersSuspended_Params_Data::Renderer_SetWebKitSharedTimersSuspended_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_SetUserAgent_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_SetUserAgent_Params_Data* object = static_cast<const Renderer_SetUserAgent_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->user_agent, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams user_agent_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->user_agent, validation_context,
                                         &user_agent_validate_params)) {
    return false;
  }

  return true;
}

Renderer_SetUserAgent_Params_Data::Renderer_SetUserAgent_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_SetUserAgentMetadata_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_SetUserAgentMetadata_Params_Data* object = static_cast<const Renderer_SetUserAgentMetadata_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->metadata, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->metadata, validation_context))
    return false;

  return true;
}

Renderer_SetUserAgentMetadata_Params_Data::Renderer_SetUserAgentMetadata_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_SetCorsExemptHeaderList_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_SetCorsExemptHeaderList_Params_Data* object = static_cast<const Renderer_SetCorsExemptHeaderList_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->list, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams list_validate_params(
      0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr));
  if (!mojo::internal::ValidateContainer(object->list, validation_context,
                                         &list_validate_params)) {
    return false;
  }

  return true;
}

Renderer_SetCorsExemptHeaderList_Params_Data::Renderer_SetCorsExemptHeaderList_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_UpdateScrollbarTheme_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_UpdateScrollbarTheme_Params_Data* object = static_cast<const Renderer_UpdateScrollbarTheme_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->params, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->params, validation_context))
    return false;

  return true;
}

Renderer_UpdateScrollbarTheme_Params_Data::Renderer_UpdateScrollbarTheme_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_OnSystemColorsChanged_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_OnSystemColorsChanged_Params_Data* object = static_cast<const Renderer_OnSystemColorsChanged_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->highlight_text_color, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams highlight_text_color_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->highlight_text_color, validation_context,
                                         &highlight_text_color_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->highlight_color, 3, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams highlight_color_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->highlight_color, validation_context,
                                         &highlight_color_validate_params)) {
    return false;
  }

  return true;
}

Renderer_OnSystemColorsChanged_Params_Data::Renderer_OnSystemColorsChanged_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_UpdateSystemColorInfo_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_UpdateSystemColorInfo_Params_Data* object = static_cast<const Renderer_UpdateSystemColorInfo_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->params, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->params, validation_context))
    return false;

  return true;
}

Renderer_UpdateSystemColorInfo_Params_Data::Renderer_UpdateSystemColorInfo_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_PurgePluginListCache_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_PurgePluginListCache_Params_Data* object = static_cast<const Renderer_PurgePluginListCache_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

Renderer_PurgePluginListCache_Params_Data::Renderer_PurgePluginListCache_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_SetProcessState_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_SetProcessState_Params_Data* object = static_cast<const Renderer_SetProcessState_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::content::mojom::internal::RenderProcessBackgroundState_Data
        ::Validate(object->background_state, validation_context))
    return false;


  if (!::content::mojom::internal::RenderProcessVisibleState_Data
        ::Validate(object->visible_state, validation_context))
    return false;

  return true;
}

Renderer_SetProcessState_Params_Data::Renderer_SetProcessState_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_SetSchedulerKeepActive_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_SetSchedulerKeepActive_Params_Data* object = static_cast<const Renderer_SetSchedulerKeepActive_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

Renderer_SetSchedulerKeepActive_Params_Data::Renderer_SetSchedulerKeepActive_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_SetIsLockedToSite_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_SetIsLockedToSite_Params_Data* object = static_cast<const Renderer_SetIsLockedToSite_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

Renderer_SetIsLockedToSite_Params_Data::Renderer_SetIsLockedToSite_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Renderer_SetIsCrossOriginIsolated_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Renderer_SetIsCrossOriginIsolated_Params_Data* object = static_cast<const Renderer_SetIsCrossOriginIsolated_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

Renderer_SetIsCrossOriginIsolated_Params_Data::Renderer_SetIsCrossOriginIsolated_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace content

namespace perfetto {

// static
void TraceFormatTraits<::content::mojom::RenderProcessBackgroundState>::WriteIntoTracedValue(
   perfetto::TracedValue context, ::content::mojom::RenderProcessBackgroundState value) {
  return std::move(context).WriteString(::content::mojom::RenderProcessBackgroundStateToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::content::mojom::RenderProcessVisibleState>::WriteIntoTracedValue(
   perfetto::TracedValue context, ::content::mojom::RenderProcessVisibleState value) {
  return std::move(context).WriteString(::content::mojom::RenderProcessVisibleStateToString(value));
}

} // namespace perfetto
