// extensions/common/mojom/renderer.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef EXTENSIONS_COMMON_MOJOM_RENDERER_MOJOM_H_
#define EXTENSIONS_COMMON_MOJOM_RENDERER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "extensions/common/mojom/renderer.mojom-shared.h"
#include "extensions/common/mojom/renderer.mojom-forward.h"
#include "extensions/common/mojom/channel.mojom.h"
#include "extensions/common/mojom/feature_session_type.mojom-forward.h"
#include "extensions/common/mojom/url_pattern_set.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"





// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace extensions {
namespace mojom {

class RendererProxy;

template <typename ImplRefTraits>
class RendererStub;

class RendererRequestValidator;


class  Renderer
    : public RendererInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = RendererInterfaceBase;
  using Proxy_ = RendererProxy;

  template <typename ImplRefTraits>
  using Stub_ = RendererStub<ImplRefTraits>;

  using RequestValidator_ = RendererRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kActivateExtensionMinVersion = 0,
    kSetActivityLoggingEnabledMinVersion = 0,
    kUnloadExtensionMinVersion = 0,
    kSetSessionInfoMinVersion = 0,
    kSetSystemFontMinVersion = 0,
    kSetWebViewPartitionIDMinVersion = 0,
    kSetScriptingAllowlistMinVersion = 0,
    kUpdateDefaultPolicyHostRestrictionsMinVersion = 0,
  };
  virtual ~Renderer() {}

  
  virtual void ActivateExtension(const std::string& extension_id) = 0;

  
  virtual void SetActivityLoggingEnabled(bool enabled) = 0;

  
  virtual void UnloadExtension(const std::string& extension_id) = 0;

  
  virtual void SetSessionInfo(version_info::Channel channel, ::extensions::mojom::FeatureSessionType session, bool is_lock_screen_context) = 0;

  
  virtual void SetSystemFont(const std::string& font_family, const std::string& font_size) = 0;

  
  virtual void SetWebViewPartitionID(const std::string& partition_id) = 0;

  
  virtual void SetScriptingAllowlist(const std::vector<std::string>& extension_ids) = 0;

  
  virtual void UpdateDefaultPolicyHostRestrictions(const ::extensions::URLPatternSet& default_policy_blocked_hosts, const ::extensions::URLPatternSet& default_policy_allowed_hosts) = 0;
};



class  RendererProxy
    : public Renderer {
 public:
  using InterfaceType = Renderer;

  explicit RendererProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void ActivateExtension(const std::string& extension_id) final;
  
  void SetActivityLoggingEnabled(bool enabled) final;
  
  void UnloadExtension(const std::string& extension_id) final;
  
  void SetSessionInfo(version_info::Channel channel, ::extensions::mojom::FeatureSessionType session, bool is_lock_screen_context) final;
  
  void SetSystemFont(const std::string& font_family, const std::string& font_size) final;
  
  void SetWebViewPartitionID(const std::string& partition_id) final;
  
  void SetScriptingAllowlist(const std::vector<std::string>& extension_ids) final;
  
  void UpdateDefaultPolicyHostRestrictions(const ::extensions::URLPatternSet& default_policy_blocked_hosts, const ::extensions::URLPatternSet& default_policy_allowed_hosts) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  RendererStubDispatch {
 public:
  static bool Accept(Renderer* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      Renderer* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<Renderer>>
class RendererStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  RendererStub() {}
  ~RendererStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RendererStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RendererStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  RendererRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace extensions

namespace mojo {

}  // namespace mojo

#endif  // EXTENSIONS_COMMON_MOJOM_RENDERER_MOJOM_H_