// media/mojo/mojom/media_player.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MOJO_MOJOM_MEDIA_PLAYER_MOJOM_H_
#define MEDIA_MOJO_MOJOM_MEDIA_PLAYER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "media/mojo/mojom/media_player.mojom-shared.h"
#include "media/mojo/mojom/media_player.mojom-forward.h"
#include "media/mojo/mojom/media_types.mojom.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "services/media_session/public/mojom/media_session.mojom.h"
#include "ui/gfx/geometry/mojom/geometry.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"





// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace media {
namespace mojom {

class MediaPlayerProxy;

template <typename ImplRefTraits>
class MediaPlayerStub;

class MediaPlayerRequestValidator;


class  MediaPlayer
    : public MediaPlayerInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = true;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = MediaPlayerInterfaceBase;
  using Proxy_ = MediaPlayerProxy;

  template <typename ImplRefTraits>
  using Stub_ = MediaPlayerStub<ImplRefTraits>;

  using RequestValidator_ = MediaPlayerRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kAddMediaPlayerObserverMinVersion = 0,
    kRequestPlayMinVersion = 0,
    kRequestPauseMinVersion = 0,
    kRequestSeekForwardMinVersion = 0,
    kRequestSeekBackwardMinVersion = 0,
    kRequestEnterPictureInPictureMinVersion = 0,
    kRequestExitPictureInPictureMinVersion = 0,
    kSetAudioSinkIdMinVersion = 0,
  };
  virtual ~MediaPlayer() {}

  
  virtual void AddMediaPlayerObserver(::mojo::PendingAssociatedRemote<MediaPlayerObserver> observer) = 0;

  
  virtual void RequestPlay() = 0;

  
  virtual void RequestPause(bool triggered_by_user) = 0;

  
  virtual void RequestSeekForward(::base::TimeDelta seek_time) = 0;

  
  virtual void RequestSeekBackward(::base::TimeDelta seek_time) = 0;

  
  virtual void RequestEnterPictureInPicture() = 0;

  
  virtual void RequestExitPictureInPicture() = 0;

  
  virtual void SetAudioSinkId(const std::string& sink_id) = 0;
};

class MediaPlayerObserverProxy;

template <typename ImplRefTraits>
class MediaPlayerObserverStub;

class MediaPlayerObserverRequestValidator;


class  MediaPlayerObserver
    : public MediaPlayerObserverInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = MediaPlayerObserverInterfaceBase;
  using Proxy_ = MediaPlayerObserverProxy;

  template <typename ImplRefTraits>
  using Stub_ = MediaPlayerObserverStub<ImplRefTraits>;

  using RequestValidator_ = MediaPlayerObserverRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnMediaPlayingMinVersion = 0,
    kOnMediaPausedMinVersion = 0,
    kOnMutedStatusChangedMinVersion = 0,
    kOnMediaMetadataChangedMinVersion = 0,
    kOnMediaPositionStateChangedMinVersion = 0,
    kOnMediaEffectivelyFullscreenChangedMinVersion = 0,
    kOnMediaSizeChangedMinVersion = 0,
    kOnPictureInPictureAvailabilityChangedMinVersion = 0,
    kOnAudioOutputSinkChangedMinVersion = 0,
    kOnAudioOutputSinkChangingDisabledMinVersion = 0,
    kOnBufferUnderflowMinVersion = 0,
    kOnSeekMinVersion = 0,
  };
  virtual ~MediaPlayerObserver() {}

  
  virtual void OnMediaPlaying() = 0;

  
  virtual void OnMediaPaused(bool stream_ended) = 0;

  
  virtual void OnMutedStatusChanged(bool muted) = 0;

  
  virtual void OnMediaMetadataChanged(bool has_audio, bool has_video, ::media::MediaContentType content_type) = 0;

  
  virtual void OnMediaPositionStateChanged(const ::media_session::MediaPosition& media_position) = 0;

  
  virtual void OnMediaEffectivelyFullscreenChanged(::blink::WebFullscreenVideoStatus status) = 0;

  
  virtual void OnMediaSizeChanged(const ::gfx::Size& size) = 0;

  
  virtual void OnPictureInPictureAvailabilityChanged(bool available) = 0;

  
  virtual void OnAudioOutputSinkChanged(const std::string& hashed_device_id) = 0;

  
  virtual void OnAudioOutputSinkChangingDisabled() = 0;

  
  virtual void OnBufferUnderflow() = 0;

  
  virtual void OnSeek() = 0;
};

class MediaPlayerHostProxy;

template <typename ImplRefTraits>
class MediaPlayerHostStub;

class MediaPlayerHostRequestValidator;


class  MediaPlayerHost
    : public MediaPlayerHostInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = true;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = MediaPlayerHostInterfaceBase;
  using Proxy_ = MediaPlayerHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = MediaPlayerHostStub<ImplRefTraits>;

  using RequestValidator_ = MediaPlayerHostRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnMediaPlayerAddedMinVersion = 0,
  };
  virtual ~MediaPlayerHost() {}

  
  virtual void OnMediaPlayerAdded(::mojo::PendingAssociatedRemote<MediaPlayer> player_remote, int32_t player_id) = 0;
};



class  MediaPlayerProxy
    : public MediaPlayer {
 public:
  using InterfaceType = MediaPlayer;

  explicit MediaPlayerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void AddMediaPlayerObserver(::mojo::PendingAssociatedRemote<MediaPlayerObserver> observer) final;
  
  void RequestPlay() final;
  
  void RequestPause(bool triggered_by_user) final;
  
  void RequestSeekForward(::base::TimeDelta seek_time) final;
  
  void RequestSeekBackward(::base::TimeDelta seek_time) final;
  
  void RequestEnterPictureInPicture() final;
  
  void RequestExitPictureInPicture() final;
  
  void SetAudioSinkId(const std::string& sink_id) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  MediaPlayerObserverProxy
    : public MediaPlayerObserver {
 public:
  using InterfaceType = MediaPlayerObserver;

  explicit MediaPlayerObserverProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnMediaPlaying() final;
  
  void OnMediaPaused(bool stream_ended) final;
  
  void OnMutedStatusChanged(bool muted) final;
  
  void OnMediaMetadataChanged(bool has_audio, bool has_video, ::media::MediaContentType content_type) final;
  
  void OnMediaPositionStateChanged(const ::media_session::MediaPosition& media_position) final;
  
  void OnMediaEffectivelyFullscreenChanged(::blink::WebFullscreenVideoStatus status) final;
  
  void OnMediaSizeChanged(const ::gfx::Size& size) final;
  
  void OnPictureInPictureAvailabilityChanged(bool available) final;
  
  void OnAudioOutputSinkChanged(const std::string& hashed_device_id) final;
  
  void OnAudioOutputSinkChangingDisabled() final;
  
  void OnBufferUnderflow() final;
  
  void OnSeek() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  MediaPlayerHostProxy
    : public MediaPlayerHost {
 public:
  using InterfaceType = MediaPlayerHost;

  explicit MediaPlayerHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnMediaPlayerAdded(::mojo::PendingAssociatedRemote<MediaPlayer> player_remote, int32_t player_id) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  MediaPlayerStubDispatch {
 public:
  static bool Accept(MediaPlayer* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      MediaPlayer* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<MediaPlayer>>
class MediaPlayerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  MediaPlayerStub() {}
  ~MediaPlayerStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaPlayerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaPlayerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  MediaPlayerObserverStubDispatch {
 public:
  static bool Accept(MediaPlayerObserver* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      MediaPlayerObserver* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<MediaPlayerObserver>>
class MediaPlayerObserverStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  MediaPlayerObserverStub() {}
  ~MediaPlayerObserverStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaPlayerObserverStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaPlayerObserverStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  MediaPlayerHostStubDispatch {
 public:
  static bool Accept(MediaPlayerHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      MediaPlayerHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<MediaPlayerHost>>
class MediaPlayerHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  MediaPlayerHostStub() {}
  ~MediaPlayerHostStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaPlayerHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaPlayerHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  MediaPlayerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  MediaPlayerObserverRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  MediaPlayerHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace media

namespace mojo {

}  // namespace mojo

#endif  // MEDIA_MOJO_MOJOM_MEDIA_PLAYER_MOJOM_H_