// services/network/public/mojom/parsed_headers.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_PARSED_HEADERS_MOJOM_SHARED_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_PARSED_HEADERS_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"
#include "services/network/public/mojom/parsed_headers.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"
#include "services/network/public/mojom/content_security_policy.mojom-shared.h"
#include "services/network/public/mojom/cross_origin_embedder_policy.mojom-shared.h"
#include "services/network/public/mojom/cross_origin_opener_policy.mojom-shared.h"
#include "services/network/public/mojom/web_client_hints_types.mojom-shared.h"
#include "services/network/public/mojom/x_frame_options.mojom-shared.h"







namespace network {
namespace mojom {
class ParsedHeadersDataView;



}  // namespace mojom
}  // namespace network

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::network::mojom::ParsedHeadersDataView> {
  using Data = ::network::mojom::internal::ParsedHeaders_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace network {
namespace mojom {


class ParsedHeadersDataView {
 public:
  ParsedHeadersDataView() {}

  ParsedHeadersDataView(
      internal::ParsedHeaders_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetContentSecurityPolicyDataView(
      mojo::ArrayDataView<::network::mojom::ContentSecurityPolicyDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadContentSecurityPolicy(UserType* output) {
    
    auto* pointer = data_->content_security_policy.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::network::mojom::ContentSecurityPolicyDataView>>(
        pointer, output, message_);
  }
  inline void GetAllowCspFromDataView(
      ::network::mojom::AllowCSPFromHeaderValueDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAllowCspFrom(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::network::mojom::AllowCSPFromHeaderValueDataView, UserType>(),
    "Attempting to read the optional `allow_csp_from` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with base::Optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadAllowCspFrom` instead "
    "of `ReadAllowCspFrom if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = !data_->allow_csp_from.is_null() ? &data_->allow_csp_from : nullptr;
    return mojo::internal::Deserialize<::network::mojom::AllowCSPFromHeaderValueDataView>(
        pointer, output, message_);
  }
  inline void GetCrossOriginEmbedderPolicyDataView(
      ::network::mojom::CrossOriginEmbedderPolicyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCrossOriginEmbedderPolicy(UserType* output) {
    
    auto* pointer = data_->cross_origin_embedder_policy.Get();
    return mojo::internal::Deserialize<::network::mojom::CrossOriginEmbedderPolicyDataView>(
        pointer, output, message_);
  }
  inline void GetCrossOriginOpenerPolicyDataView(
      ::network::mojom::CrossOriginOpenerPolicyDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCrossOriginOpenerPolicy(UserType* output) {
    
    auto* pointer = data_->cross_origin_opener_policy.Get();
    return mojo::internal::Deserialize<::network::mojom::CrossOriginOpenerPolicyDataView>(
        pointer, output, message_);
  }
  bool origin_agent_cluster() const {
    return data_->origin_agent_cluster;
  }
  inline void GetAcceptChDataView(
      mojo::ArrayDataView<::network::mojom::WebClientHintsType>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAcceptCh(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        mojo::ArrayDataView<::network::mojom::WebClientHintsType>, UserType>(),
    "Attempting to read the optional `accept_ch` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with base::Optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadAcceptCh` instead "
    "of `ReadAcceptCh if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->accept_ch.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::network::mojom::WebClientHintsType>>(
        pointer, output, message_);
  }
  inline void GetAcceptChLifetimeDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAcceptChLifetime(UserType* output) {
    
    auto* pointer = data_->accept_ch_lifetime.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, message_);
  }
  inline void GetCriticalChDataView(
      mojo::ArrayDataView<::network::mojom::WebClientHintsType>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCriticalCh(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        mojo::ArrayDataView<::network::mojom::WebClientHintsType>, UserType>(),
    "Attempting to read the optional `critical_ch` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with base::Optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadCriticalCh` instead "
    "of `ReadCriticalCh if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->critical_ch.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::network::mojom::WebClientHintsType>>(
        pointer, output, message_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadXfo(UserType* output) const {
    auto data_value = data_->xfo;
    return mojo::internal::Deserialize<::network::mojom::XFrameOptionsValue>(
        data_value, output);
  }
  ::network::mojom::XFrameOptionsValue xfo() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::network::mojom::XFrameOptionsValue>(data_->xfo));
  }
 private:
  internal::ParsedHeaders_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom
}  // namespace network

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::ParsedHeadersDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::network::mojom::ParsedHeadersDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::network::mojom::internal::ParsedHeaders_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::content_security_policy(input)) in_content_security_policy = Traits::content_security_policy(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->content_security_policy)::BaseType>
        content_security_policy_fragment(fragment.message());
    const mojo::internal::ContainerValidateParams content_security_policy_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::network::mojom::ContentSecurityPolicyDataView>>(
        in_content_security_policy, content_security_policy_fragment, &content_security_policy_validate_params);
    fragment->content_security_policy.Set(
        content_security_policy_fragment.is_null() ? nullptr : content_security_policy_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->content_security_policy.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null content_security_policy in ParsedHeaders struct");
    decltype(Traits::allow_csp_from(input)) in_allow_csp_from = Traits::allow_csp_from(input);
    mojo::internal::MessageFragment<decltype(fragment->allow_csp_from)>
        allow_csp_from_fragment(fragment.message());
    allow_csp_from_fragment.Claim(&fragment->allow_csp_from);
    mojo::internal::Serialize<::network::mojom::AllowCSPFromHeaderValueDataView>(
        in_allow_csp_from, allow_csp_from_fragment, true);
    decltype(Traits::cross_origin_embedder_policy(input)) in_cross_origin_embedder_policy = Traits::cross_origin_embedder_policy(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->cross_origin_embedder_policy)::BaseType> cross_origin_embedder_policy_fragment(
            fragment.message());
    mojo::internal::Serialize<::network::mojom::CrossOriginEmbedderPolicyDataView>(
        in_cross_origin_embedder_policy, cross_origin_embedder_policy_fragment);
    fragment->cross_origin_embedder_policy.Set(
        cross_origin_embedder_policy_fragment.is_null() ? nullptr : cross_origin_embedder_policy_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->cross_origin_embedder_policy.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null cross_origin_embedder_policy in ParsedHeaders struct");
    decltype(Traits::cross_origin_opener_policy(input)) in_cross_origin_opener_policy = Traits::cross_origin_opener_policy(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->cross_origin_opener_policy)::BaseType> cross_origin_opener_policy_fragment(
            fragment.message());
    mojo::internal::Serialize<::network::mojom::CrossOriginOpenerPolicyDataView>(
        in_cross_origin_opener_policy, cross_origin_opener_policy_fragment);
    fragment->cross_origin_opener_policy.Set(
        cross_origin_opener_policy_fragment.is_null() ? nullptr : cross_origin_opener_policy_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->cross_origin_opener_policy.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null cross_origin_opener_policy in ParsedHeaders struct");
    fragment->origin_agent_cluster = Traits::origin_agent_cluster(input);
    decltype(Traits::accept_ch(input)) in_accept_ch = Traits::accept_ch(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->accept_ch)::BaseType>
        accept_ch_fragment(fragment.message());
    const mojo::internal::ContainerValidateParams accept_ch_validate_params(
        0, ::network::mojom::internal::WebClientHintsType_Data::Validate);
    mojo::internal::Serialize<mojo::ArrayDataView<::network::mojom::WebClientHintsType>>(
        in_accept_ch, accept_ch_fragment, &accept_ch_validate_params);
    fragment->accept_ch.Set(
        accept_ch_fragment.is_null() ? nullptr : accept_ch_fragment.data());
    decltype(Traits::accept_ch_lifetime(input)) in_accept_ch_lifetime = Traits::accept_ch_lifetime(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->accept_ch_lifetime)::BaseType> accept_ch_lifetime_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::TimeDeltaDataView>(
        in_accept_ch_lifetime, accept_ch_lifetime_fragment);
    fragment->accept_ch_lifetime.Set(
        accept_ch_lifetime_fragment.is_null() ? nullptr : accept_ch_lifetime_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->accept_ch_lifetime.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null accept_ch_lifetime in ParsedHeaders struct");
    decltype(Traits::critical_ch(input)) in_critical_ch = Traits::critical_ch(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->critical_ch)::BaseType>
        critical_ch_fragment(fragment.message());
    const mojo::internal::ContainerValidateParams critical_ch_validate_params(
        0, ::network::mojom::internal::WebClientHintsType_Data::Validate);
    mojo::internal::Serialize<mojo::ArrayDataView<::network::mojom::WebClientHintsType>>(
        in_critical_ch, critical_ch_fragment, &critical_ch_validate_params);
    fragment->critical_ch.Set(
        critical_ch_fragment.is_null() ? nullptr : critical_ch_fragment.data());
    mojo::internal::Serialize<::network::mojom::XFrameOptionsValue>(
        Traits::xfo(input), &fragment->xfo);
  }

  static bool Deserialize(::network::mojom::internal::ParsedHeaders_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::network::mojom::ParsedHeadersDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace network {
namespace mojom {

inline void ParsedHeadersDataView::GetContentSecurityPolicyDataView(
    mojo::ArrayDataView<::network::mojom::ContentSecurityPolicyDataView>* output) {
  auto pointer = data_->content_security_policy.Get();
  *output = mojo::ArrayDataView<::network::mojom::ContentSecurityPolicyDataView>(pointer, message_);
}
inline void ParsedHeadersDataView::GetAllowCspFromDataView(
    ::network::mojom::AllowCSPFromHeaderValueDataView* output) {
  auto pointer = &data_->allow_csp_from;
  *output = ::network::mojom::AllowCSPFromHeaderValueDataView(pointer, message_);
}
inline void ParsedHeadersDataView::GetCrossOriginEmbedderPolicyDataView(
    ::network::mojom::CrossOriginEmbedderPolicyDataView* output) {
  auto pointer = data_->cross_origin_embedder_policy.Get();
  *output = ::network::mojom::CrossOriginEmbedderPolicyDataView(pointer, message_);
}
inline void ParsedHeadersDataView::GetCrossOriginOpenerPolicyDataView(
    ::network::mojom::CrossOriginOpenerPolicyDataView* output) {
  auto pointer = data_->cross_origin_opener_policy.Get();
  *output = ::network::mojom::CrossOriginOpenerPolicyDataView(pointer, message_);
}
inline void ParsedHeadersDataView::GetAcceptChDataView(
    mojo::ArrayDataView<::network::mojom::WebClientHintsType>* output) {
  auto pointer = data_->accept_ch.Get();
  *output = mojo::ArrayDataView<::network::mojom::WebClientHintsType>(pointer, message_);
}
inline void ParsedHeadersDataView::GetAcceptChLifetimeDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->accept_ch_lifetime.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, message_);
}
inline void ParsedHeadersDataView::GetCriticalChDataView(
    mojo::ArrayDataView<::network::mojom::WebClientHintsType>* output) {
  auto pointer = data_->critical_ch.Get();
  *output = mojo::ArrayDataView<::network::mojom::WebClientHintsType>(pointer, message_);
}



}  // namespace mojom
}  // namespace network

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_PARSED_HEADERS_MOJOM_SHARED_H_