// services/network/public/mojom/parsed_headers.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_PARSED_HEADERS_MOJOM_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_PARSED_HEADERS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/network/public/mojom/parsed_headers.mojom-shared.h"
#include "services/network/public/mojom/parsed_headers.mojom-forward.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "services/network/public/mojom/content_security_policy.mojom.h"
#include "services/network/public/mojom/cross_origin_embedder_policy.mojom.h"
#include "services/network/public/mojom/cross_origin_opener_policy.mojom.h"
#include "services/network/public/mojom/web_client_hints_types.mojom-forward.h"
#include "services/network/public/mojom/x_frame_options.mojom-forward.h"
#include <string>
#include <vector>







// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace network {
namespace mojom {








class  ParsedHeaders {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ParsedHeaders, T>::value>;
  using DataView = ParsedHeadersDataView;
  using Data_ = internal::ParsedHeaders_Data;

  template <typename... Args>
  static ParsedHeadersPtr New(Args&&... args) {
    return ParsedHeadersPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ParsedHeadersPtr From(const U& u) {
    return mojo::TypeConverter<ParsedHeadersPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ParsedHeaders>::Convert(*this);
  }


  ParsedHeaders();

  ParsedHeaders(
      std::vector<::network::mojom::ContentSecurityPolicyPtr> content_security_policy,
      ::network::mojom::AllowCSPFromHeaderValuePtr allow_csp_from,
      const ::network::CrossOriginEmbedderPolicy& cross_origin_embedder_policy,
      const ::network::CrossOriginOpenerPolicy& cross_origin_opener_policy,
      bool origin_agent_cluster,
      base::Optional<std::vector<::network::mojom::WebClientHintsType>> accept_ch,
      ::base::TimeDelta accept_ch_lifetime,
      base::Optional<std::vector<::network::mojom::WebClientHintsType>> critical_ch,
      ::network::mojom::XFrameOptionsValue xfo);

  ~ParsedHeaders();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ParsedHeadersPtr>
  ParsedHeadersPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ParsedHeaders::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ParsedHeaders::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ParsedHeaders::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ParsedHeaders::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ParsedHeaders_UnserializedMessageContext<
            UserType, ParsedHeaders::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ParsedHeaders::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ParsedHeaders::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ParsedHeaders_UnserializedMessageContext<
            UserType, ParsedHeaders::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ParsedHeaders::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::vector<::network::mojom::ContentSecurityPolicyPtr> content_security_policy;
  
  ::network::mojom::AllowCSPFromHeaderValuePtr allow_csp_from;
  
  ::network::CrossOriginEmbedderPolicy cross_origin_embedder_policy;
  
  ::network::CrossOriginOpenerPolicy cross_origin_opener_policy;
  
  bool origin_agent_cluster;
  
  base::Optional<std::vector<::network::mojom::WebClientHintsType>> accept_ch;
  
  ::base::TimeDelta accept_ch_lifetime;
  
  base::Optional<std::vector<::network::mojom::WebClientHintsType>> critical_ch;
  
  ::network::mojom::XFrameOptionsValue xfo;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(ParsedHeaders);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ParsedHeaders::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ParsedHeaders::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ParsedHeaders::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ParsedHeaders::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
ParsedHeadersPtr ParsedHeaders::Clone() const {
  return New(
      mojo::Clone(content_security_policy),
      mojo::Clone(allow_csp_from),
      mojo::Clone(cross_origin_embedder_policy),
      mojo::Clone(cross_origin_opener_policy),
      mojo::Clone(origin_agent_cluster),
      mojo::Clone(accept_ch),
      mojo::Clone(accept_ch_lifetime),
      mojo::Clone(critical_ch),
      mojo::Clone(xfo)
  );
}

template <typename T, ParsedHeaders::EnableIfSame<T>*>
bool ParsedHeaders::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->content_security_policy, other_struct.content_security_policy))
    return false;
  if (!mojo::Equals(this->allow_csp_from, other_struct.allow_csp_from))
    return false;
  if (!mojo::Equals(this->cross_origin_embedder_policy, other_struct.cross_origin_embedder_policy))
    return false;
  if (!mojo::Equals(this->cross_origin_opener_policy, other_struct.cross_origin_opener_policy))
    return false;
  if (!mojo::Equals(this->origin_agent_cluster, other_struct.origin_agent_cluster))
    return false;
  if (!mojo::Equals(this->accept_ch, other_struct.accept_ch))
    return false;
  if (!mojo::Equals(this->accept_ch_lifetime, other_struct.accept_ch_lifetime))
    return false;
  if (!mojo::Equals(this->critical_ch, other_struct.critical_ch))
    return false;
  if (!mojo::Equals(this->xfo, other_struct.xfo))
    return false;
  return true;
}

template <typename T, ParsedHeaders::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.content_security_policy < rhs.content_security_policy)
    return true;
  if (rhs.content_security_policy < lhs.content_security_policy)
    return false;
  if (lhs.allow_csp_from < rhs.allow_csp_from)
    return true;
  if (rhs.allow_csp_from < lhs.allow_csp_from)
    return false;
  if (lhs.cross_origin_embedder_policy < rhs.cross_origin_embedder_policy)
    return true;
  if (rhs.cross_origin_embedder_policy < lhs.cross_origin_embedder_policy)
    return false;
  if (lhs.cross_origin_opener_policy < rhs.cross_origin_opener_policy)
    return true;
  if (rhs.cross_origin_opener_policy < lhs.cross_origin_opener_policy)
    return false;
  if (lhs.origin_agent_cluster < rhs.origin_agent_cluster)
    return true;
  if (rhs.origin_agent_cluster < lhs.origin_agent_cluster)
    return false;
  if (lhs.accept_ch < rhs.accept_ch)
    return true;
  if (rhs.accept_ch < lhs.accept_ch)
    return false;
  if (lhs.accept_ch_lifetime < rhs.accept_ch_lifetime)
    return true;
  if (rhs.accept_ch_lifetime < lhs.accept_ch_lifetime)
    return false;
  if (lhs.critical_ch < rhs.critical_ch)
    return true;
  if (rhs.critical_ch < lhs.critical_ch)
    return false;
  if (lhs.xfo < rhs.xfo)
    return true;
  if (rhs.xfo < lhs.xfo)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace network

namespace mojo {


template <>
struct  StructTraits<::network::mojom::ParsedHeaders::DataView,
                                         ::network::mojom::ParsedHeadersPtr> {
  static bool IsNull(const ::network::mojom::ParsedHeadersPtr& input) { return !input; }
  static void SetToNull(::network::mojom::ParsedHeadersPtr* output) { output->reset(); }

  static const decltype(::network::mojom::ParsedHeaders::content_security_policy)& content_security_policy(
      const ::network::mojom::ParsedHeadersPtr& input) {
    return input->content_security_policy;
  }

  static const decltype(::network::mojom::ParsedHeaders::allow_csp_from)& allow_csp_from(
      const ::network::mojom::ParsedHeadersPtr& input) {
    return input->allow_csp_from;
  }

  static const decltype(::network::mojom::ParsedHeaders::cross_origin_embedder_policy)& cross_origin_embedder_policy(
      const ::network::mojom::ParsedHeadersPtr& input) {
    return input->cross_origin_embedder_policy;
  }

  static const decltype(::network::mojom::ParsedHeaders::cross_origin_opener_policy)& cross_origin_opener_policy(
      const ::network::mojom::ParsedHeadersPtr& input) {
    return input->cross_origin_opener_policy;
  }

  static decltype(::network::mojom::ParsedHeaders::origin_agent_cluster) origin_agent_cluster(
      const ::network::mojom::ParsedHeadersPtr& input) {
    return input->origin_agent_cluster;
  }

  static const decltype(::network::mojom::ParsedHeaders::accept_ch)& accept_ch(
      const ::network::mojom::ParsedHeadersPtr& input) {
    return input->accept_ch;
  }

  static const decltype(::network::mojom::ParsedHeaders::accept_ch_lifetime)& accept_ch_lifetime(
      const ::network::mojom::ParsedHeadersPtr& input) {
    return input->accept_ch_lifetime;
  }

  static const decltype(::network::mojom::ParsedHeaders::critical_ch)& critical_ch(
      const ::network::mojom::ParsedHeadersPtr& input) {
    return input->critical_ch;
  }

  static decltype(::network::mojom::ParsedHeaders::xfo) xfo(
      const ::network::mojom::ParsedHeadersPtr& input) {
    return input->xfo;
  }

  static bool Read(::network::mojom::ParsedHeaders::DataView input, ::network::mojom::ParsedHeadersPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_PARSED_HEADERS_MOJOM_H_