// services/network/public/mojom/supports_loading_mode.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_SUPPORTS_LOADING_MODE_MOJOM_BLINK_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_SUPPORTS_LOADING_MODE_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/network/public/mojom/supports_loading_mode.mojom-shared.h"
#include "services/network/public/mojom/supports_loading_mode.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "third_party/blink/public/platform/web_common.h"




namespace WTF {
struct network_mojom_internal_LoadingMode_DataHashFn {
  static unsigned GetHash(const ::network::mojom::LoadingMode& value) {
    using utype = std::underlying_type<::network::mojom::LoadingMode>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::network::mojom::LoadingMode& left, const ::network::mojom::LoadingMode& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct HashTraits<::network::mojom::LoadingMode>
    : public GenericHashTraits<::network::mojom::LoadingMode> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::network::mojom::LoadingMode& value) {
    return value == static_cast<::network::mojom::LoadingMode>(-1000000);
  }
  static void ConstructDeletedValue(::network::mojom::LoadingMode& slot, bool) {
    slot = static_cast<::network::mojom::LoadingMode>(-1000001);
  }
  static bool IsDeletedValue(const ::network::mojom::LoadingMode& value) {
    return value == static_cast<::network::mojom::LoadingMode>(-1000001);
  }
};
}  // namespace WTF

// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace network {
namespace mojom {
namespace blink {








class BLINK_PLATFORM_EXPORT SupportsLoadingMode {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SupportsLoadingMode, T>::value>;
  using DataView = SupportsLoadingModeDataView;
  using Data_ = internal::SupportsLoadingMode_Data;

  template <typename... Args>
  static SupportsLoadingModePtr New(Args&&... args) {
    return SupportsLoadingModePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SupportsLoadingModePtr From(const U& u) {
    return mojo::TypeConverter<SupportsLoadingModePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SupportsLoadingMode>::Convert(*this);
  }


  SupportsLoadingMode();

  explicit SupportsLoadingMode(
      WTF::Vector<LoadingMode> supported_modes);

  ~SupportsLoadingMode();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SupportsLoadingModePtr>
  SupportsLoadingModePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SupportsLoadingMode::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, SupportsLoadingMode::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SupportsLoadingMode::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SupportsLoadingMode::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SupportsLoadingMode_UnserializedMessageContext<
            UserType, SupportsLoadingMode::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<SupportsLoadingMode::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return SupportsLoadingMode::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SupportsLoadingMode_UnserializedMessageContext<
            UserType, SupportsLoadingMode::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SupportsLoadingMode::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::Vector<LoadingMode> supported_modes;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SupportsLoadingMode::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SupportsLoadingMode::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SupportsLoadingMode::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SupportsLoadingMode::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
SupportsLoadingModePtr SupportsLoadingMode::Clone() const {
  return New(
      mojo::Clone(supported_modes)
  );
}

template <typename T, SupportsLoadingMode::EnableIfSame<T>*>
bool SupportsLoadingMode::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->supported_modes, other_struct.supported_modes))
    return false;
  return true;
}

template <typename T, SupportsLoadingMode::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.supported_modes < rhs.supported_modes)
    return true;
  if (rhs.supported_modes < lhs.supported_modes)
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace network

namespace mojo {


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::network::mojom::blink::SupportsLoadingMode::DataView,
                                         ::network::mojom::blink::SupportsLoadingModePtr> {
  static bool IsNull(const ::network::mojom::blink::SupportsLoadingModePtr& input) { return !input; }
  static void SetToNull(::network::mojom::blink::SupportsLoadingModePtr* output) { output->reset(); }

  static const decltype(::network::mojom::blink::SupportsLoadingMode::supported_modes)& supported_modes(
      const ::network::mojom::blink::SupportsLoadingModePtr& input) {
    return input->supported_modes;
  }

  static bool Read(::network::mojom::blink::SupportsLoadingMode::DataView input, ::network::mojom::blink::SupportsLoadingModePtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_SUPPORTS_LOADING_MODE_MOJOM_BLINK_H_