// services/viz/public/mojom/compositing/compositor_frame_transition_directive.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_COMPOSITOR_FRAME_TRANSITION_DIRECTIVE_MOJOM_SHARED_H_
#define SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_COMPOSITOR_FRAME_TRANSITION_DIRECTIVE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"
#include "services/viz/public/mojom/compositing/compositor_frame_transition_directive.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"







namespace viz {
namespace mojom {
class CompositorFrameTransitionDirectiveDataView;



}  // namespace mojom
}  // namespace viz

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::viz::mojom::CompositorFrameTransitionDirectiveDataView> {
  using Data = ::viz::mojom::internal::CompositorFrameTransitionDirective_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace viz {
namespace mojom {


enum class CompositorFrameTransitionDirectiveType : int32_t {
  
  kSave = 0,
  
  kAnimate = 1,
  kMinValue = 0,
  kMaxValue = 1,
};

 std::ostream& operator<<(std::ostream& os, CompositorFrameTransitionDirectiveType value);
inline bool IsKnownEnumValue(CompositorFrameTransitionDirectiveType value) {
  return internal::CompositorFrameTransitionDirectiveType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class CompositorFrameTransitionDirectiveEffect : int32_t {
  
  kNone = 0,
  
  kCoverDown = 1,
  
  kCoverLeft = 2,
  
  kCoverRight = 3,
  
  kCoverUp = 4,
  
  kExplode = 5,
  
  kFade = 6,
  
  kImplode = 7,
  
  kRevealDown = 8,
  
  kRevealLeft = 9,
  
  kRevealRight = 10,
  
  kRevealUp = 11,
  kMinValue = 0,
  kMaxValue = 11,
};

 std::ostream& operator<<(std::ostream& os, CompositorFrameTransitionDirectiveEffect value);
inline bool IsKnownEnumValue(CompositorFrameTransitionDirectiveEffect value) {
  return internal::CompositorFrameTransitionDirectiveEffect_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


class CompositorFrameTransitionDirectiveDataView {
 public:
  CompositorFrameTransitionDirectiveDataView() {}

  CompositorFrameTransitionDirectiveDataView(
      internal::CompositorFrameTransitionDirective_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  uint32_t sequence_id() const {
    return data_->sequence_id;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadType(UserType* output) const {
    auto data_value = data_->type;
    return mojo::internal::Deserialize<::viz::mojom::CompositorFrameTransitionDirectiveType>(
        data_value, output);
  }
  CompositorFrameTransitionDirectiveType type() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::viz::mojom::CompositorFrameTransitionDirectiveType>(data_->type));
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadEffect(UserType* output) const {
    auto data_value = data_->effect;
    return mojo::internal::Deserialize<::viz::mojom::CompositorFrameTransitionDirectiveEffect>(
        data_value, output);
  }
  CompositorFrameTransitionDirectiveEffect effect() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::viz::mojom::CompositorFrameTransitionDirectiveEffect>(data_->effect));
  }
  inline void GetDurationDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDuration(UserType* output) {
    
    auto* pointer = data_->duration.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, message_);
  }
 private:
  internal::CompositorFrameTransitionDirective_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom
}  // namespace viz

namespace std {

template <>
struct hash<::viz::mojom::CompositorFrameTransitionDirectiveType>
    : public mojo::internal::EnumHashImpl<::viz::mojom::CompositorFrameTransitionDirectiveType> {};

template <>
struct hash<::viz::mojom::CompositorFrameTransitionDirectiveEffect>
    : public mojo::internal::EnumHashImpl<::viz::mojom::CompositorFrameTransitionDirectiveEffect> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::viz::mojom::CompositorFrameTransitionDirectiveType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::viz::mojom::CompositorFrameTransitionDirectiveType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::viz::mojom::CompositorFrameTransitionDirectiveType>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::viz::mojom::CompositorFrameTransitionDirectiveEffect, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::viz::mojom::CompositorFrameTransitionDirectiveEffect, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::viz::mojom::CompositorFrameTransitionDirectiveEffect>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::viz::mojom::CompositorFrameTransitionDirectiveDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::viz::mojom::CompositorFrameTransitionDirectiveDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::viz::mojom::internal::CompositorFrameTransitionDirective_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->sequence_id = Traits::sequence_id(input);
    mojo::internal::Serialize<::viz::mojom::CompositorFrameTransitionDirectiveType>(
        Traits::type(input), &fragment->type);
    mojo::internal::Serialize<::viz::mojom::CompositorFrameTransitionDirectiveEffect>(
        Traits::effect(input), &fragment->effect);
    decltype(Traits::duration(input)) in_duration = Traits::duration(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->duration)::BaseType> duration_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::TimeDeltaDataView>(
        in_duration, duration_fragment);
    fragment->duration.Set(
        duration_fragment.is_null() ? nullptr : duration_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->duration.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null duration in CompositorFrameTransitionDirective struct");
  }

  static bool Deserialize(::viz::mojom::internal::CompositorFrameTransitionDirective_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::viz::mojom::CompositorFrameTransitionDirectiveDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace viz {
namespace mojom {

inline void CompositorFrameTransitionDirectiveDataView::GetDurationDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->duration.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, message_);
}



}  // namespace mojom
}  // namespace viz

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct  TraceFormatTraits<::viz::mojom::CompositorFrameTransitionDirectiveType> {
 static void WriteIntoTracedValue(perfetto::TracedValue context, ::viz::mojom::CompositorFrameTransitionDirectiveType value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct  TraceFormatTraits<::viz::mojom::CompositorFrameTransitionDirectiveEffect> {
 static void WriteIntoTracedValue(perfetto::TracedValue context, ::viz::mojom::CompositorFrameTransitionDirectiveEffect value);
};

} // namespace perfetto

#endif  // SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_COMPOSITOR_FRAME_TRANSITION_DIRECTIVE_MOJOM_SHARED_H_