// services/viz/public/mojom/compositing/compositor_frame_transition_directive.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_COMPOSITOR_FRAME_TRANSITION_DIRECTIVE_MOJOM_H_
#define SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_COMPOSITOR_FRAME_TRANSITION_DIRECTIVE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/viz/public/mojom/compositing/compositor_frame_transition_directive.mojom-shared.h"
#include "services/viz/public/mojom/compositing/compositor_frame_transition_directive.mojom-forward.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include <string>
#include <vector>




#include "services/viz/public/cpp/compositing/compositor_frame_transition_directive_mojom_traits.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace viz {
namespace mojom {








class  CompositorFrameTransitionDirective {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<CompositorFrameTransitionDirective, T>::value>;
  using DataView = CompositorFrameTransitionDirectiveDataView;
  using Data_ = internal::CompositorFrameTransitionDirective_Data;

  template <typename... Args>
  static CompositorFrameTransitionDirectivePtr New(Args&&... args) {
    return CompositorFrameTransitionDirectivePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static CompositorFrameTransitionDirectivePtr From(const U& u) {
    return mojo::TypeConverter<CompositorFrameTransitionDirectivePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, CompositorFrameTransitionDirective>::Convert(*this);
  }


  CompositorFrameTransitionDirective();

  CompositorFrameTransitionDirective(
      uint32_t sequence_id,
      CompositorFrameTransitionDirectiveType type,
      CompositorFrameTransitionDirectiveEffect effect,
      ::base::TimeDelta duration);

  ~CompositorFrameTransitionDirective();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = CompositorFrameTransitionDirectivePtr>
  CompositorFrameTransitionDirectivePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        CompositorFrameTransitionDirective::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        CompositorFrameTransitionDirective::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::CompositorFrameTransitionDirective_UnserializedMessageContext<
            UserType, CompositorFrameTransitionDirective::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<CompositorFrameTransitionDirective::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return CompositorFrameTransitionDirective::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::CompositorFrameTransitionDirective_UnserializedMessageContext<
            UserType, CompositorFrameTransitionDirective::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<CompositorFrameTransitionDirective::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint32_t sequence_id;
  
  CompositorFrameTransitionDirectiveType type;
  
  CompositorFrameTransitionDirectiveEffect effect;
  
  ::base::TimeDelta duration;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
CompositorFrameTransitionDirectivePtr CompositorFrameTransitionDirective::Clone() const {
  return New(
      mojo::Clone(sequence_id),
      mojo::Clone(type),
      mojo::Clone(effect),
      mojo::Clone(duration)
  );
}

template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>*>
bool CompositorFrameTransitionDirective::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->sequence_id, other_struct.sequence_id))
    return false;
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->effect, other_struct.effect))
    return false;
  if (!mojo::Equals(this->duration, other_struct.duration))
    return false;
  return true;
}

template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.sequence_id < rhs.sequence_id)
    return true;
  if (rhs.sequence_id < lhs.sequence_id)
    return false;
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.effect < rhs.effect)
    return true;
  if (rhs.effect < lhs.effect)
    return false;
  if (lhs.duration < rhs.duration)
    return true;
  if (rhs.duration < lhs.duration)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace viz

namespace mojo {


template <>
struct  StructTraits<::viz::mojom::CompositorFrameTransitionDirective::DataView,
                                         ::viz::mojom::CompositorFrameTransitionDirectivePtr> {
  static bool IsNull(const ::viz::mojom::CompositorFrameTransitionDirectivePtr& input) { return !input; }
  static void SetToNull(::viz::mojom::CompositorFrameTransitionDirectivePtr* output) { output->reset(); }

  static decltype(::viz::mojom::CompositorFrameTransitionDirective::sequence_id) sequence_id(
      const ::viz::mojom::CompositorFrameTransitionDirectivePtr& input) {
    return input->sequence_id;
  }

  static decltype(::viz::mojom::CompositorFrameTransitionDirective::type) type(
      const ::viz::mojom::CompositorFrameTransitionDirectivePtr& input) {
    return input->type;
  }

  static decltype(::viz::mojom::CompositorFrameTransitionDirective::effect) effect(
      const ::viz::mojom::CompositorFrameTransitionDirectivePtr& input) {
    return input->effect;
  }

  static const decltype(::viz::mojom::CompositorFrameTransitionDirective::duration)& duration(
      const ::viz::mojom::CompositorFrameTransitionDirectivePtr& input) {
    return input->duration;
  }

  static bool Read(::viz::mojom::CompositorFrameTransitionDirective::DataView input, ::viz::mojom::CompositorFrameTransitionDirectivePtr* output);
};

}  // namespace mojo

#endif  // SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_COMPOSITOR_FRAME_TRANSITION_DIRECTIVE_MOJOM_H_