// third_party/blink/public/mojom/appcache/appcache.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/appcache/appcache.mojom-shared.h"

#include <utility>

#include "base/stl_util.h"  // for base::size()
#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/appcache/appcache.mojom-params-data.h"
namespace blink {
namespace mojom {

std::string AppCacheEventIDToString(AppCacheEventID value) {
  switch(value) {
    case AppCacheEventID::APPCACHE_CHECKING_EVENT:
      return "AppCacheEventID::APPCACHE_CHECKING_EVENT";
    case AppCacheEventID::APPCACHE_ERROR_EVENT:
      return "AppCacheEventID::APPCACHE_ERROR_EVENT";
    case AppCacheEventID::APPCACHE_NO_UPDATE_EVENT:
      return "AppCacheEventID::APPCACHE_NO_UPDATE_EVENT";
    case AppCacheEventID::APPCACHE_DOWNLOADING_EVENT:
      return "AppCacheEventID::APPCACHE_DOWNLOADING_EVENT";
    case AppCacheEventID::APPCACHE_PROGRESS_EVENT:
      return "AppCacheEventID::APPCACHE_PROGRESS_EVENT";
    case AppCacheEventID::APPCACHE_UPDATE_READY_EVENT:
      return "AppCacheEventID::APPCACHE_UPDATE_READY_EVENT";
    case AppCacheEventID::APPCACHE_CACHED_EVENT:
      return "AppCacheEventID::APPCACHE_CACHED_EVENT";
    case AppCacheEventID::APPCACHE_OBSOLETE_EVENT:
      return "AppCacheEventID::APPCACHE_OBSOLETE_EVENT";
    default:
      return base::StringPrintf("Unknown AppCacheEventID value: %i", static_cast<int32_t>(value));
  }
}

std::ostream& operator<<(std::ostream& os, AppCacheEventID value) {
  return os << AppCacheEventIDToString(value);
}

std::string AppCacheErrorReasonToString(AppCacheErrorReason value) {
  switch(value) {
    case AppCacheErrorReason::APPCACHE_MANIFEST_ERROR:
      return "AppCacheErrorReason::APPCACHE_MANIFEST_ERROR";
    case AppCacheErrorReason::APPCACHE_SIGNATURE_ERROR:
      return "AppCacheErrorReason::APPCACHE_SIGNATURE_ERROR";
    case AppCacheErrorReason::APPCACHE_RESOURCE_ERROR:
      return "AppCacheErrorReason::APPCACHE_RESOURCE_ERROR";
    case AppCacheErrorReason::APPCACHE_CHANGED_ERROR:
      return "AppCacheErrorReason::APPCACHE_CHANGED_ERROR";
    case AppCacheErrorReason::APPCACHE_ABORT_ERROR:
      return "AppCacheErrorReason::APPCACHE_ABORT_ERROR";
    case AppCacheErrorReason::APPCACHE_QUOTA_ERROR:
      return "AppCacheErrorReason::APPCACHE_QUOTA_ERROR";
    case AppCacheErrorReason::APPCACHE_POLICY_ERROR:
      return "AppCacheErrorReason::APPCACHE_POLICY_ERROR";
    case AppCacheErrorReason::APPCACHE_UNKNOWN_ERROR:
      return "AppCacheErrorReason::APPCACHE_UNKNOWN_ERROR";
    default:
      return base::StringPrintf("Unknown AppCacheErrorReason value: %i", static_cast<int32_t>(value));
  }
}

std::ostream& operator<<(std::ostream& os, AppCacheErrorReason value) {
  return os << AppCacheErrorReasonToString(value);
}

namespace internal {


// static
bool AppCacheResourceInfo_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 48, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheResourceInfo_Data* object = static_cast<const AppCacheResourceInfo_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->url, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->url, validation_context))
    return false;

  return true;
}

AppCacheResourceInfo_Data::AppCacheResourceInfo_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheErrorDetails_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 40, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheErrorDetails_Data* object = static_cast<const AppCacheErrorDetails_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->message, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams message_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->message, validation_context,
                                         &message_validate_params)) {
    return false;
  }


  if (!::blink::mojom::internal::AppCacheErrorReason_Data
        ::Validate(object->reason, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->url, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->url, validation_context))
    return false;

  return true;
}

AppCacheErrorDetails_Data::AppCacheErrorDetails_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheBackend_RegisterHost_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheBackend_RegisterHost_Params_Data* object = static_cast<const AppCacheBackend_RegisterHost_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->host_receiver, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->host_receiver,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->frontend, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->frontend,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->host_id, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->host_id, validation_context))
    return false;

  return true;
}

AppCacheBackend_RegisterHost_Params_Data::AppCacheBackend_RegisterHost_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheHost_SetSpawningHostId_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheHost_SetSpawningHostId_Params_Data* object = static_cast<const AppCacheHost_SetSpawningHostId_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->spawning_host_id, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->spawning_host_id, validation_context))
    return false;

  return true;
}

AppCacheHost_SetSpawningHostId_Params_Data::AppCacheHost_SetSpawningHostId_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheHost_SelectCache_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheHost_SelectCache_Params_Data* object = static_cast<const AppCacheHost_SelectCache_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->document_url, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->document_url, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->opt_manifest_url, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->opt_manifest_url, validation_context))
    return false;

  return true;
}

AppCacheHost_SelectCache_Params_Data::AppCacheHost_SelectCache_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheHost_SelectCacheForWorker_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheHost_SelectCacheForWorker_Params_Data* object = static_cast<const AppCacheHost_SelectCacheForWorker_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

AppCacheHost_SelectCacheForWorker_Params_Data::AppCacheHost_SelectCacheForWorker_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheHost_MarkAsForeignEntry_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheHost_MarkAsForeignEntry_Params_Data* object = static_cast<const AppCacheHost_MarkAsForeignEntry_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->document_url, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->document_url, validation_context))
    return false;

  return true;
}

AppCacheHost_MarkAsForeignEntry_Params_Data::AppCacheHost_MarkAsForeignEntry_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheHost_GetStatus_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheHost_GetStatus_Params_Data* object = static_cast<const AppCacheHost_GetStatus_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

AppCacheHost_GetStatus_Params_Data::AppCacheHost_GetStatus_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheHost_GetStatus_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheHost_GetStatus_ResponseParams_Data* object = static_cast<const AppCacheHost_GetStatus_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::blink::mojom::internal::AppCacheStatus_Data
        ::Validate(object->status, validation_context))
    return false;

  return true;
}

AppCacheHost_GetStatus_ResponseParams_Data::AppCacheHost_GetStatus_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheHost_StartUpdate_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheHost_StartUpdate_Params_Data* object = static_cast<const AppCacheHost_StartUpdate_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

AppCacheHost_StartUpdate_Params_Data::AppCacheHost_StartUpdate_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheHost_StartUpdate_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheHost_StartUpdate_ResponseParams_Data* object = static_cast<const AppCacheHost_StartUpdate_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

AppCacheHost_StartUpdate_ResponseParams_Data::AppCacheHost_StartUpdate_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheHost_SwapCache_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheHost_SwapCache_Params_Data* object = static_cast<const AppCacheHost_SwapCache_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

AppCacheHost_SwapCache_Params_Data::AppCacheHost_SwapCache_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheHost_SwapCache_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheHost_SwapCache_ResponseParams_Data* object = static_cast<const AppCacheHost_SwapCache_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

AppCacheHost_SwapCache_ResponseParams_Data::AppCacheHost_SwapCache_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheHost_GetResourceList_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheHost_GetResourceList_Params_Data* object = static_cast<const AppCacheHost_GetResourceList_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

AppCacheHost_GetResourceList_Params_Data::AppCacheHost_GetResourceList_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheHost_GetResourceList_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheHost_GetResourceList_ResponseParams_Data* object = static_cast<const AppCacheHost_GetResourceList_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->resources, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams resources_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->resources, validation_context,
                                         &resources_validate_params)) {
    return false;
  }

  return true;
}

AppCacheHost_GetResourceList_ResponseParams_Data::AppCacheHost_GetResourceList_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheFrontend_CacheSelected_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheFrontend_CacheSelected_Params_Data* object = static_cast<const AppCacheFrontend_CacheSelected_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->info, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->info, validation_context))
    return false;

  return true;
}

AppCacheFrontend_CacheSelected_Params_Data::AppCacheFrontend_CacheSelected_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheFrontend_EventRaised_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheFrontend_EventRaised_Params_Data* object = static_cast<const AppCacheFrontend_EventRaised_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::blink::mojom::internal::AppCacheEventID_Data
        ::Validate(object->event_id, validation_context))
    return false;

  return true;
}

AppCacheFrontend_EventRaised_Params_Data::AppCacheFrontend_EventRaised_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheFrontend_ProgressEventRaised_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheFrontend_ProgressEventRaised_Params_Data* object = static_cast<const AppCacheFrontend_ProgressEventRaised_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->url, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->url, validation_context))
    return false;

  return true;
}

AppCacheFrontend_ProgressEventRaised_Params_Data::AppCacheFrontend_ProgressEventRaised_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheFrontend_ErrorEventRaised_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheFrontend_ErrorEventRaised_Params_Data* object = static_cast<const AppCacheFrontend_ErrorEventRaised_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->error_details, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->error_details, validation_context))
    return false;

  return true;
}

AppCacheFrontend_ErrorEventRaised_Params_Data::AppCacheFrontend_ErrorEventRaised_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheFrontend_LogMessage_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheFrontend_LogMessage_Params_Data* object = static_cast<const AppCacheFrontend_LogMessage_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::blink::mojom::internal::ConsoleMessageLevel_Data
        ::Validate(object->log_level, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->message, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams message_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->message, validation_context,
                                         &message_validate_params)) {
    return false;
  }

  return true;
}

AppCacheFrontend_LogMessage_Params_Data::AppCacheFrontend_LogMessage_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AppCacheFrontend_SetSubresourceFactory_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AppCacheFrontend_SetSubresourceFactory_Params_Data* object = static_cast<const AppCacheFrontend_SetSubresourceFactory_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->url_loader_factory, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->url_loader_factory,
                                                 validation_context)) {
    return false;
  }

  return true;
}

AppCacheFrontend_SetSubresourceFactory_Params_Data::AppCacheFrontend_SetSubresourceFactory_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::AppCacheEventID>::WriteIntoTracedValue(
   perfetto::TracedValue context, ::blink::mojom::AppCacheEventID value) {
  return std::move(context).WriteString(::blink::mojom::AppCacheEventIDToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::AppCacheErrorReason>::WriteIntoTracedValue(
   perfetto::TracedValue context, ::blink::mojom::AppCacheErrorReason value) {
  return std::move(context).WriteString(::blink::mojom::AppCacheErrorReasonToString(value));
}

} // namespace perfetto
