// third_party/blink/public/mojom/appcache/appcache_info.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_APPCACHE_APPCACHE_INFO_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_APPCACHE_APPCACHE_INFO_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"
#include "third_party/blink/public/mojom/appcache/appcache_info.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"
#include "url/mojom/url.mojom-shared.h"



#include "base/component_export.h"




namespace blink {
namespace mojom {
class AppCacheInfoDataView;



}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::AppCacheInfoDataView> {
  using Data = ::blink::mojom::internal::AppCacheInfo_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {


enum class AppCacheStatus : int32_t {
  
  APPCACHE_STATUS_UNCACHED = 0,
  
  APPCACHE_STATUS_IDLE = 1,
  
  APPCACHE_STATUS_CHECKING = 2,
  
  APPCACHE_STATUS_DOWNLOADING = 3,
  
  APPCACHE_STATUS_UPDATE_READY = 4,
  
  APPCACHE_STATUS_OBSOLETE = 5,
  kMinValue = 0,
  kMaxValue = 5,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, AppCacheStatus value);
inline bool IsKnownEnumValue(AppCacheStatus value) {
  return internal::AppCacheStatus_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


class AppCacheInfoDataView {
 public:
  AppCacheInfoDataView() {}

  AppCacheInfoDataView(
      internal::AppCacheInfo_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetManifestUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadManifestUrl(UserType* output) {
    
    auto* pointer = data_->manifest_url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, message_);
  }
  inline void GetCreationTimeDataView(
      ::mojo_base::mojom::TimeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCreationTime(UserType* output) {
    
    auto* pointer = data_->creation_time.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDataView>(
        pointer, output, message_);
  }
  inline void GetLastUpdateTimeDataView(
      ::mojo_base::mojom::TimeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadLastUpdateTime(UserType* output) {
    
    auto* pointer = data_->last_update_time.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDataView>(
        pointer, output, message_);
  }
  inline void GetLastAccessTimeDataView(
      ::mojo_base::mojom::TimeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadLastAccessTime(UserType* output) {
    
    auto* pointer = data_->last_access_time.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDataView>(
        pointer, output, message_);
  }
  inline void GetTokenExpiresDataView(
      ::mojo_base::mojom::TimeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTokenExpires(UserType* output) {
    
    auto* pointer = data_->token_expires.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDataView>(
        pointer, output, message_);
  }
  int64_t cache_id() const {
    return data_->cache_id;
  }
  int64_t group_id() const {
    return data_->group_id;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::AppCacheStatus>(
        data_value, output);
  }
  AppCacheStatus status() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::AppCacheStatus>(data_->status));
  }
  int64_t response_sizes() const {
    return data_->response_sizes;
  }
  int64_t padding_sizes() const {
    return data_->padding_sizes;
  }
  bool is_complete() const {
    return data_->is_complete;
  }
  int64_t manifest_parser_version() const {
    return data_->manifest_parser_version;
  }
  inline void GetManifestScopeDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadManifestScope(UserType* output) {
    
    auto* pointer = data_->manifest_scope.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
 private:
  internal::AppCacheInfo_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

template <>
struct hash<::blink::mojom::AppCacheStatus>
    : public mojo::internal::EnumHashImpl<::blink::mojom::AppCacheStatus> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::AppCacheStatus, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::AppCacheStatus, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::AppCacheStatus>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::AppCacheInfoDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::AppCacheInfoDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::AppCacheInfo_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::manifest_url(input)) in_manifest_url = Traits::manifest_url(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->manifest_url)::BaseType> manifest_url_fragment(
            fragment.message());
    mojo::internal::Serialize<::url::mojom::UrlDataView>(
        in_manifest_url, manifest_url_fragment);
    fragment->manifest_url.Set(
        manifest_url_fragment.is_null() ? nullptr : manifest_url_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->manifest_url.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null manifest_url in AppCacheInfo struct");
    decltype(Traits::creation_time(input)) in_creation_time = Traits::creation_time(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->creation_time)::BaseType> creation_time_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::TimeDataView>(
        in_creation_time, creation_time_fragment);
    fragment->creation_time.Set(
        creation_time_fragment.is_null() ? nullptr : creation_time_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->creation_time.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null creation_time in AppCacheInfo struct");
    decltype(Traits::last_update_time(input)) in_last_update_time = Traits::last_update_time(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->last_update_time)::BaseType> last_update_time_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::TimeDataView>(
        in_last_update_time, last_update_time_fragment);
    fragment->last_update_time.Set(
        last_update_time_fragment.is_null() ? nullptr : last_update_time_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->last_update_time.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null last_update_time in AppCacheInfo struct");
    decltype(Traits::last_access_time(input)) in_last_access_time = Traits::last_access_time(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->last_access_time)::BaseType> last_access_time_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::TimeDataView>(
        in_last_access_time, last_access_time_fragment);
    fragment->last_access_time.Set(
        last_access_time_fragment.is_null() ? nullptr : last_access_time_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->last_access_time.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null last_access_time in AppCacheInfo struct");
    decltype(Traits::token_expires(input)) in_token_expires = Traits::token_expires(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->token_expires)::BaseType> token_expires_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::TimeDataView>(
        in_token_expires, token_expires_fragment);
    fragment->token_expires.Set(
        token_expires_fragment.is_null() ? nullptr : token_expires_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->token_expires.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null token_expires in AppCacheInfo struct");
    fragment->cache_id = Traits::cache_id(input);
    fragment->group_id = Traits::group_id(input);
    mojo::internal::Serialize<::blink::mojom::AppCacheStatus>(
        Traits::status(input), &fragment->status);
    fragment->response_sizes = Traits::response_sizes(input);
    fragment->padding_sizes = Traits::padding_sizes(input);
    fragment->is_complete = Traits::is_complete(input);
    fragment->manifest_parser_version = Traits::manifest_parser_version(input);
    decltype(Traits::manifest_scope(input)) in_manifest_scope = Traits::manifest_scope(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->manifest_scope)::BaseType> manifest_scope_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_manifest_scope, manifest_scope_fragment);
    fragment->manifest_scope.Set(
        manifest_scope_fragment.is_null() ? nullptr : manifest_scope_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->manifest_scope.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null manifest_scope in AppCacheInfo struct");
  }

  static bool Deserialize(::blink::mojom::internal::AppCacheInfo_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::AppCacheInfoDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {

inline void AppCacheInfoDataView::GetManifestUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->manifest_url.Get();
  *output = ::url::mojom::UrlDataView(pointer, message_);
}
inline void AppCacheInfoDataView::GetCreationTimeDataView(
    ::mojo_base::mojom::TimeDataView* output) {
  auto pointer = data_->creation_time.Get();
  *output = ::mojo_base::mojom::TimeDataView(pointer, message_);
}
inline void AppCacheInfoDataView::GetLastUpdateTimeDataView(
    ::mojo_base::mojom::TimeDataView* output) {
  auto pointer = data_->last_update_time.Get();
  *output = ::mojo_base::mojom::TimeDataView(pointer, message_);
}
inline void AppCacheInfoDataView::GetLastAccessTimeDataView(
    ::mojo_base::mojom::TimeDataView* output) {
  auto pointer = data_->last_access_time.Get();
  *output = ::mojo_base::mojom::TimeDataView(pointer, message_);
}
inline void AppCacheInfoDataView::GetTokenExpiresDataView(
    ::mojo_base::mojom::TimeDataView* output) {
  auto pointer = data_->token_expires.Get();
  *output = ::mojo_base::mojom::TimeDataView(pointer, message_);
}
inline void AppCacheInfoDataView::GetManifestScopeDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->manifest_scope.Get();
  *output = mojo::StringDataView(pointer, message_);
}



}  // namespace mojom
}  // namespace blink

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::AppCacheStatus> {
 static void WriteIntoTracedValue(perfetto::TracedValue context, ::blink::mojom::AppCacheStatus value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_APPCACHE_APPCACHE_INFO_MOJOM_SHARED_H_