// third_party/blink/public/mojom/background_sync/background_sync.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/background_sync/background_sync.mojom-shared.h"

#include <utility>

#include "base/stl_util.h"  // for base::size()
#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/background_sync/background_sync.mojom-params-data.h"
namespace blink {
namespace mojom {

std::string BackgroundSyncErrorToString(BackgroundSyncError value) {
  switch(value) {
    case BackgroundSyncError::NONE:
      return "BackgroundSyncError::NONE";
    case BackgroundSyncError::STORAGE:
      return "BackgroundSyncError::STORAGE";
    case BackgroundSyncError::NOT_FOUND:
      return "BackgroundSyncError::NOT_FOUND";
    case BackgroundSyncError::NO_SERVICE_WORKER:
      return "BackgroundSyncError::NO_SERVICE_WORKER";
    case BackgroundSyncError::NOT_ALLOWED:
      return "BackgroundSyncError::NOT_ALLOWED";
    case BackgroundSyncError::PERMISSION_DENIED:
      return "BackgroundSyncError::{PERMISSION_DENIED, MAX}";
    default:
      return base::StringPrintf("Unknown BackgroundSyncError value: %i", static_cast<int32_t>(value));
  }
}

std::ostream& operator<<(std::ostream& os, BackgroundSyncError value) {
  return os << BackgroundSyncErrorToString(value);
}

std::string BackgroundSyncStateToString(BackgroundSyncState value) {
  switch(value) {
    case BackgroundSyncState::PENDING:
      return "BackgroundSyncState::PENDING";
    case BackgroundSyncState::FIRING:
      return "BackgroundSyncState::FIRING";
    case BackgroundSyncState::REREGISTERED_WHILE_FIRING:
      return "BackgroundSyncState::REREGISTERED_WHILE_FIRING";
    default:
      return base::StringPrintf("Unknown BackgroundSyncState value: %i", static_cast<int32_t>(value));
  }
}

std::ostream& operator<<(std::ostream& os, BackgroundSyncState value) {
  return os << BackgroundSyncStateToString(value);
}

std::string BackgroundSyncEventLastChanceToString(BackgroundSyncEventLastChance value) {
  switch(value) {
    case BackgroundSyncEventLastChance::IS_NOT_LAST_CHANCE:
      return "BackgroundSyncEventLastChance::IS_NOT_LAST_CHANCE";
    case BackgroundSyncEventLastChance::IS_LAST_CHANCE:
      return "BackgroundSyncEventLastChance::IS_LAST_CHANCE";
    default:
      return base::StringPrintf("Unknown BackgroundSyncEventLastChance value: %i", static_cast<int32_t>(value));
  }
}

std::ostream& operator<<(std::ostream& os, BackgroundSyncEventLastChance value) {
  return os << BackgroundSyncEventLastChanceToString(value);
}

std::string BackgroundSyncTypeToString(BackgroundSyncType value) {
  switch(value) {
    case BackgroundSyncType::ONE_SHOT:
      return "BackgroundSyncType::ONE_SHOT";
    case BackgroundSyncType::PERIODIC:
      return "BackgroundSyncType::PERIODIC";
    default:
      return base::StringPrintf("Unknown BackgroundSyncType value: %i", static_cast<int32_t>(value));
  }
}

std::ostream& operator<<(std::ostream& os, BackgroundSyncType value) {
  return os << BackgroundSyncTypeToString(value);
}

namespace internal {


// static
bool SyncRegistrationOptions_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const SyncRegistrationOptions_Data* object = static_cast<const SyncRegistrationOptions_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->tag, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams tag_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->tag, validation_context,
                                         &tag_validate_params)) {
    return false;
  }

  return true;
}

SyncRegistrationOptions_Data::SyncRegistrationOptions_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool BackgroundSyncRegistrationInfo_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const BackgroundSyncRegistrationInfo_Data* object = static_cast<const BackgroundSyncRegistrationInfo_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->tag, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams tag_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->tag, validation_context,
                                         &tag_validate_params)) {
    return false;
  }


  if (!::blink::mojom::internal::BackgroundSyncType_Data
        ::Validate(object->sync_type, validation_context))
    return false;

  return true;
}

BackgroundSyncRegistrationInfo_Data::BackgroundSyncRegistrationInfo_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OneShotBackgroundSyncService_Register_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const OneShotBackgroundSyncService_Register_Params_Data* object = static_cast<const OneShotBackgroundSyncService_Register_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->options, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->options, validation_context))
    return false;

  return true;
}

OneShotBackgroundSyncService_Register_Params_Data::OneShotBackgroundSyncService_Register_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OneShotBackgroundSyncService_Register_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const OneShotBackgroundSyncService_Register_ResponseParams_Data* object = static_cast<const OneShotBackgroundSyncService_Register_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::blink::mojom::internal::BackgroundSyncError_Data
        ::Validate(object->err, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->options, validation_context))
    return false;

  return true;
}

OneShotBackgroundSyncService_Register_ResponseParams_Data::OneShotBackgroundSyncService_Register_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OneShotBackgroundSyncService_DidResolveRegistration_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const OneShotBackgroundSyncService_DidResolveRegistration_Params_Data* object = static_cast<const OneShotBackgroundSyncService_DidResolveRegistration_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->registration_info, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->registration_info, validation_context))
    return false;

  return true;
}

OneShotBackgroundSyncService_DidResolveRegistration_Params_Data::OneShotBackgroundSyncService_DidResolveRegistration_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OneShotBackgroundSyncService_GetRegistrations_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const OneShotBackgroundSyncService_GetRegistrations_Params_Data* object = static_cast<const OneShotBackgroundSyncService_GetRegistrations_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

OneShotBackgroundSyncService_GetRegistrations_Params_Data::OneShotBackgroundSyncService_GetRegistrations_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OneShotBackgroundSyncService_GetRegistrations_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const OneShotBackgroundSyncService_GetRegistrations_ResponseParams_Data* object = static_cast<const OneShotBackgroundSyncService_GetRegistrations_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::blink::mojom::internal::BackgroundSyncError_Data
        ::Validate(object->err, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->registrations, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams registrations_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->registrations, validation_context,
                                         &registrations_validate_params)) {
    return false;
  }

  return true;
}

OneShotBackgroundSyncService_GetRegistrations_ResponseParams_Data::OneShotBackgroundSyncService_GetRegistrations_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PeriodicBackgroundSyncService_Register_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PeriodicBackgroundSyncService_Register_Params_Data* object = static_cast<const PeriodicBackgroundSyncService_Register_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->options, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->options, validation_context))
    return false;

  return true;
}

PeriodicBackgroundSyncService_Register_Params_Data::PeriodicBackgroundSyncService_Register_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PeriodicBackgroundSyncService_Register_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PeriodicBackgroundSyncService_Register_ResponseParams_Data* object = static_cast<const PeriodicBackgroundSyncService_Register_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::blink::mojom::internal::BackgroundSyncError_Data
        ::Validate(object->err, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->options, validation_context))
    return false;

  return true;
}

PeriodicBackgroundSyncService_Register_ResponseParams_Data::PeriodicBackgroundSyncService_Register_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PeriodicBackgroundSyncService_Unregister_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PeriodicBackgroundSyncService_Unregister_Params_Data* object = static_cast<const PeriodicBackgroundSyncService_Unregister_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->tag, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams tag_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->tag, validation_context,
                                         &tag_validate_params)) {
    return false;
  }

  return true;
}

PeriodicBackgroundSyncService_Unregister_Params_Data::PeriodicBackgroundSyncService_Unregister_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PeriodicBackgroundSyncService_Unregister_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PeriodicBackgroundSyncService_Unregister_ResponseParams_Data* object = static_cast<const PeriodicBackgroundSyncService_Unregister_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::blink::mojom::internal::BackgroundSyncError_Data
        ::Validate(object->err, validation_context))
    return false;

  return true;
}

PeriodicBackgroundSyncService_Unregister_ResponseParams_Data::PeriodicBackgroundSyncService_Unregister_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PeriodicBackgroundSyncService_GetRegistrations_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PeriodicBackgroundSyncService_GetRegistrations_Params_Data* object = static_cast<const PeriodicBackgroundSyncService_GetRegistrations_Params_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  return true;
}

PeriodicBackgroundSyncService_GetRegistrations_Params_Data::PeriodicBackgroundSyncService_GetRegistrations_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PeriodicBackgroundSyncService_GetRegistrations_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PeriodicBackgroundSyncService_GetRegistrations_ResponseParams_Data* object = static_cast<const PeriodicBackgroundSyncService_GetRegistrations_ResponseParams_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);


  if (!::blink::mojom::internal::BackgroundSyncError_Data
        ::Validate(object->err, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->registrations, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams registrations_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->registrations, validation_context,
                                         &registrations_validate_params)) {
    return false;
  }

  return true;
}

PeriodicBackgroundSyncService_GetRegistrations_ResponseParams_Data::PeriodicBackgroundSyncService_GetRegistrations_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::BackgroundSyncError>::WriteIntoTracedValue(
   perfetto::TracedValue context, ::blink::mojom::BackgroundSyncError value) {
  return std::move(context).WriteString(::blink::mojom::BackgroundSyncErrorToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::BackgroundSyncState>::WriteIntoTracedValue(
   perfetto::TracedValue context, ::blink::mojom::BackgroundSyncState value) {
  return std::move(context).WriteString(::blink::mojom::BackgroundSyncStateToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::BackgroundSyncEventLastChance>::WriteIntoTracedValue(
   perfetto::TracedValue context, ::blink::mojom::BackgroundSyncEventLastChance value) {
  return std::move(context).WriteString(::blink::mojom::BackgroundSyncEventLastChanceToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::BackgroundSyncType>::WriteIntoTracedValue(
   perfetto::TracedValue context, ::blink::mojom::BackgroundSyncType value) {
  return std::move(context).WriteString(::blink::mojom::BackgroundSyncTypeToString(value));
}

} // namespace perfetto
