// third_party/blink/public/mojom/federated_learning/floc.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FEDERATED_LEARNING_FLOC_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FEDERATED_LEARNING_FLOC_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/federated_learning/floc.mojom-shared.h"
#include "third_party/blink/public/mojom/federated_learning/floc.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace blink {
namespace mojom {

class FlocServiceProxy;

template <typename ImplRefTraits>
class FlocServiceStub;

class FlocServiceRequestValidator;
class FlocServiceResponseValidator;


class BLINK_COMMON_EXPORT FlocService
    : public FlocServiceInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = FlocServiceInterfaceBase;
  using Proxy_ = FlocServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = FlocServiceStub<ImplRefTraits>;

  using RequestValidator_ = FlocServiceRequestValidator;
  using ResponseValidator_ = FlocServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetInterestCohortMinVersion = 0,
  };
  virtual ~FlocService() {}


  using GetInterestCohortCallback = base::OnceCallback<void(InterestCohortPtr)>;
  
  virtual void GetInterestCohort(GetInterestCohortCallback callback) = 0;
};



class BLINK_COMMON_EXPORT FlocServiceProxy
    : public FlocService {
 public:
  using InterfaceType = FlocService;

  explicit FlocServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetInterestCohort(GetInterestCohortCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT FlocServiceStubDispatch {
 public:
  static bool Accept(FlocService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      FlocService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<FlocService>>
class FlocServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  FlocServiceStub() {}
  ~FlocServiceStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FlocServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FlocServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT FlocServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT FlocServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class BLINK_COMMON_EXPORT InterestCohort {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<InterestCohort, T>::value>;
  using DataView = InterestCohortDataView;
  using Data_ = internal::InterestCohort_Data;

  template <typename... Args>
  static InterestCohortPtr New(Args&&... args) {
    return InterestCohortPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static InterestCohortPtr From(const U& u) {
    return mojo::TypeConverter<InterestCohortPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, InterestCohort>::Convert(*this);
  }


  InterestCohort();

  InterestCohort(
      const std::string& id,
      const std::string& version);

  ~InterestCohort();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = InterestCohortPtr>
  InterestCohortPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, InterestCohort::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, InterestCohort::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        InterestCohort::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        InterestCohort::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::InterestCohort_UnserializedMessageContext<
            UserType, InterestCohort::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<InterestCohort::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return InterestCohort::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::InterestCohort_UnserializedMessageContext<
            UserType, InterestCohort::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<InterestCohort::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string id;
  
  std::string version;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, InterestCohort::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, InterestCohort::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, InterestCohort::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, InterestCohort::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
InterestCohortPtr InterestCohort::Clone() const {
  return New(
      mojo::Clone(id),
      mojo::Clone(version)
  );
}

template <typename T, InterestCohort::EnableIfSame<T>*>
bool InterestCohort::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->id, other_struct.id))
    return false;
  if (!mojo::Equals(this->version, other_struct.version))
    return false;
  return true;
}

template <typename T, InterestCohort::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.id < rhs.id)
    return true;
  if (rhs.id < lhs.id)
    return false;
  if (lhs.version < rhs.version)
    return true;
  if (rhs.version < lhs.version)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::InterestCohort::DataView,
                                         ::blink::mojom::InterestCohortPtr> {
  static bool IsNull(const ::blink::mojom::InterestCohortPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::InterestCohortPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::InterestCohort::id)& id(
      const ::blink::mojom::InterestCohortPtr& input) {
    return input->id;
  }

  static const decltype(::blink::mojom::InterestCohort::version)& version(
      const ::blink::mojom::InterestCohortPtr& input) {
    return input->version;
  }

  static bool Read(::blink::mojom::InterestCohort::DataView input, ::blink::mojom::InterestCohortPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FEDERATED_LEARNING_FLOC_MOJOM_H_