// third_party/blink/public/mojom/font_access/font_access.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FONT_ACCESS_FONT_ACCESS_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FONT_ACCESS_FONT_ACCESS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/font_access/font_access.mojom-shared.h"
#include "third_party/blink/public/mojom/font_access/font_access.mojom-forward.h"
#include "third_party/blink/public/mojom/permissions/permission_status.mojom-forward.h"
#include "mojo/public/mojom/base/shared_memory.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace blink {
namespace mojom {

class FontAccessManagerProxy;

template <typename ImplRefTraits>
class FontAccessManagerStub;

class FontAccessManagerRequestValidator;
class FontAccessManagerResponseValidator;


class BLINK_COMMON_EXPORT FontAccessManager
    : public FontAccessManagerInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = FontAccessManagerInterfaceBase;
  using Proxy_ = FontAccessManagerProxy;

  template <typename ImplRefTraits>
  using Stub_ = FontAccessManagerStub<ImplRefTraits>;

  using RequestValidator_ = FontAccessManagerRequestValidator;
  using ResponseValidator_ = FontAccessManagerResponseValidator;
  enum MethodMinVersions : uint32_t {
    kEnumerateLocalFontsMinVersion = 0,
    kChooseLocalFontsMinVersion = 0,
  };
  virtual ~FontAccessManager() {}


  using EnumerateLocalFontsCallback = base::OnceCallback<void(FontEnumerationStatus, ::base::ReadOnlySharedMemoryRegion)>;
  
  virtual void EnumerateLocalFonts(EnumerateLocalFontsCallback callback) = 0;


  using ChooseLocalFontsCallback = base::OnceCallback<void(FontEnumerationStatus, std::vector<FontMetadataPtr>)>;
  
  virtual void ChooseLocalFonts(const std::vector<std::string>& selection, ChooseLocalFontsCallback callback) = 0;
};



class BLINK_COMMON_EXPORT FontAccessManagerProxy
    : public FontAccessManager {
 public:
  using InterfaceType = FontAccessManager;

  explicit FontAccessManagerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void EnumerateLocalFonts(EnumerateLocalFontsCallback callback) final;
  
  void ChooseLocalFonts(const std::vector<std::string>& selection, ChooseLocalFontsCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT FontAccessManagerStubDispatch {
 public:
  static bool Accept(FontAccessManager* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      FontAccessManager* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<FontAccessManager>>
class FontAccessManagerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  FontAccessManagerStub() {}
  ~FontAccessManagerStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FontAccessManagerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FontAccessManagerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT FontAccessManagerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT FontAccessManagerResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class BLINK_COMMON_EXPORT FontMetadata {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FontMetadata, T>::value>;
  using DataView = FontMetadataDataView;
  using Data_ = internal::FontMetadata_Data;

  template <typename... Args>
  static FontMetadataPtr New(Args&&... args) {
    return FontMetadataPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FontMetadataPtr From(const U& u) {
    return mojo::TypeConverter<FontMetadataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FontMetadata>::Convert(*this);
  }


  FontMetadata();

  FontMetadata(
      const std::string& postscript_name,
      const std::string& full_name,
      const std::string& family);

  ~FontMetadata();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FontMetadataPtr>
  FontMetadataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FontMetadata::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, FontMetadata::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FontMetadata::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FontMetadata::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FontMetadata_UnserializedMessageContext<
            UserType, FontMetadata::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<FontMetadata::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return FontMetadata::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FontMetadata_UnserializedMessageContext<
            UserType, FontMetadata::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FontMetadata::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string postscript_name;
  
  std::string full_name;
  
  std::string family;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FontMetadata::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FontMetadata::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FontMetadata::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FontMetadata::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
FontMetadataPtr FontMetadata::Clone() const {
  return New(
      mojo::Clone(postscript_name),
      mojo::Clone(full_name),
      mojo::Clone(family)
  );
}

template <typename T, FontMetadata::EnableIfSame<T>*>
bool FontMetadata::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->postscript_name, other_struct.postscript_name))
    return false;
  if (!mojo::Equals(this->full_name, other_struct.full_name))
    return false;
  if (!mojo::Equals(this->family, other_struct.family))
    return false;
  return true;
}

template <typename T, FontMetadata::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.postscript_name < rhs.postscript_name)
    return true;
  if (rhs.postscript_name < lhs.postscript_name)
    return false;
  if (lhs.full_name < rhs.full_name)
    return true;
  if (rhs.full_name < lhs.full_name)
    return false;
  if (lhs.family < rhs.family)
    return true;
  if (rhs.family < lhs.family)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::FontMetadata::DataView,
                                         ::blink::mojom::FontMetadataPtr> {
  static bool IsNull(const ::blink::mojom::FontMetadataPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::FontMetadataPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::FontMetadata::postscript_name)& postscript_name(
      const ::blink::mojom::FontMetadataPtr& input) {
    return input->postscript_name;
  }

  static const decltype(::blink::mojom::FontMetadata::full_name)& full_name(
      const ::blink::mojom::FontMetadataPtr& input) {
    return input->full_name;
  }

  static const decltype(::blink::mojom::FontMetadata::family)& family(
      const ::blink::mojom::FontMetadataPtr& input) {
    return input->family;
  }

  static bool Read(::blink::mojom::FontMetadata::DataView input, ::blink::mojom::FontMetadataPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FONT_ACCESS_FONT_ACCESS_MOJOM_H_