// third_party/blink/public/mojom/frame/policy_container.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_POLICY_CONTAINER_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_POLICY_CONTAINER_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/frame/policy_container.mojom-shared.h"
#include "third_party/blink/public/mojom/frame/policy_container.mojom-blink-forward.h"
#include "services/network/public/mojom/ip_address_space.mojom-blink-forward.h"
#include "services/network/public/mojom/referrer_policy.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/renderer/platform/platform_export.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace blink {
namespace mojom {
namespace blink {

class PolicyContainerHostProxy;

template <typename ImplRefTraits>
class PolicyContainerHostStub;

class PolicyContainerHostRequestValidator;


class PLATFORM_EXPORT PolicyContainerHost
    : public PolicyContainerHostInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = PolicyContainerHostInterfaceBase;
  using Proxy_ = PolicyContainerHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = PolicyContainerHostStub<ImplRefTraits>;

  using RequestValidator_ = PolicyContainerHostRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kSetReferrerPolicyMinVersion = 0,
    kIssueKeepAliveHandleMinVersion = 0,
  };
  virtual ~PolicyContainerHost() {}

  
  virtual void SetReferrerPolicy(::network::mojom::blink::ReferrerPolicy referrer_policy) = 0;

  
  virtual void IssueKeepAliveHandle(::mojo::PendingReceiver<PolicyContainerHostKeepAliveHandle> receiver) = 0;
};

class PolicyContainerHostKeepAliveHandleProxy;

template <typename ImplRefTraits>
class PolicyContainerHostKeepAliveHandleStub;

class PolicyContainerHostKeepAliveHandleRequestValidator;


class PLATFORM_EXPORT PolicyContainerHostKeepAliveHandle
    : public PolicyContainerHostKeepAliveHandleInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = PolicyContainerHostKeepAliveHandleInterfaceBase;
  using Proxy_ = PolicyContainerHostKeepAliveHandleProxy;

  template <typename ImplRefTraits>
  using Stub_ = PolicyContainerHostKeepAliveHandleStub<ImplRefTraits>;

  using RequestValidator_ = PolicyContainerHostKeepAliveHandleRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
  };
  virtual ~PolicyContainerHostKeepAliveHandle() {}
};



class PLATFORM_EXPORT PolicyContainerHostProxy
    : public PolicyContainerHost {
 public:
  using InterfaceType = PolicyContainerHost;

  explicit PolicyContainerHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void SetReferrerPolicy(::network::mojom::blink::ReferrerPolicy referrer_policy) final;
  
  void IssueKeepAliveHandle(::mojo::PendingReceiver<PolicyContainerHostKeepAliveHandle> receiver) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class PLATFORM_EXPORT PolicyContainerHostKeepAliveHandleProxy
    : public PolicyContainerHostKeepAliveHandle {
 public:
  using InterfaceType = PolicyContainerHostKeepAliveHandle;

  explicit PolicyContainerHostKeepAliveHandleProxy(mojo::MessageReceiverWithResponder* receiver);

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class PLATFORM_EXPORT PolicyContainerHostStubDispatch {
 public:
  static bool Accept(PolicyContainerHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PolicyContainerHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PolicyContainerHost>>
class PolicyContainerHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PolicyContainerHostStub() {}
  ~PolicyContainerHostStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PolicyContainerHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PolicyContainerHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT PolicyContainerHostKeepAliveHandleStubDispatch {
 public:
  static bool Accept(PolicyContainerHostKeepAliveHandle* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PolicyContainerHostKeepAliveHandle* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PolicyContainerHostKeepAliveHandle>>
class PolicyContainerHostKeepAliveHandleStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PolicyContainerHostKeepAliveHandleStub() {}
  ~PolicyContainerHostKeepAliveHandleStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PolicyContainerHostKeepAliveHandleStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PolicyContainerHostKeepAliveHandleStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT PolicyContainerHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT PolicyContainerHostKeepAliveHandleRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class PLATFORM_EXPORT PolicyContainerPolicies {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PolicyContainerPolicies, T>::value>;
  using DataView = PolicyContainerPoliciesDataView;
  using Data_ = internal::PolicyContainerPolicies_Data;

  template <typename... Args>
  static PolicyContainerPoliciesPtr New(Args&&... args) {
    return PolicyContainerPoliciesPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PolicyContainerPoliciesPtr From(const U& u) {
    return mojo::TypeConverter<PolicyContainerPoliciesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PolicyContainerPolicies>::Convert(*this);
  }


  PolicyContainerPolicies();

  PolicyContainerPolicies(
      ::network::mojom::blink::ReferrerPolicy referrer_policy,
      ::network::mojom::blink::IPAddressSpace ip_address_space);

  ~PolicyContainerPolicies();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PolicyContainerPoliciesPtr>
  PolicyContainerPoliciesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PolicyContainerPolicies::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, PolicyContainerPolicies::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PolicyContainerPolicies::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PolicyContainerPolicies::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PolicyContainerPolicies_UnserializedMessageContext<
            UserType, PolicyContainerPolicies::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<PolicyContainerPolicies::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return PolicyContainerPolicies::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PolicyContainerPolicies_UnserializedMessageContext<
            UserType, PolicyContainerPolicies::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PolicyContainerPolicies::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::network::mojom::blink::ReferrerPolicy referrer_policy;
  
  ::network::mojom::blink::IPAddressSpace ip_address_space;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PolicyContainerPolicies::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PolicyContainerPolicies::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PolicyContainerPolicies::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PolicyContainerPolicies::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}










class PLATFORM_EXPORT PolicyContainer {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PolicyContainer, T>::value>;
  using DataView = PolicyContainerDataView;
  using Data_ = internal::PolicyContainer_Data;

  template <typename... Args>
  static PolicyContainerPtr New(Args&&... args) {
    return PolicyContainerPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PolicyContainerPtr From(const U& u) {
    return mojo::TypeConverter<PolicyContainerPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PolicyContainer>::Convert(*this);
  }


  PolicyContainer();

  PolicyContainer(
      PolicyContainerPoliciesPtr policies,
      ::mojo::PendingAssociatedRemote<PolicyContainerHost> remote);

  ~PolicyContainer();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PolicyContainerPtr>
  PolicyContainerPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PolicyContainer::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, PolicyContainer::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PolicyContainer::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PolicyContainer_UnserializedMessageContext<
            UserType, PolicyContainer::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<PolicyContainer::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return PolicyContainer::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PolicyContainer_UnserializedMessageContext<
            UserType, PolicyContainer::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PolicyContainer::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  PolicyContainerPoliciesPtr policies;
  
  ::mojo::PendingAssociatedRemote<PolicyContainerHost> remote;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(PolicyContainer);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PolicyContainer::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PolicyContainer::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PolicyContainer::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PolicyContainer::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class PLATFORM_EXPORT PolicyContainerBindParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PolicyContainerBindParams, T>::value>;
  using DataView = PolicyContainerBindParamsDataView;
  using Data_ = internal::PolicyContainerBindParams_Data;

  template <typename... Args>
  static PolicyContainerBindParamsPtr New(Args&&... args) {
    return PolicyContainerBindParamsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PolicyContainerBindParamsPtr From(const U& u) {
    return mojo::TypeConverter<PolicyContainerBindParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PolicyContainerBindParams>::Convert(*this);
  }


  PolicyContainerBindParams();

  explicit PolicyContainerBindParams(
      ::mojo::PendingAssociatedReceiver<PolicyContainerHost> receiver);

  ~PolicyContainerBindParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PolicyContainerBindParamsPtr>
  PolicyContainerBindParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PolicyContainerBindParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, PolicyContainerBindParams::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PolicyContainerBindParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PolicyContainerBindParams_UnserializedMessageContext<
            UserType, PolicyContainerBindParams::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<PolicyContainerBindParams::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return PolicyContainerBindParams::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PolicyContainerBindParams_UnserializedMessageContext<
            UserType, PolicyContainerBindParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PolicyContainerBindParams::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::mojo::PendingAssociatedReceiver<PolicyContainerHost> receiver;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(PolicyContainerBindParams);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PolicyContainerBindParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PolicyContainerBindParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PolicyContainerBindParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PolicyContainerBindParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
PolicyContainerPoliciesPtr PolicyContainerPolicies::Clone() const {
  return New(
      mojo::Clone(referrer_policy),
      mojo::Clone(ip_address_space)
  );
}

template <typename T, PolicyContainerPolicies::EnableIfSame<T>*>
bool PolicyContainerPolicies::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->referrer_policy, other_struct.referrer_policy))
    return false;
  if (!mojo::Equals(this->ip_address_space, other_struct.ip_address_space))
    return false;
  return true;
}

template <typename T, PolicyContainerPolicies::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.referrer_policy < rhs.referrer_policy)
    return true;
  if (rhs.referrer_policy < lhs.referrer_policy)
    return false;
  if (lhs.ip_address_space < rhs.ip_address_space)
    return true;
  if (rhs.ip_address_space < lhs.ip_address_space)
    return false;
  return false;
}
template <typename StructPtrType>
PolicyContainerPtr PolicyContainer::Clone() const {
  return New(
      mojo::Clone(policies),
      mojo::Clone(remote)
  );
}

template <typename T, PolicyContainer::EnableIfSame<T>*>
bool PolicyContainer::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->policies, other_struct.policies))
    return false;
  if (!mojo::Equals(this->remote, other_struct.remote))
    return false;
  return true;
}

template <typename T, PolicyContainer::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.policies < rhs.policies)
    return true;
  if (rhs.policies < lhs.policies)
    return false;
  if (lhs.remote < rhs.remote)
    return true;
  if (rhs.remote < lhs.remote)
    return false;
  return false;
}
template <typename StructPtrType>
PolicyContainerBindParamsPtr PolicyContainerBindParams::Clone() const {
  return New(
      mojo::Clone(receiver)
  );
}

template <typename T, PolicyContainerBindParams::EnableIfSame<T>*>
bool PolicyContainerBindParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->receiver, other_struct.receiver))
    return false;
  return true;
}

template <typename T, PolicyContainerBindParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.receiver < rhs.receiver)
    return true;
  if (rhs.receiver < lhs.receiver)
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::PolicyContainerPolicies::DataView,
                                         ::blink::mojom::blink::PolicyContainerPoliciesPtr> {
  static bool IsNull(const ::blink::mojom::blink::PolicyContainerPoliciesPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::PolicyContainerPoliciesPtr* output) { output->reset(); }

  static decltype(::blink::mojom::blink::PolicyContainerPolicies::referrer_policy) referrer_policy(
      const ::blink::mojom::blink::PolicyContainerPoliciesPtr& input) {
    return input->referrer_policy;
  }

  static decltype(::blink::mojom::blink::PolicyContainerPolicies::ip_address_space) ip_address_space(
      const ::blink::mojom::blink::PolicyContainerPoliciesPtr& input) {
    return input->ip_address_space;
  }

  static bool Read(::blink::mojom::blink::PolicyContainerPolicies::DataView input, ::blink::mojom::blink::PolicyContainerPoliciesPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::PolicyContainer::DataView,
                                         ::blink::mojom::blink::PolicyContainerPtr> {
  static bool IsNull(const ::blink::mojom::blink::PolicyContainerPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::PolicyContainerPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::PolicyContainer::policies)& policies(
      const ::blink::mojom::blink::PolicyContainerPtr& input) {
    return input->policies;
  }

  static  decltype(::blink::mojom::blink::PolicyContainer::remote)& remote(
       ::blink::mojom::blink::PolicyContainerPtr& input) {
    return input->remote;
  }

  static bool Read(::blink::mojom::blink::PolicyContainer::DataView input, ::blink::mojom::blink::PolicyContainerPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::PolicyContainerBindParams::DataView,
                                         ::blink::mojom::blink::PolicyContainerBindParamsPtr> {
  static bool IsNull(const ::blink::mojom::blink::PolicyContainerBindParamsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::PolicyContainerBindParamsPtr* output) { output->reset(); }

  static  decltype(::blink::mojom::blink::PolicyContainerBindParams::receiver)& receiver(
       ::blink::mojom::blink::PolicyContainerBindParamsPtr& input) {
    return input->receiver;
  }

  static bool Read(::blink::mojom::blink::PolicyContainerBindParams::DataView input, ::blink::mojom::blink::PolicyContainerBindParamsPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_POLICY_CONTAINER_MOJOM_BLINK_H_