// third_party/blink/public/mojom/handwriting/handwriting.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_HANDWRITING_HANDWRITING_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_HANDWRITING_HANDWRITING_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/handwriting/handwriting.mojom-shared.h"
#include "third_party/blink/public/mojom/handwriting/handwriting.mojom-forward.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "ui/gfx/geometry/mojom/geometry.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace handwriting {
namespace mojom {

class HandwritingRecognizerProxy;

template <typename ImplRefTraits>
class HandwritingRecognizerStub;

class HandwritingRecognizerRequestValidator;
class HandwritingRecognizerResponseValidator;


class BLINK_COMMON_EXPORT HandwritingRecognizer
    : public HandwritingRecognizerInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = HandwritingRecognizerInterfaceBase;
  using Proxy_ = HandwritingRecognizerProxy;

  template <typename ImplRefTraits>
  using Stub_ = HandwritingRecognizerStub<ImplRefTraits>;

  using RequestValidator_ = HandwritingRecognizerRequestValidator;
  using ResponseValidator_ = HandwritingRecognizerResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetPredictionMinVersion = 0,
  };
  virtual ~HandwritingRecognizer() {}


  using GetPredictionCallback = base::OnceCallback<void(base::Optional<std::vector<HandwritingPredictionPtr>>)>;
  
  virtual void GetPrediction(std::vector<HandwritingStrokePtr> strokes, HandwritingHintsPtr hints, GetPredictionCallback callback) = 0;
};

class HandwritingRecognitionServiceProxy;

template <typename ImplRefTraits>
class HandwritingRecognitionServiceStub;

class HandwritingRecognitionServiceRequestValidator;
class HandwritingRecognitionServiceResponseValidator;


class BLINK_COMMON_EXPORT HandwritingRecognitionService
    : public HandwritingRecognitionServiceInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = HandwritingRecognitionServiceInterfaceBase;
  using Proxy_ = HandwritingRecognitionServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = HandwritingRecognitionServiceStub<ImplRefTraits>;

  using RequestValidator_ = HandwritingRecognitionServiceRequestValidator;
  using ResponseValidator_ = HandwritingRecognitionServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCreateHandwritingRecognizerMinVersion = 0,
    kQueryHandwritingRecognizerSupportMinVersion = 0,
  };
  virtual ~HandwritingRecognitionService() {}


  using CreateHandwritingRecognizerCallback = base::OnceCallback<void(CreateHandwritingRecognizerResult, ::mojo::PendingRemote<HandwritingRecognizer>)>;
  
  virtual void CreateHandwritingRecognizer(HandwritingModelConstraintPtr constraint, CreateHandwritingRecognizerCallback callback) = 0;


  using QueryHandwritingRecognizerSupportCallback = base::OnceCallback<void(HandwritingFeatureQueryResultPtr)>;
  
  virtual void QueryHandwritingRecognizerSupport(HandwritingFeatureQueryPtr query, QueryHandwritingRecognizerSupportCallback callback) = 0;
};



class BLINK_COMMON_EXPORT HandwritingRecognizerProxy
    : public HandwritingRecognizer {
 public:
  using InterfaceType = HandwritingRecognizer;

  explicit HandwritingRecognizerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetPrediction(std::vector<HandwritingStrokePtr> strokes, HandwritingHintsPtr hints, GetPredictionCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class BLINK_COMMON_EXPORT HandwritingRecognitionServiceProxy
    : public HandwritingRecognitionService {
 public:
  using InterfaceType = HandwritingRecognitionService;

  explicit HandwritingRecognitionServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateHandwritingRecognizer(HandwritingModelConstraintPtr constraint, CreateHandwritingRecognizerCallback callback) final;
  
  void QueryHandwritingRecognizerSupport(HandwritingFeatureQueryPtr query, QueryHandwritingRecognizerSupportCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT HandwritingRecognizerStubDispatch {
 public:
  static bool Accept(HandwritingRecognizer* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      HandwritingRecognizer* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<HandwritingRecognizer>>
class HandwritingRecognizerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  HandwritingRecognizerStub() {}
  ~HandwritingRecognizerStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return HandwritingRecognizerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return HandwritingRecognizerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT HandwritingRecognitionServiceStubDispatch {
 public:
  static bool Accept(HandwritingRecognitionService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      HandwritingRecognitionService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<HandwritingRecognitionService>>
class HandwritingRecognitionServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  HandwritingRecognitionServiceStub() {}
  ~HandwritingRecognitionServiceStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return HandwritingRecognitionServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return HandwritingRecognitionServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT HandwritingRecognizerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT HandwritingRecognitionServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT HandwritingRecognizerResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT HandwritingRecognitionServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};







class BLINK_COMMON_EXPORT HandwritingDrawingSegment {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<HandwritingDrawingSegment, T>::value>;
  using DataView = HandwritingDrawingSegmentDataView;
  using Data_ = internal::HandwritingDrawingSegment_Data;

  template <typename... Args>
  static HandwritingDrawingSegmentPtr New(Args&&... args) {
    return HandwritingDrawingSegmentPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static HandwritingDrawingSegmentPtr From(const U& u) {
    return mojo::TypeConverter<HandwritingDrawingSegmentPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, HandwritingDrawingSegment>::Convert(*this);
  }


  HandwritingDrawingSegment();

  HandwritingDrawingSegment(
      uint32_t stroke_index,
      uint32_t begin_point_index,
      uint32_t end_point_index);

  ~HandwritingDrawingSegment();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = HandwritingDrawingSegmentPtr>
  HandwritingDrawingSegmentPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, HandwritingDrawingSegment::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, HandwritingDrawingSegment::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        HandwritingDrawingSegment::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        HandwritingDrawingSegment::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::HandwritingDrawingSegment_UnserializedMessageContext<
            UserType, HandwritingDrawingSegment::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<HandwritingDrawingSegment::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return HandwritingDrawingSegment::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::HandwritingDrawingSegment_UnserializedMessageContext<
            UserType, HandwritingDrawingSegment::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<HandwritingDrawingSegment::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint32_t stroke_index;
  
  uint32_t begin_point_index;
  
  uint32_t end_point_index;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, HandwritingDrawingSegment::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, HandwritingDrawingSegment::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, HandwritingDrawingSegment::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, HandwritingDrawingSegment::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class BLINK_COMMON_EXPORT HandwritingHints {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<HandwritingHints, T>::value>;
  using DataView = HandwritingHintsDataView;
  using Data_ = internal::HandwritingHints_Data;

  template <typename... Args>
  static HandwritingHintsPtr New(Args&&... args) {
    return HandwritingHintsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static HandwritingHintsPtr From(const U& u) {
    return mojo::TypeConverter<HandwritingHintsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, HandwritingHints>::Convert(*this);
  }


  HandwritingHints();

  HandwritingHints(
      const std::string& recognition_type,
      const std::string& input_type,
      const std::string& text_context,
      uint32_t alternatives);

  ~HandwritingHints();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = HandwritingHintsPtr>
  HandwritingHintsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, HandwritingHints::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, HandwritingHints::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        HandwritingHints::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        HandwritingHints::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::HandwritingHints_UnserializedMessageContext<
            UserType, HandwritingHints::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<HandwritingHints::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return HandwritingHints::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::HandwritingHints_UnserializedMessageContext<
            UserType, HandwritingHints::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<HandwritingHints::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string recognition_type;
  
  std::string input_type;
  
  std::string text_context;
  
  uint32_t alternatives;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, HandwritingHints::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, HandwritingHints::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, HandwritingHints::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, HandwritingHints::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class BLINK_COMMON_EXPORT HandwritingFeatureQueryResult {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<HandwritingFeatureQueryResult, T>::value>;
  using DataView = HandwritingFeatureQueryResultDataView;
  using Data_ = internal::HandwritingFeatureQueryResult_Data;

  template <typename... Args>
  static HandwritingFeatureQueryResultPtr New(Args&&... args) {
    return HandwritingFeatureQueryResultPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static HandwritingFeatureQueryResultPtr From(const U& u) {
    return mojo::TypeConverter<HandwritingFeatureQueryResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, HandwritingFeatureQueryResult>::Convert(*this);
  }


  HandwritingFeatureQueryResult();

  HandwritingFeatureQueryResult(
      HandwritingFeatureStatus languages,
      HandwritingFeatureStatus alternatives,
      HandwritingFeatureStatus segmentation_result);

  ~HandwritingFeatureQueryResult();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = HandwritingFeatureQueryResultPtr>
  HandwritingFeatureQueryResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, HandwritingFeatureQueryResult::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, HandwritingFeatureQueryResult::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        HandwritingFeatureQueryResult::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        HandwritingFeatureQueryResult::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::HandwritingFeatureQueryResult_UnserializedMessageContext<
            UserType, HandwritingFeatureQueryResult::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<HandwritingFeatureQueryResult::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return HandwritingFeatureQueryResult::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::HandwritingFeatureQueryResult_UnserializedMessageContext<
            UserType, HandwritingFeatureQueryResult::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<HandwritingFeatureQueryResult::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  HandwritingFeatureStatus languages;
  
  HandwritingFeatureStatus alternatives;
  
  HandwritingFeatureStatus segmentation_result;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, HandwritingFeatureQueryResult::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, HandwritingFeatureQueryResult::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, HandwritingFeatureQueryResult::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, HandwritingFeatureQueryResult::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}








class BLINK_COMMON_EXPORT HandwritingPoint {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<HandwritingPoint, T>::value>;
  using DataView = HandwritingPointDataView;
  using Data_ = internal::HandwritingPoint_Data;

  template <typename... Args>
  static HandwritingPointPtr New(Args&&... args) {
    return HandwritingPointPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static HandwritingPointPtr From(const U& u) {
    return mojo::TypeConverter<HandwritingPointPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, HandwritingPoint>::Convert(*this);
  }


  HandwritingPoint();

  HandwritingPoint(
      const ::gfx::PointF& location,
      ::base::TimeDelta t);

  ~HandwritingPoint();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = HandwritingPointPtr>
  HandwritingPointPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, HandwritingPoint::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, HandwritingPoint::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        HandwritingPoint::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        HandwritingPoint::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::HandwritingPoint_UnserializedMessageContext<
            UserType, HandwritingPoint::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<HandwritingPoint::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return HandwritingPoint::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::HandwritingPoint_UnserializedMessageContext<
            UserType, HandwritingPoint::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<HandwritingPoint::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::gfx::PointF location;
  
  ::base::TimeDelta t;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, HandwritingPoint::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, HandwritingPoint::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, HandwritingPoint::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, HandwritingPoint::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT HandwritingStroke {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<HandwritingStroke, T>::value>;
  using DataView = HandwritingStrokeDataView;
  using Data_ = internal::HandwritingStroke_Data;

  template <typename... Args>
  static HandwritingStrokePtr New(Args&&... args) {
    return HandwritingStrokePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static HandwritingStrokePtr From(const U& u) {
    return mojo::TypeConverter<HandwritingStrokePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, HandwritingStroke>::Convert(*this);
  }


  HandwritingStroke();

  explicit HandwritingStroke(
      std::vector<HandwritingPointPtr> points);

  ~HandwritingStroke();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = HandwritingStrokePtr>
  HandwritingStrokePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, HandwritingStroke::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, HandwritingStroke::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        HandwritingStroke::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        HandwritingStroke::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::HandwritingStroke_UnserializedMessageContext<
            UserType, HandwritingStroke::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<HandwritingStroke::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return HandwritingStroke::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::HandwritingStroke_UnserializedMessageContext<
            UserType, HandwritingStroke::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<HandwritingStroke::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::vector<HandwritingPointPtr> points;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(HandwritingStroke);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, HandwritingStroke::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, HandwritingStroke::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, HandwritingStroke::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, HandwritingStroke::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class BLINK_COMMON_EXPORT HandwritingSegment {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<HandwritingSegment, T>::value>;
  using DataView = HandwritingSegmentDataView;
  using Data_ = internal::HandwritingSegment_Data;

  template <typename... Args>
  static HandwritingSegmentPtr New(Args&&... args) {
    return HandwritingSegmentPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static HandwritingSegmentPtr From(const U& u) {
    return mojo::TypeConverter<HandwritingSegmentPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, HandwritingSegment>::Convert(*this);
  }


  HandwritingSegment();

  HandwritingSegment(
      const std::string& grapheme,
      uint32_t begin_index,
      uint32_t end_index,
      std::vector<HandwritingDrawingSegmentPtr> drawing_segments);

  ~HandwritingSegment();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = HandwritingSegmentPtr>
  HandwritingSegmentPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, HandwritingSegment::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, HandwritingSegment::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        HandwritingSegment::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        HandwritingSegment::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::HandwritingSegment_UnserializedMessageContext<
            UserType, HandwritingSegment::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<HandwritingSegment::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return HandwritingSegment::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::HandwritingSegment_UnserializedMessageContext<
            UserType, HandwritingSegment::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<HandwritingSegment::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string grapheme;
  
  uint32_t begin_index;
  
  uint32_t end_index;
  
  std::vector<HandwritingDrawingSegmentPtr> drawing_segments;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(HandwritingSegment);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, HandwritingSegment::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, HandwritingSegment::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, HandwritingSegment::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, HandwritingSegment::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT HandwritingPrediction {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<HandwritingPrediction, T>::value>;
  using DataView = HandwritingPredictionDataView;
  using Data_ = internal::HandwritingPrediction_Data;

  template <typename... Args>
  static HandwritingPredictionPtr New(Args&&... args) {
    return HandwritingPredictionPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static HandwritingPredictionPtr From(const U& u) {
    return mojo::TypeConverter<HandwritingPredictionPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, HandwritingPrediction>::Convert(*this);
  }


  HandwritingPrediction();

  HandwritingPrediction(
      const std::string& text,
      std::vector<HandwritingSegmentPtr> segmentation_result);

  ~HandwritingPrediction();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = HandwritingPredictionPtr>
  HandwritingPredictionPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, HandwritingPrediction::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, HandwritingPrediction::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        HandwritingPrediction::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        HandwritingPrediction::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::HandwritingPrediction_UnserializedMessageContext<
            UserType, HandwritingPrediction::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<HandwritingPrediction::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return HandwritingPrediction::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::HandwritingPrediction_UnserializedMessageContext<
            UserType, HandwritingPrediction::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<HandwritingPrediction::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string text;
  
  std::vector<HandwritingSegmentPtr> segmentation_result;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(HandwritingPrediction);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, HandwritingPrediction::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, HandwritingPrediction::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, HandwritingPrediction::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, HandwritingPrediction::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class BLINK_COMMON_EXPORT HandwritingFeatureQuery {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<HandwritingFeatureQuery, T>::value>;
  using DataView = HandwritingFeatureQueryDataView;
  using Data_ = internal::HandwritingFeatureQuery_Data;

  template <typename... Args>
  static HandwritingFeatureQueryPtr New(Args&&... args) {
    return HandwritingFeatureQueryPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static HandwritingFeatureQueryPtr From(const U& u) {
    return mojo::TypeConverter<HandwritingFeatureQueryPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, HandwritingFeatureQuery>::Convert(*this);
  }


  HandwritingFeatureQuery();

  HandwritingFeatureQuery(
      std::vector<std::string> languages,
      bool alternatives,
      bool segmentation_result);

  ~HandwritingFeatureQuery();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = HandwritingFeatureQueryPtr>
  HandwritingFeatureQueryPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, HandwritingFeatureQuery::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, HandwritingFeatureQuery::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        HandwritingFeatureQuery::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        HandwritingFeatureQuery::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::HandwritingFeatureQuery_UnserializedMessageContext<
            UserType, HandwritingFeatureQuery::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<HandwritingFeatureQuery::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return HandwritingFeatureQuery::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::HandwritingFeatureQuery_UnserializedMessageContext<
            UserType, HandwritingFeatureQuery::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<HandwritingFeatureQuery::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::vector<std::string> languages;
  
  bool alternatives;
  
  bool segmentation_result;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, HandwritingFeatureQuery::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, HandwritingFeatureQuery::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, HandwritingFeatureQuery::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, HandwritingFeatureQuery::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class BLINK_COMMON_EXPORT HandwritingModelConstraint {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<HandwritingModelConstraint, T>::value>;
  using DataView = HandwritingModelConstraintDataView;
  using Data_ = internal::HandwritingModelConstraint_Data;

  template <typename... Args>
  static HandwritingModelConstraintPtr New(Args&&... args) {
    return HandwritingModelConstraintPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static HandwritingModelConstraintPtr From(const U& u) {
    return mojo::TypeConverter<HandwritingModelConstraintPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, HandwritingModelConstraint>::Convert(*this);
  }


  HandwritingModelConstraint();

  explicit HandwritingModelConstraint(
      std::vector<std::string> languages);

  ~HandwritingModelConstraint();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = HandwritingModelConstraintPtr>
  HandwritingModelConstraintPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, HandwritingModelConstraint::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, HandwritingModelConstraint::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        HandwritingModelConstraint::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        HandwritingModelConstraint::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::HandwritingModelConstraint_UnserializedMessageContext<
            UserType, HandwritingModelConstraint::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<HandwritingModelConstraint::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return HandwritingModelConstraint::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::HandwritingModelConstraint_UnserializedMessageContext<
            UserType, HandwritingModelConstraint::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<HandwritingModelConstraint::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::vector<std::string> languages;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, HandwritingModelConstraint::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, HandwritingModelConstraint::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, HandwritingModelConstraint::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, HandwritingModelConstraint::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
HandwritingPointPtr HandwritingPoint::Clone() const {
  return New(
      mojo::Clone(location),
      mojo::Clone(t)
  );
}

template <typename T, HandwritingPoint::EnableIfSame<T>*>
bool HandwritingPoint::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->location, other_struct.location))
    return false;
  if (!mojo::Equals(this->t, other_struct.t))
    return false;
  return true;
}

template <typename T, HandwritingPoint::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.location < rhs.location)
    return true;
  if (rhs.location < lhs.location)
    return false;
  if (lhs.t < rhs.t)
    return true;
  if (rhs.t < lhs.t)
    return false;
  return false;
}
template <typename StructPtrType>
HandwritingStrokePtr HandwritingStroke::Clone() const {
  return New(
      mojo::Clone(points)
  );
}

template <typename T, HandwritingStroke::EnableIfSame<T>*>
bool HandwritingStroke::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->points, other_struct.points))
    return false;
  return true;
}

template <typename T, HandwritingStroke::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.points < rhs.points)
    return true;
  if (rhs.points < lhs.points)
    return false;
  return false;
}
template <typename StructPtrType>
HandwritingDrawingSegmentPtr HandwritingDrawingSegment::Clone() const {
  return New(
      mojo::Clone(stroke_index),
      mojo::Clone(begin_point_index),
      mojo::Clone(end_point_index)
  );
}

template <typename T, HandwritingDrawingSegment::EnableIfSame<T>*>
bool HandwritingDrawingSegment::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->stroke_index, other_struct.stroke_index))
    return false;
  if (!mojo::Equals(this->begin_point_index, other_struct.begin_point_index))
    return false;
  if (!mojo::Equals(this->end_point_index, other_struct.end_point_index))
    return false;
  return true;
}

template <typename T, HandwritingDrawingSegment::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.stroke_index < rhs.stroke_index)
    return true;
  if (rhs.stroke_index < lhs.stroke_index)
    return false;
  if (lhs.begin_point_index < rhs.begin_point_index)
    return true;
  if (rhs.begin_point_index < lhs.begin_point_index)
    return false;
  if (lhs.end_point_index < rhs.end_point_index)
    return true;
  if (rhs.end_point_index < lhs.end_point_index)
    return false;
  return false;
}
template <typename StructPtrType>
HandwritingSegmentPtr HandwritingSegment::Clone() const {
  return New(
      mojo::Clone(grapheme),
      mojo::Clone(begin_index),
      mojo::Clone(end_index),
      mojo::Clone(drawing_segments)
  );
}

template <typename T, HandwritingSegment::EnableIfSame<T>*>
bool HandwritingSegment::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->grapheme, other_struct.grapheme))
    return false;
  if (!mojo::Equals(this->begin_index, other_struct.begin_index))
    return false;
  if (!mojo::Equals(this->end_index, other_struct.end_index))
    return false;
  if (!mojo::Equals(this->drawing_segments, other_struct.drawing_segments))
    return false;
  return true;
}

template <typename T, HandwritingSegment::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.grapheme < rhs.grapheme)
    return true;
  if (rhs.grapheme < lhs.grapheme)
    return false;
  if (lhs.begin_index < rhs.begin_index)
    return true;
  if (rhs.begin_index < lhs.begin_index)
    return false;
  if (lhs.end_index < rhs.end_index)
    return true;
  if (rhs.end_index < lhs.end_index)
    return false;
  if (lhs.drawing_segments < rhs.drawing_segments)
    return true;
  if (rhs.drawing_segments < lhs.drawing_segments)
    return false;
  return false;
}
template <typename StructPtrType>
HandwritingPredictionPtr HandwritingPrediction::Clone() const {
  return New(
      mojo::Clone(text),
      mojo::Clone(segmentation_result)
  );
}

template <typename T, HandwritingPrediction::EnableIfSame<T>*>
bool HandwritingPrediction::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->text, other_struct.text))
    return false;
  if (!mojo::Equals(this->segmentation_result, other_struct.segmentation_result))
    return false;
  return true;
}

template <typename T, HandwritingPrediction::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.text < rhs.text)
    return true;
  if (rhs.text < lhs.text)
    return false;
  if (lhs.segmentation_result < rhs.segmentation_result)
    return true;
  if (rhs.segmentation_result < lhs.segmentation_result)
    return false;
  return false;
}
template <typename StructPtrType>
HandwritingHintsPtr HandwritingHints::Clone() const {
  return New(
      mojo::Clone(recognition_type),
      mojo::Clone(input_type),
      mojo::Clone(text_context),
      mojo::Clone(alternatives)
  );
}

template <typename T, HandwritingHints::EnableIfSame<T>*>
bool HandwritingHints::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->recognition_type, other_struct.recognition_type))
    return false;
  if (!mojo::Equals(this->input_type, other_struct.input_type))
    return false;
  if (!mojo::Equals(this->text_context, other_struct.text_context))
    return false;
  if (!mojo::Equals(this->alternatives, other_struct.alternatives))
    return false;
  return true;
}

template <typename T, HandwritingHints::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.recognition_type < rhs.recognition_type)
    return true;
  if (rhs.recognition_type < lhs.recognition_type)
    return false;
  if (lhs.input_type < rhs.input_type)
    return true;
  if (rhs.input_type < lhs.input_type)
    return false;
  if (lhs.text_context < rhs.text_context)
    return true;
  if (rhs.text_context < lhs.text_context)
    return false;
  if (lhs.alternatives < rhs.alternatives)
    return true;
  if (rhs.alternatives < lhs.alternatives)
    return false;
  return false;
}
template <typename StructPtrType>
HandwritingFeatureQueryPtr HandwritingFeatureQuery::Clone() const {
  return New(
      mojo::Clone(languages),
      mojo::Clone(alternatives),
      mojo::Clone(segmentation_result)
  );
}

template <typename T, HandwritingFeatureQuery::EnableIfSame<T>*>
bool HandwritingFeatureQuery::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->languages, other_struct.languages))
    return false;
  if (!mojo::Equals(this->alternatives, other_struct.alternatives))
    return false;
  if (!mojo::Equals(this->segmentation_result, other_struct.segmentation_result))
    return false;
  return true;
}

template <typename T, HandwritingFeatureQuery::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.languages < rhs.languages)
    return true;
  if (rhs.languages < lhs.languages)
    return false;
  if (lhs.alternatives < rhs.alternatives)
    return true;
  if (rhs.alternatives < lhs.alternatives)
    return false;
  if (lhs.segmentation_result < rhs.segmentation_result)
    return true;
  if (rhs.segmentation_result < lhs.segmentation_result)
    return false;
  return false;
}
template <typename StructPtrType>
HandwritingFeatureQueryResultPtr HandwritingFeatureQueryResult::Clone() const {
  return New(
      mojo::Clone(languages),
      mojo::Clone(alternatives),
      mojo::Clone(segmentation_result)
  );
}

template <typename T, HandwritingFeatureQueryResult::EnableIfSame<T>*>
bool HandwritingFeatureQueryResult::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->languages, other_struct.languages))
    return false;
  if (!mojo::Equals(this->alternatives, other_struct.alternatives))
    return false;
  if (!mojo::Equals(this->segmentation_result, other_struct.segmentation_result))
    return false;
  return true;
}

template <typename T, HandwritingFeatureQueryResult::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.languages < rhs.languages)
    return true;
  if (rhs.languages < lhs.languages)
    return false;
  if (lhs.alternatives < rhs.alternatives)
    return true;
  if (rhs.alternatives < lhs.alternatives)
    return false;
  if (lhs.segmentation_result < rhs.segmentation_result)
    return true;
  if (rhs.segmentation_result < lhs.segmentation_result)
    return false;
  return false;
}
template <typename StructPtrType>
HandwritingModelConstraintPtr HandwritingModelConstraint::Clone() const {
  return New(
      mojo::Clone(languages)
  );
}

template <typename T, HandwritingModelConstraint::EnableIfSame<T>*>
bool HandwritingModelConstraint::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->languages, other_struct.languages))
    return false;
  return true;
}

template <typename T, HandwritingModelConstraint::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.languages < rhs.languages)
    return true;
  if (rhs.languages < lhs.languages)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace handwriting

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::handwriting::mojom::HandwritingPoint::DataView,
                                         ::handwriting::mojom::HandwritingPointPtr> {
  static bool IsNull(const ::handwriting::mojom::HandwritingPointPtr& input) { return !input; }
  static void SetToNull(::handwriting::mojom::HandwritingPointPtr* output) { output->reset(); }

  static const decltype(::handwriting::mojom::HandwritingPoint::location)& location(
      const ::handwriting::mojom::HandwritingPointPtr& input) {
    return input->location;
  }

  static const decltype(::handwriting::mojom::HandwritingPoint::t)& t(
      const ::handwriting::mojom::HandwritingPointPtr& input) {
    return input->t;
  }

  static bool Read(::handwriting::mojom::HandwritingPoint::DataView input, ::handwriting::mojom::HandwritingPointPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::handwriting::mojom::HandwritingStroke::DataView,
                                         ::handwriting::mojom::HandwritingStrokePtr> {
  static bool IsNull(const ::handwriting::mojom::HandwritingStrokePtr& input) { return !input; }
  static void SetToNull(::handwriting::mojom::HandwritingStrokePtr* output) { output->reset(); }

  static const decltype(::handwriting::mojom::HandwritingStroke::points)& points(
      const ::handwriting::mojom::HandwritingStrokePtr& input) {
    return input->points;
  }

  static bool Read(::handwriting::mojom::HandwritingStroke::DataView input, ::handwriting::mojom::HandwritingStrokePtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::handwriting::mojom::HandwritingDrawingSegment::DataView,
                                         ::handwriting::mojom::HandwritingDrawingSegmentPtr> {
  static bool IsNull(const ::handwriting::mojom::HandwritingDrawingSegmentPtr& input) { return !input; }
  static void SetToNull(::handwriting::mojom::HandwritingDrawingSegmentPtr* output) { output->reset(); }

  static decltype(::handwriting::mojom::HandwritingDrawingSegment::stroke_index) stroke_index(
      const ::handwriting::mojom::HandwritingDrawingSegmentPtr& input) {
    return input->stroke_index;
  }

  static decltype(::handwriting::mojom::HandwritingDrawingSegment::begin_point_index) begin_point_index(
      const ::handwriting::mojom::HandwritingDrawingSegmentPtr& input) {
    return input->begin_point_index;
  }

  static decltype(::handwriting::mojom::HandwritingDrawingSegment::end_point_index) end_point_index(
      const ::handwriting::mojom::HandwritingDrawingSegmentPtr& input) {
    return input->end_point_index;
  }

  static bool Read(::handwriting::mojom::HandwritingDrawingSegment::DataView input, ::handwriting::mojom::HandwritingDrawingSegmentPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::handwriting::mojom::HandwritingSegment::DataView,
                                         ::handwriting::mojom::HandwritingSegmentPtr> {
  static bool IsNull(const ::handwriting::mojom::HandwritingSegmentPtr& input) { return !input; }
  static void SetToNull(::handwriting::mojom::HandwritingSegmentPtr* output) { output->reset(); }

  static const decltype(::handwriting::mojom::HandwritingSegment::grapheme)& grapheme(
      const ::handwriting::mojom::HandwritingSegmentPtr& input) {
    return input->grapheme;
  }

  static decltype(::handwriting::mojom::HandwritingSegment::begin_index) begin_index(
      const ::handwriting::mojom::HandwritingSegmentPtr& input) {
    return input->begin_index;
  }

  static decltype(::handwriting::mojom::HandwritingSegment::end_index) end_index(
      const ::handwriting::mojom::HandwritingSegmentPtr& input) {
    return input->end_index;
  }

  static const decltype(::handwriting::mojom::HandwritingSegment::drawing_segments)& drawing_segments(
      const ::handwriting::mojom::HandwritingSegmentPtr& input) {
    return input->drawing_segments;
  }

  static bool Read(::handwriting::mojom::HandwritingSegment::DataView input, ::handwriting::mojom::HandwritingSegmentPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::handwriting::mojom::HandwritingPrediction::DataView,
                                         ::handwriting::mojom::HandwritingPredictionPtr> {
  static bool IsNull(const ::handwriting::mojom::HandwritingPredictionPtr& input) { return !input; }
  static void SetToNull(::handwriting::mojom::HandwritingPredictionPtr* output) { output->reset(); }

  static const decltype(::handwriting::mojom::HandwritingPrediction::text)& text(
      const ::handwriting::mojom::HandwritingPredictionPtr& input) {
    return input->text;
  }

  static const decltype(::handwriting::mojom::HandwritingPrediction::segmentation_result)& segmentation_result(
      const ::handwriting::mojom::HandwritingPredictionPtr& input) {
    return input->segmentation_result;
  }

  static bool Read(::handwriting::mojom::HandwritingPrediction::DataView input, ::handwriting::mojom::HandwritingPredictionPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::handwriting::mojom::HandwritingHints::DataView,
                                         ::handwriting::mojom::HandwritingHintsPtr> {
  static bool IsNull(const ::handwriting::mojom::HandwritingHintsPtr& input) { return !input; }
  static void SetToNull(::handwriting::mojom::HandwritingHintsPtr* output) { output->reset(); }

  static const decltype(::handwriting::mojom::HandwritingHints::recognition_type)& recognition_type(
      const ::handwriting::mojom::HandwritingHintsPtr& input) {
    return input->recognition_type;
  }

  static const decltype(::handwriting::mojom::HandwritingHints::input_type)& input_type(
      const ::handwriting::mojom::HandwritingHintsPtr& input) {
    return input->input_type;
  }

  static const decltype(::handwriting::mojom::HandwritingHints::text_context)& text_context(
      const ::handwriting::mojom::HandwritingHintsPtr& input) {
    return input->text_context;
  }

  static decltype(::handwriting::mojom::HandwritingHints::alternatives) alternatives(
      const ::handwriting::mojom::HandwritingHintsPtr& input) {
    return input->alternatives;
  }

  static bool Read(::handwriting::mojom::HandwritingHints::DataView input, ::handwriting::mojom::HandwritingHintsPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::handwriting::mojom::HandwritingFeatureQuery::DataView,
                                         ::handwriting::mojom::HandwritingFeatureQueryPtr> {
  static bool IsNull(const ::handwriting::mojom::HandwritingFeatureQueryPtr& input) { return !input; }
  static void SetToNull(::handwriting::mojom::HandwritingFeatureQueryPtr* output) { output->reset(); }

  static const decltype(::handwriting::mojom::HandwritingFeatureQuery::languages)& languages(
      const ::handwriting::mojom::HandwritingFeatureQueryPtr& input) {
    return input->languages;
  }

  static decltype(::handwriting::mojom::HandwritingFeatureQuery::alternatives) alternatives(
      const ::handwriting::mojom::HandwritingFeatureQueryPtr& input) {
    return input->alternatives;
  }

  static decltype(::handwriting::mojom::HandwritingFeatureQuery::segmentation_result) segmentation_result(
      const ::handwriting::mojom::HandwritingFeatureQueryPtr& input) {
    return input->segmentation_result;
  }

  static bool Read(::handwriting::mojom::HandwritingFeatureQuery::DataView input, ::handwriting::mojom::HandwritingFeatureQueryPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::handwriting::mojom::HandwritingFeatureQueryResult::DataView,
                                         ::handwriting::mojom::HandwritingFeatureQueryResultPtr> {
  static bool IsNull(const ::handwriting::mojom::HandwritingFeatureQueryResultPtr& input) { return !input; }
  static void SetToNull(::handwriting::mojom::HandwritingFeatureQueryResultPtr* output) { output->reset(); }

  static decltype(::handwriting::mojom::HandwritingFeatureQueryResult::languages) languages(
      const ::handwriting::mojom::HandwritingFeatureQueryResultPtr& input) {
    return input->languages;
  }

  static decltype(::handwriting::mojom::HandwritingFeatureQueryResult::alternatives) alternatives(
      const ::handwriting::mojom::HandwritingFeatureQueryResultPtr& input) {
    return input->alternatives;
  }

  static decltype(::handwriting::mojom::HandwritingFeatureQueryResult::segmentation_result) segmentation_result(
      const ::handwriting::mojom::HandwritingFeatureQueryResultPtr& input) {
    return input->segmentation_result;
  }

  static bool Read(::handwriting::mojom::HandwritingFeatureQueryResult::DataView input, ::handwriting::mojom::HandwritingFeatureQueryResultPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::handwriting::mojom::HandwritingModelConstraint::DataView,
                                         ::handwriting::mojom::HandwritingModelConstraintPtr> {
  static bool IsNull(const ::handwriting::mojom::HandwritingModelConstraintPtr& input) { return !input; }
  static void SetToNull(::handwriting::mojom::HandwritingModelConstraintPtr* output) { output->reset(); }

  static const decltype(::handwriting::mojom::HandwritingModelConstraint::languages)& languages(
      const ::handwriting::mojom::HandwritingModelConstraintPtr& input) {
    return input->languages;
  }

  static bool Read(::handwriting::mojom::HandwritingModelConstraint::DataView input, ::handwriting::mojom::HandwritingModelConstraintPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_HANDWRITING_HANDWRITING_MOJOM_H_