// third_party/blink/public/mojom/native_io/native_io.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_NATIVE_IO_NATIVE_IO_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_NATIVE_IO_NATIVE_IO_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/native_io/native_io.mojom-shared.h"
#include "third_party/blink/public/mojom/native_io/native_io.mojom-blink-forward.h"
#include "mojo/public/mojom/base/file.mojom-blink.h"
#include "mojo/public/mojom/base/file_error.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/renderer/platform/platform_export.h"




namespace WTF {
struct blink_mojom_internal_NativeIOErrorType_DataHashFn {
  static unsigned GetHash(const ::blink::mojom::NativeIOErrorType& value) {
    using utype = std::underlying_type<::blink::mojom::NativeIOErrorType>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::blink::mojom::NativeIOErrorType& left, const ::blink::mojom::NativeIOErrorType& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct HashTraits<::blink::mojom::NativeIOErrorType>
    : public GenericHashTraits<::blink::mojom::NativeIOErrorType> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::blink::mojom::NativeIOErrorType& value) {
    return value == static_cast<::blink::mojom::NativeIOErrorType>(-1000000);
  }
  static void ConstructDeletedValue(::blink::mojom::NativeIOErrorType& slot, bool) {
    slot = static_cast<::blink::mojom::NativeIOErrorType>(-1000001);
  }
  static bool IsDeletedValue(const ::blink::mojom::NativeIOErrorType& value) {
    return value == static_cast<::blink::mojom::NativeIOErrorType>(-1000001);
  }
};
}  // namespace WTF

// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace blink {
namespace mojom {
namespace blink {

class NativeIOFileHostProxy;

template <typename ImplRefTraits>
class NativeIOFileHostStub;

class NativeIOFileHostRequestValidator;
class NativeIOFileHostResponseValidator;


class PLATFORM_EXPORT NativeIOFileHost
    : public NativeIOFileHostInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = true;

  using Base_ = NativeIOFileHostInterfaceBase;
  using Proxy_ = NativeIOFileHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = NativeIOFileHostStub<ImplRefTraits>;

  using RequestValidator_ = NativeIOFileHostRequestValidator;
  using ResponseValidator_ = NativeIOFileHostResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCloseMinVersion = 0,
  };
  virtual ~NativeIOFileHost() {}

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool Close();

  using CloseCallback = base::OnceCallback<void()>;
  
  virtual void Close(CloseCallback callback) = 0;
};

class NativeIOHostProxy;

template <typename ImplRefTraits>
class NativeIOHostStub;

class NativeIOHostRequestValidator;
class NativeIOHostResponseValidator;


class PLATFORM_EXPORT NativeIOHost
    : public NativeIOHostInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = true;

  using Base_ = NativeIOHostInterfaceBase;
  using Proxy_ = NativeIOHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = NativeIOHostStub<ImplRefTraits>;

  using RequestValidator_ = NativeIOHostRequestValidator;
  using ResponseValidator_ = NativeIOHostResponseValidator;
  enum MethodMinVersions : uint32_t {
    kRequestCapacityChangeMinVersion = 0,
    kOpenFileMinVersion = 0,
    kDeleteFileMinVersion = 0,
    kGetAllFileNamesMinVersion = 0,
    kRenameFileMinVersion = 0,
  };
  virtual ~NativeIOHost() {}

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool RequestCapacityChange(int64_t capacity_delta, int64_t* out_granted_capacity_delta);

  using RequestCapacityChangeCallback = base::OnceCallback<void(int64_t)>;
  
  virtual void RequestCapacityChange(int64_t capacity_delta, RequestCapacityChangeCallback callback) = 0;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool OpenFile(const WTF::String& name, ::mojo::PendingReceiver<NativeIOFileHost> file_host_receiver, ::base::File* out_backing_file, uint64_t* out_backing_file_size, NativeIOErrorPtr* out_open_error);

  using OpenFileCallback = base::OnceCallback<void(::base::File, uint64_t, NativeIOErrorPtr)>;
  
  virtual void OpenFile(const WTF::String& name, ::mojo::PendingReceiver<NativeIOFileHost> file_host_receiver, OpenFileCallback callback) = 0;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool DeleteFile(const WTF::String& name, NativeIOErrorPtr* out_delete_error, uint64_t* out_granted_capacity_delta);

  using DeleteFileCallback = base::OnceCallback<void(NativeIOErrorPtr, uint64_t)>;
  
  virtual void DeleteFile(const WTF::String& name, DeleteFileCallback callback) = 0;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool GetAllFileNames(bool* out_success, WTF::Vector<WTF::String>* out_names);

  using GetAllFileNamesCallback = base::OnceCallback<void(bool, const WTF::Vector<WTF::String>&)>;
  
  virtual void GetAllFileNames(GetAllFileNamesCallback callback) = 0;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool RenameFile(const WTF::String& old_name, const WTF::String& new_name, NativeIOErrorPtr* out_rename_error);

  using RenameFileCallback = base::OnceCallback<void(NativeIOErrorPtr)>;
  
  virtual void RenameFile(const WTF::String& old_name, const WTF::String& new_name, RenameFileCallback callback) = 0;
};



class PLATFORM_EXPORT NativeIOFileHostProxy
    : public NativeIOFileHost {
 public:
  using InterfaceType = NativeIOFileHost;

  explicit NativeIOFileHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  bool Close() final;
  
  void Close(CloseCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class PLATFORM_EXPORT NativeIOHostProxy
    : public NativeIOHost {
 public:
  using InterfaceType = NativeIOHost;

  explicit NativeIOHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  bool RequestCapacityChange(int64_t capacity_delta, int64_t* out_granted_capacity_delta) final;
  
  void RequestCapacityChange(int64_t capacity_delta, RequestCapacityChangeCallback callback) final;
  
  bool OpenFile(const WTF::String& name, ::mojo::PendingReceiver<NativeIOFileHost> file_host_receiver, ::base::File* out_backing_file, uint64_t* out_backing_file_size, NativeIOErrorPtr* out_open_error) final;
  
  void OpenFile(const WTF::String& name, ::mojo::PendingReceiver<NativeIOFileHost> file_host_receiver, OpenFileCallback callback) final;
  
  bool DeleteFile(const WTF::String& name, NativeIOErrorPtr* out_delete_error, uint64_t* out_granted_capacity_delta) final;
  
  void DeleteFile(const WTF::String& name, DeleteFileCallback callback) final;
  
  bool GetAllFileNames(bool* out_success, WTF::Vector<WTF::String>* out_names) final;
  
  void GetAllFileNames(GetAllFileNamesCallback callback) final;
  
  bool RenameFile(const WTF::String& old_name, const WTF::String& new_name, NativeIOErrorPtr* out_rename_error) final;
  
  void RenameFile(const WTF::String& old_name, const WTF::String& new_name, RenameFileCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class PLATFORM_EXPORT NativeIOFileHostStubDispatch {
 public:
  static bool Accept(NativeIOFileHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      NativeIOFileHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<NativeIOFileHost>>
class NativeIOFileHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  NativeIOFileHostStub() {}
  ~NativeIOFileHostStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return NativeIOFileHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return NativeIOFileHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT NativeIOHostStubDispatch {
 public:
  static bool Accept(NativeIOHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      NativeIOHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<NativeIOHost>>
class NativeIOHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  NativeIOHostStub() {}
  ~NativeIOHostStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return NativeIOHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return NativeIOHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT NativeIOFileHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT NativeIOHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT NativeIOFileHostResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT NativeIOHostResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class PLATFORM_EXPORT NativeIOError {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<NativeIOError, T>::value>;
  using DataView = NativeIOErrorDataView;
  using Data_ = internal::NativeIOError_Data;

  template <typename... Args>
  static NativeIOErrorPtr New(Args&&... args) {
    return NativeIOErrorPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static NativeIOErrorPtr From(const U& u) {
    return mojo::TypeConverter<NativeIOErrorPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, NativeIOError>::Convert(*this);
  }


  NativeIOError();

  NativeIOError(
      NativeIOErrorType type,
      const WTF::String& message);

  ~NativeIOError();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = NativeIOErrorPtr>
  NativeIOErrorPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, NativeIOError::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, NativeIOError::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        NativeIOError::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        NativeIOError::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::NativeIOError_UnserializedMessageContext<
            UserType, NativeIOError::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<NativeIOError::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return NativeIOError::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::NativeIOError_UnserializedMessageContext<
            UserType, NativeIOError::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<NativeIOError::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  NativeIOErrorType type;
  
  WTF::String message;

  // Serialise this struct into a trace.
  void WriteIntoTracedValue(perfetto::TracedValue context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, NativeIOError::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, NativeIOError::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, NativeIOError::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, NativeIOError::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
NativeIOErrorPtr NativeIOError::Clone() const {
  return New(
      mojo::Clone(type),
      mojo::Clone(message)
  );
}

template <typename T, NativeIOError::EnableIfSame<T>*>
bool NativeIOError::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->message, other_struct.message))
    return false;
  return true;
}

template <typename T, NativeIOError::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.message < rhs.message)
    return true;
  if (rhs.message < lhs.message)
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::NativeIOError::DataView,
                                         ::blink::mojom::blink::NativeIOErrorPtr> {
  static bool IsNull(const ::blink::mojom::blink::NativeIOErrorPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::NativeIOErrorPtr* output) { output->reset(); }

  static decltype(::blink::mojom::blink::NativeIOError::type) type(
      const ::blink::mojom::blink::NativeIOErrorPtr& input) {
    return input->type;
  }

  static const decltype(::blink::mojom::blink::NativeIOError::message)& message(
      const ::blink::mojom::blink::NativeIOErrorPtr& input) {
    return input->message;
  }

  static bool Read(::blink::mojom::blink::NativeIOError::DataView input, ::blink::mojom::blink::NativeIOErrorPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_NATIVE_IO_NATIVE_IO_MOJOM_BLINK_H_