// third_party/blink/public/mojom/widget/screen_info.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "third_party/blink/public/mojom/widget/screen_info.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/common/task_annotator.h"
#include "base/trace_event/trace_conversion_helper.h"
#include "base/trace_event/traced_value.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "third_party/blink/public/mojom/widget/screen_info.mojom-params-data.h"
#include "third_party/blink/public/mojom/widget/screen_info.mojom-shared-message-ids.h"

#include "third_party/blink/public/mojom/widget/screen_info.mojom-import-headers.h"


#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WIDGET_SCREEN_INFO_MOJOM_JUMBO_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WIDGET_SCREEN_INFO_MOJOM_JUMBO_H_
#endif
namespace blink {
namespace mojom {
ScreenInfo::ScreenInfo()
    : device_scale_factor(1),
      display_color_spaces(),
      depth(),
      depth_per_component(),
      is_monochrome(false),
      display_frequency(),
      rect(),
      available_rect(),
      orientation_type(::blink::mojom::ScreenOrientation::kUndefined),
      orientation_angle(),
      is_extended() {}

ScreenInfo::ScreenInfo(
    float device_scale_factor_in,
    const ::gfx::DisplayColorSpaces& display_color_spaces_in,
    uint32_t depth_in,
    uint32_t depth_per_component_in,
    bool is_monochrome_in,
    uint32_t display_frequency_in,
    const ::gfx::Rect& rect_in,
    const ::gfx::Rect& available_rect_in,
    ::blink::mojom::ScreenOrientation orientation_type_in,
    uint16_t orientation_angle_in,
    bool is_extended_in)
    : device_scale_factor(std::move(device_scale_factor_in)),
      display_color_spaces(std::move(display_color_spaces_in)),
      depth(std::move(depth_in)),
      depth_per_component(std::move(depth_per_component_in)),
      is_monochrome(std::move(is_monochrome_in)),
      display_frequency(std::move(display_frequency_in)),
      rect(std::move(rect_in)),
      available_rect(std::move(available_rect_in)),
      orientation_type(std::move(orientation_type_in)),
      orientation_angle(std::move(orientation_angle_in)),
      is_extended(std::move(is_extended_in)) {}

ScreenInfo::~ScreenInfo() = default;

void ScreenInfo::WriteIntoTracedValue(perfetto::TracedValue context) const {
  auto dict = std::move(context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "device_scale_factor"), this->device_scale_factor, 
      "<value of type float>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "display_color_spaces"), this->display_color_spaces, 
      "<value of type const ::gfx::DisplayColorSpaces&>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "depth"), this->depth, 
      "<value of type uint32_t>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "depth_per_component"), this->depth_per_component, 
      "<value of type uint32_t>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "is_monochrome"), this->is_monochrome, 
      "<value of type bool>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "display_frequency"), this->display_frequency, 
      "<value of type uint32_t>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "rect"), this->rect, 
      "<value of type const ::gfx::Rect&>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "available_rect"), this->available_rect, 
      "<value of type const ::gfx::Rect&>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "orientation_type"), this->orientation_type, 
      "<value of type ::blink::mojom::ScreenOrientation>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "orientation_angle"), this->orientation_angle, 
      "<value of type uint16_t>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "is_extended"), this->is_extended, 
      "<value of type bool>");
}

bool ScreenInfo::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace blink

namespace mojo {


// static
bool StructTraits<::blink::mojom::ScreenInfo::DataView, ::blink::mojom::ScreenInfoPtr>::Read(
    ::blink::mojom::ScreenInfo::DataView input,
    ::blink::mojom::ScreenInfoPtr* output) {
  bool success = true;
  ::blink::mojom::ScreenInfoPtr result(::blink::mojom::ScreenInfo::New());
  
      if (success)
        result->device_scale_factor = input.device_scale_factor();
      if (success && !input.ReadDisplayColorSpaces(&result->display_color_spaces))
        success = false;
      if (success)
        result->depth = input.depth();
      if (success)
        result->depth_per_component = input.depth_per_component();
      if (success)
        result->is_monochrome = input.is_monochrome();
      if (success)
        result->display_frequency = input.display_frequency();
      if (success && !input.ReadRect(&result->rect))
        success = false;
      if (success && !input.ReadAvailableRect(&result->available_rect))
        success = false;
      if (success && !input.ReadOrientationType(&result->orientation_type))
        success = false;
      if (success)
        result->orientation_angle = input.orientation_angle();
      if (success)
        result->is_extended = input.is_extended();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif