// ui/accessibility/mojom/ax_assistant_structure.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_ACCESSIBILITY_MOJOM_AX_ASSISTANT_STRUCTURE_MOJOM_SHARED_H_
#define UI_ACCESSIBILITY_MOJOM_AX_ASSISTANT_STRUCTURE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"
#include "ui/accessibility/mojom/ax_assistant_structure.mojom-shared-internal.h"
#include "mojo/public/mojom/base/string16.mojom-shared.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-shared.h"
#include "ui/gfx/range/mojom/range.mojom-shared.h"
#include "url/mojom/url.mojom-shared.h"







namespace ax {
namespace mojom {
class AssistantTreeDataView;

class AssistantNodeDataView;

class AssistantExtraDataView;

class AssistantStructureDataView;



}  // namespace mojom
}  // namespace ax

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::ax::mojom::AssistantTreeDataView> {
  using Data = ::ax::mojom::internal::AssistantTree_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::ax::mojom::AssistantNodeDataView> {
  using Data = ::ax::mojom::internal::AssistantNode_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::ax::mojom::AssistantExtraDataView> {
  using Data = ::ax::mojom::internal::AssistantExtra_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::ax::mojom::AssistantStructureDataView> {
  using Data = ::ax::mojom::internal::AssistantStructure_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace ax {
namespace mojom {


class AssistantTreeDataView {
 public:
  AssistantTreeDataView() {}

  AssistantTreeDataView(
      internal::AssistantTree_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetNodesDataView(
      mojo::ArrayDataView<AssistantNodeDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadNodes(UserType* output) {
    
    auto* pointer = data_->nodes.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ax::mojom::AssistantNodeDataView>>(
        pointer, output, message_);
  }
 private:
  internal::AssistantTree_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



class AssistantNodeDataView {
 public:
  AssistantNodeDataView() {}

  AssistantNodeDataView(
      internal::AssistantNode_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetChildrenIndicesDataView(
      mojo::ArrayDataView<int32_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadChildrenIndices(UserType* output) {
    
    auto* pointer = data_->children_indices.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<int32_t>>(
        pointer, output, message_);
  }
  inline void GetRectDataView(
      ::gfx::mojom::RectDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRect(UserType* output) {
    
    auto* pointer = data_->rect.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RectDataView>(
        pointer, output, message_);
  }
  inline void GetTextDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadText(UserType* output) {
    
    auto* pointer = data_->text.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, message_);
  }
  float text_size() const {
    return data_->text_size;
  }
  uint32_t color() const {
    return data_->color;
  }
  uint32_t bgcolor() const {
    return data_->bgcolor;
  }
  bool bold() const {
    return data_->bold;
  }
  bool italic() const {
    return data_->italic;
  }
  bool underline() const {
    return data_->underline;
  }
  bool line_through() const {
    return data_->line_through;
  }
  inline void GetSelectionDataView(
      ::gfx::mojom::RangeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSelection(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::gfx::mojom::RangeDataView, UserType>(),
    "Attempting to read the optional `selection` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with base::Optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadSelection` instead "
    "of `ReadSelection if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->selection.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RangeDataView>(
        pointer, output, message_);
  }
  inline void GetClassNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadClassName(UserType* output) {
    
    auto* pointer = data_->class_name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetRoleDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRole(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        mojo::StringDataView, UserType>(),
    "Attempting to read the optional `role` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with base::Optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadRole` instead "
    "of `ReadRole if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->role.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
 private:
  internal::AssistantNode_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



class AssistantExtraDataView {
 public:
  AssistantExtraDataView() {}

  AssistantExtraDataView(
      internal::AssistantExtra_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, message_);
  }
  inline void GetBoundsPixelDataView(
      ::gfx::mojom::RectDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadBoundsPixel(UserType* output) {
    
    auto* pointer = data_->bounds_pixel.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RectDataView>(
        pointer, output, message_);
  }
  inline void GetTitleDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTitle(UserType* output) {
    
    auto* pointer = data_->title.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, message_);
  }
 private:
  internal::AssistantExtra_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



class AssistantStructureDataView {
 public:
  AssistantStructureDataView() {}

  AssistantStructureDataView(
      internal::AssistantStructure_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetAssistantTreeDataView(
      AssistantTreeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAssistantTree(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::ax::mojom::AssistantTreeDataView, UserType>(),
    "Attempting to read the optional `assistant_tree` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with base::Optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadAssistantTree` instead "
    "of `ReadAssistantTree if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->assistant_tree.Get();
    return mojo::internal::Deserialize<::ax::mojom::AssistantTreeDataView>(
        pointer, output, message_);
  }
  inline void GetAssistantExtraDataView(
      AssistantExtraDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAssistantExtra(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::ax::mojom::AssistantExtraDataView, UserType>(),
    "Attempting to read the optional `assistant_extra` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with base::Optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadAssistantExtra` instead "
    "of `ReadAssistantExtra if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->assistant_extra.Get();
    return mojo::internal::Deserialize<::ax::mojom::AssistantExtraDataView>(
        pointer, output, message_);
  }
 private:
  internal::AssistantStructure_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom
}  // namespace ax

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::ax::mojom::AssistantTreeDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::ax::mojom::AssistantTreeDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::ax::mojom::internal::AssistantTree_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::nodes(input)) in_nodes = Traits::nodes(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->nodes)::BaseType>
        nodes_fragment(fragment.message());
    const mojo::internal::ContainerValidateParams nodes_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::ax::mojom::AssistantNodeDataView>>(
        in_nodes, nodes_fragment, &nodes_validate_params);
    fragment->nodes.Set(
        nodes_fragment.is_null() ? nullptr : nodes_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->nodes.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null nodes in AssistantTree struct");
  }

  static bool Deserialize(::ax::mojom::internal::AssistantTree_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::ax::mojom::AssistantTreeDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::ax::mojom::AssistantNodeDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::ax::mojom::AssistantNodeDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::ax::mojom::internal::AssistantNode_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::children_indices(input)) in_children_indices = Traits::children_indices(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->children_indices)::BaseType>
        children_indices_fragment(fragment.message());
    const mojo::internal::ContainerValidateParams children_indices_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<int32_t>>(
        in_children_indices, children_indices_fragment, &children_indices_validate_params);
    fragment->children_indices.Set(
        children_indices_fragment.is_null() ? nullptr : children_indices_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->children_indices.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null children_indices in AssistantNode struct");
    decltype(Traits::rect(input)) in_rect = Traits::rect(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->rect)::BaseType> rect_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::RectDataView>(
        in_rect, rect_fragment);
    fragment->rect.Set(
        rect_fragment.is_null() ? nullptr : rect_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->rect.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null rect in AssistantNode struct");
    decltype(Traits::text(input)) in_text = Traits::text(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->text)::BaseType> text_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
        in_text, text_fragment);
    fragment->text.Set(
        text_fragment.is_null() ? nullptr : text_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->text.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null text in AssistantNode struct");
    fragment->text_size = Traits::text_size(input);
    fragment->color = Traits::color(input);
    fragment->bgcolor = Traits::bgcolor(input);
    fragment->bold = Traits::bold(input);
    fragment->italic = Traits::italic(input);
    fragment->underline = Traits::underline(input);
    fragment->line_through = Traits::line_through(input);
    decltype(Traits::selection(input)) in_selection = Traits::selection(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->selection)::BaseType> selection_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::RangeDataView>(
        in_selection, selection_fragment);
    fragment->selection.Set(
        selection_fragment.is_null() ? nullptr : selection_fragment.data());
    decltype(Traits::class_name(input)) in_class_name = Traits::class_name(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->class_name)::BaseType> class_name_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_class_name, class_name_fragment);
    fragment->class_name.Set(
        class_name_fragment.is_null() ? nullptr : class_name_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->class_name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null class_name in AssistantNode struct");
    decltype(Traits::role(input)) in_role = Traits::role(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->role)::BaseType> role_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_role, role_fragment);
    fragment->role.Set(
        role_fragment.is_null() ? nullptr : role_fragment.data());
  }

  static bool Deserialize(::ax::mojom::internal::AssistantNode_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::ax::mojom::AssistantNodeDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::ax::mojom::AssistantExtraDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::ax::mojom::AssistantExtraDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::ax::mojom::internal::AssistantExtra_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::url(input)) in_url = Traits::url(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->url)::BaseType> url_fragment(
            fragment.message());
    mojo::internal::Serialize<::url::mojom::UrlDataView>(
        in_url, url_fragment);
    fragment->url.Set(
        url_fragment.is_null() ? nullptr : url_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->url.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null url in AssistantExtra struct");
    decltype(Traits::bounds_pixel(input)) in_bounds_pixel = Traits::bounds_pixel(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->bounds_pixel)::BaseType> bounds_pixel_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::RectDataView>(
        in_bounds_pixel, bounds_pixel_fragment);
    fragment->bounds_pixel.Set(
        bounds_pixel_fragment.is_null() ? nullptr : bounds_pixel_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->bounds_pixel.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null bounds_pixel in AssistantExtra struct");
    decltype(Traits::title(input)) in_title = Traits::title(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->title)::BaseType> title_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
        in_title, title_fragment);
    fragment->title.Set(
        title_fragment.is_null() ? nullptr : title_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->title.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null title in AssistantExtra struct");
  }

  static bool Deserialize(::ax::mojom::internal::AssistantExtra_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::ax::mojom::AssistantExtraDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::ax::mojom::AssistantStructureDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::ax::mojom::AssistantStructureDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::ax::mojom::internal::AssistantStructure_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::assistant_tree(input)) in_assistant_tree = Traits::assistant_tree(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->assistant_tree)::BaseType> assistant_tree_fragment(
            fragment.message());
    mojo::internal::Serialize<::ax::mojom::AssistantTreeDataView>(
        in_assistant_tree, assistant_tree_fragment);
    fragment->assistant_tree.Set(
        assistant_tree_fragment.is_null() ? nullptr : assistant_tree_fragment.data());
    decltype(Traits::assistant_extra(input)) in_assistant_extra = Traits::assistant_extra(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->assistant_extra)::BaseType> assistant_extra_fragment(
            fragment.message());
    mojo::internal::Serialize<::ax::mojom::AssistantExtraDataView>(
        in_assistant_extra, assistant_extra_fragment);
    fragment->assistant_extra.Set(
        assistant_extra_fragment.is_null() ? nullptr : assistant_extra_fragment.data());
  }

  static bool Deserialize(::ax::mojom::internal::AssistantStructure_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::ax::mojom::AssistantStructureDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace ax {
namespace mojom {

inline void AssistantTreeDataView::GetNodesDataView(
    mojo::ArrayDataView<AssistantNodeDataView>* output) {
  auto pointer = data_->nodes.Get();
  *output = mojo::ArrayDataView<AssistantNodeDataView>(pointer, message_);
}


inline void AssistantNodeDataView::GetChildrenIndicesDataView(
    mojo::ArrayDataView<int32_t>* output) {
  auto pointer = data_->children_indices.Get();
  *output = mojo::ArrayDataView<int32_t>(pointer, message_);
}
inline void AssistantNodeDataView::GetRectDataView(
    ::gfx::mojom::RectDataView* output) {
  auto pointer = data_->rect.Get();
  *output = ::gfx::mojom::RectDataView(pointer, message_);
}
inline void AssistantNodeDataView::GetTextDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->text.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, message_);
}
inline void AssistantNodeDataView::GetSelectionDataView(
    ::gfx::mojom::RangeDataView* output) {
  auto pointer = data_->selection.Get();
  *output = ::gfx::mojom::RangeDataView(pointer, message_);
}
inline void AssistantNodeDataView::GetClassNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->class_name.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void AssistantNodeDataView::GetRoleDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->role.Get();
  *output = mojo::StringDataView(pointer, message_);
}


inline void AssistantExtraDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, message_);
}
inline void AssistantExtraDataView::GetBoundsPixelDataView(
    ::gfx::mojom::RectDataView* output) {
  auto pointer = data_->bounds_pixel.Get();
  *output = ::gfx::mojom::RectDataView(pointer, message_);
}
inline void AssistantExtraDataView::GetTitleDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->title.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, message_);
}


inline void AssistantStructureDataView::GetAssistantTreeDataView(
    AssistantTreeDataView* output) {
  auto pointer = data_->assistant_tree.Get();
  *output = AssistantTreeDataView(pointer, message_);
}
inline void AssistantStructureDataView::GetAssistantExtraDataView(
    AssistantExtraDataView* output) {
  auto pointer = data_->assistant_extra.Get();
  *output = AssistantExtraDataView(pointer, message_);
}



}  // namespace mojom
}  // namespace ax

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // UI_ACCESSIBILITY_MOJOM_AX_ASSISTANT_STRUCTURE_MOJOM_SHARED_H_