// ui/gfx/mojom/gpu_extra_info.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "ui/gfx/mojom/gpu_extra_info.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/common/task_annotator.h"
#include "base/trace_event/trace_conversion_helper.h"
#include "base/trace_event/traced_value.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "ui/gfx/mojom/gpu_extra_info.mojom-params-data.h"
#include "ui/gfx/mojom/gpu_extra_info.mojom-shared-message-ids.h"

#include "ui/gfx/mojom/gpu_extra_info.mojom-import-headers.h"


#ifndef UI_GFX_MOJOM_GPU_EXTRA_INFO_MOJOM_JUMBO_H_
#define UI_GFX_MOJOM_GPU_EXTRA_INFO_MOJOM_JUMBO_H_
#endif
namespace gfx {
namespace mojom {
ANGLEFeature::ANGLEFeature()
    : name(),
      category(),
      description(),
      bug(),
      status(),
      condition() {}

ANGLEFeature::ANGLEFeature(
    const std::string& name_in,
    const std::string& category_in,
    const std::string& description_in,
    const std::string& bug_in,
    const std::string& status_in,
    const std::string& condition_in)
    : name(std::move(name_in)),
      category(std::move(category_in)),
      description(std::move(description_in)),
      bug(std::move(bug_in)),
      status(std::move(status_in)),
      condition(std::move(condition_in)) {}

ANGLEFeature::~ANGLEFeature() = default;

void ANGLEFeature::WriteIntoTracedValue(perfetto::TracedValue context) const {
  auto dict = std::move(context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "name"), this->name, 
      "<value of type const std::string&>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "category"), this->category, 
      "<value of type const std::string&>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "description"), this->description, 
      "<value of type const std::string&>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "bug"), this->bug, 
      "<value of type const std::string&>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "status"), this->status, 
      "<value of type const std::string&>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "condition"), this->condition, 
      "<value of type const std::string&>");
}

bool ANGLEFeature::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
GpuExtraInfo::GpuExtraInfo()
    : angle_features(),
      system_visual(),
      rgba_visual(),
      gpu_memory_buffer_support_x11() {}

GpuExtraInfo::GpuExtraInfo(
    std::vector<::gfx::ANGLEFeature> angle_features_in,
    uint64_t system_visual_in,
    uint64_t rgba_visual_in,
    std::vector<::gfx::BufferUsageAndFormat> gpu_memory_buffer_support_x11_in)
    : angle_features(std::move(angle_features_in)),
      system_visual(std::move(system_visual_in)),
      rgba_visual(std::move(rgba_visual_in)),
      gpu_memory_buffer_support_x11(std::move(gpu_memory_buffer_support_x11_in)) {}

GpuExtraInfo::~GpuExtraInfo() = default;

void GpuExtraInfo::WriteIntoTracedValue(perfetto::TracedValue context) const {
  auto dict = std::move(context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "angle_features"), this->angle_features, 
      "<value of type const std::vector<::gfx::ANGLEFeature>&>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "system_visual"), this->system_visual, 
      "<value of type uint64_t>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "rgba_visual"), this->rgba_visual, 
      "<value of type uint64_t>");
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "gpu_memory_buffer_support_x11"), this->gpu_memory_buffer_support_x11, 
      "<value of type const std::vector<::gfx::BufferUsageAndFormat>&>");
}

bool GpuExtraInfo::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace gfx

namespace mojo {


// static
bool StructTraits<::gfx::mojom::ANGLEFeature::DataView, ::gfx::mojom::ANGLEFeaturePtr>::Read(
    ::gfx::mojom::ANGLEFeature::DataView input,
    ::gfx::mojom::ANGLEFeaturePtr* output) {
  bool success = true;
  ::gfx::mojom::ANGLEFeaturePtr result(::gfx::mojom::ANGLEFeature::New());
  
      if (success && !input.ReadName(&result->name))
        success = false;
      if (success && !input.ReadCategory(&result->category))
        success = false;
      if (success && !input.ReadDescription(&result->description))
        success = false;
      if (success && !input.ReadBug(&result->bug))
        success = false;
      if (success && !input.ReadStatus(&result->status))
        success = false;
      if (success && !input.ReadCondition(&result->condition))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::gfx::mojom::GpuExtraInfo::DataView, ::gfx::mojom::GpuExtraInfoPtr>::Read(
    ::gfx::mojom::GpuExtraInfo::DataView input,
    ::gfx::mojom::GpuExtraInfoPtr* output) {
  bool success = true;
  ::gfx::mojom::GpuExtraInfoPtr result(::gfx::mojom::GpuExtraInfo::New());
  
      if (success && !input.ReadAngleFeatures(&result->angle_features))
        success = false;
      if (success)
        result->system_visual = input.system_visual();
      if (success)
        result->rgba_visual = input.rgba_visual();
      if (success && !input.ReadGpuMemoryBufferSupportX11(&result->gpu_memory_buffer_support_x11))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif